

{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (inaki@blueleaf.cc)

/No description available in the introspection data./
-}

#define ENABLE_OVERLOADING (MIN_VERSION_haskell_gi_overloading(1,0,0) \
       && !defined(__HADDOCK_VERSION__))

module GI.Handy.Objects.Dialer
    ( 

-- * Exported types
    Dialer(..)                              ,
    IsDialer                                ,
    toDialer                                ,
    noDialer                                ,


 -- * Methods
-- ** clearNumber #method:clearNumber#

#if ENABLE_OVERLOADING
    DialerClearNumberMethodInfo             ,
#endif
    dialerClearNumber                       ,


-- ** getNumber #method:getNumber#

#if ENABLE_OVERLOADING
    DialerGetNumberMethodInfo               ,
#endif
    dialerGetNumber                         ,


-- ** getRelief #method:getRelief#

#if ENABLE_OVERLOADING
    DialerGetReliefMethodInfo               ,
#endif
    dialerGetRelief                         ,


-- ** getShowActionButtons #method:getShowActionButtons#

#if ENABLE_OVERLOADING
    DialerGetShowActionButtonsMethodInfo    ,
#endif
    dialerGetShowActionButtons              ,


-- ** new #method:new#

    dialerNew                               ,


-- ** setNumber #method:setNumber#

#if ENABLE_OVERLOADING
    DialerSetNumberMethodInfo               ,
#endif
    dialerSetNumber                         ,


-- ** setRelief #method:setRelief#

#if ENABLE_OVERLOADING
    DialerSetReliefMethodInfo               ,
#endif
    dialerSetRelief                         ,


-- ** setShowActionButtons #method:setShowActionButtons#

#if ENABLE_OVERLOADING
    DialerSetShowActionButtonsMethodInfo    ,
#endif
    dialerSetShowActionButtons              ,




 -- * Properties
-- ** columnSpacing #attr:columnSpacing#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DialerColumnSpacingPropertyInfo         ,
#endif
    constructDialerColumnSpacing            ,
#if ENABLE_OVERLOADING
    dialerColumnSpacing                     ,
#endif
    getDialerColumnSpacing                  ,
    setDialerColumnSpacing                  ,


-- ** number #attr:number#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DialerNumberPropertyInfo                ,
#endif
    constructDialerNumber                   ,
#if ENABLE_OVERLOADING
    dialerNumber                            ,
#endif
    getDialerNumber                         ,
    setDialerNumber                         ,


-- ** relief #attr:relief#
{- | The relief style of the edges of the main buttons.
-}
#if ENABLE_OVERLOADING
    DialerReliefPropertyInfo                ,
#endif
    constructDialerRelief                   ,
#if ENABLE_OVERLOADING
    dialerRelief                            ,
#endif
    getDialerRelief                         ,
    setDialerRelief                         ,


-- ** rowSpacing #attr:rowSpacing#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DialerRowSpacingPropertyInfo            ,
#endif
    constructDialerRowSpacing               ,
#if ENABLE_OVERLOADING
    dialerRowSpacing                        ,
#endif
    getDialerRowSpacing                     ,
    setDialerRowSpacing                     ,


-- ** showActionButtons #attr:showActionButtons#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DialerShowActionButtonsPropertyInfo     ,
#endif
    constructDialerShowActionButtons        ,
#if ENABLE_OVERLOADING
    dialerShowActionButtons                 ,
#endif
    getDialerShowActionButtons              ,
    setDialerShowActionButtons              ,




 -- * Signals
-- ** deleted #signal:deleted#

    C_DialerDeletedCallback                 ,
    DialerDeletedCallback                   ,
#if ENABLE_OVERLOADING
    DialerDeletedSignalInfo                 ,
#endif
    afterDialerDeleted                      ,
    genClosure_DialerDeleted                ,
    mk_DialerDeletedCallback                ,
    noDialerDeletedCallback                 ,
    onDialerDeleted                         ,
    wrap_DialerDeletedCallback              ,


-- ** submitted #signal:submitted#

    C_DialerSubmittedCallback               ,
    DialerSubmittedCallback                 ,
#if ENABLE_OVERLOADING
    DialerSubmittedSignalInfo               ,
#endif
    afterDialerSubmitted                    ,
    genClosure_DialerSubmitted              ,
    mk_DialerSubmittedCallback              ,
    noDialerSubmittedCallback               ,
    onDialerSubmitted                       ,
    wrap_DialerSubmittedCallback            ,


-- ** symbolClicked #signal:symbolClicked#

    C_DialerSymbolClickedCallback           ,
    DialerSymbolClickedCallback             ,
#if ENABLE_OVERLOADING
    DialerSymbolClickedSignalInfo           ,
#endif
    afterDialerSymbolClicked                ,
    genClosure_DialerSymbolClicked          ,
    mk_DialerSymbolClickedCallback          ,
    noDialerSymbolClickedCallback           ,
    onDialerSymbolClicked                   ,
    wrap_DialerSymbolClickedCallback        ,




    ) where

import Data.GI.Base.ShortPrelude
import qualified Data.GI.Base.ShortPrelude as SP
import qualified Data.GI.Base.Overloading as O
import qualified Prelude as P

import qualified Data.GI.Base.Attributes as GI.Attributes
import qualified Data.GI.Base.ManagedPtr as B.ManagedPtr
import qualified Data.GI.Base.GClosure as B.GClosure
import qualified Data.GI.Base.GError as B.GError
import qualified Data.GI.Base.GVariant as B.GVariant
import qualified Data.GI.Base.GValue as B.GValue
import qualified Data.GI.Base.GParamSpec as B.GParamSpec
import qualified Data.GI.Base.CallStack as B.CallStack
import qualified Data.GI.Base.Properties as B.Properties
import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map
import qualified Foreign.Ptr as FP
import qualified GHC.OverloadedLabels as OL

import qualified GI.Atk.Interfaces.ImplementorIface as Atk.ImplementorIface
import qualified GI.GObject.Objects.Object as GObject.Object
import qualified GI.Gtk.Enums as Gtk.Enums
import qualified GI.Gtk.Interfaces.Buildable as Gtk.Buildable
import qualified GI.Gtk.Objects.Bin as Gtk.Bin
import qualified GI.Gtk.Objects.Container as Gtk.Container
import qualified GI.Gtk.Objects.Widget as Gtk.Widget

-- | Memory-managed wrapper type.
newtype Dialer = Dialer (ManagedPtr Dialer)
foreign import ccall "hdy_dialer_get_type"
    c_hdy_dialer_get_type :: IO GType

instance GObject Dialer where
    gobjectType = c_hdy_dialer_get_type
    

-- | Type class for types which can be safely cast to `Dialer`, for instance with `toDialer`.
class (GObject o, O.IsDescendantOf Dialer o) => IsDialer o
instance (GObject o, O.IsDescendantOf Dialer o) => IsDialer o

instance O.HasParentTypes Dialer
type instance O.ParentTypes Dialer = '[Gtk.Bin.Bin, Gtk.Container.Container, Gtk.Widget.Widget, GObject.Object.Object, Atk.ImplementorIface.ImplementorIface, Gtk.Buildable.Buildable]

-- | Cast to `Dialer`, for types for which this is known to be safe. For general casts, use `Data.GI.Base.ManagedPtr.castTo`.
toDialer :: (MonadIO m, IsDialer o) => o -> m Dialer
toDialer = liftIO . unsafeCastTo Dialer

-- | A convenience alias for `Nothing` :: `Maybe` `Dialer`.
noDialer :: Maybe Dialer
noDialer = Nothing

#if ENABLE_OVERLOADING
type family ResolveDialerMethod (t :: Symbol) (o :: *) :: * where
    ResolveDialerMethod "activate" o = Gtk.Widget.WidgetActivateMethodInfo
    ResolveDialerMethod "add" o = Gtk.Container.ContainerAddMethodInfo
    ResolveDialerMethod "addAccelerator" o = Gtk.Widget.WidgetAddAcceleratorMethodInfo
    ResolveDialerMethod "addChild" o = Gtk.Buildable.BuildableAddChildMethodInfo
    ResolveDialerMethod "addDeviceEvents" o = Gtk.Widget.WidgetAddDeviceEventsMethodInfo
    ResolveDialerMethod "addEvents" o = Gtk.Widget.WidgetAddEventsMethodInfo
    ResolveDialerMethod "addMnemonicLabel" o = Gtk.Widget.WidgetAddMnemonicLabelMethodInfo
    ResolveDialerMethod "addTickCallback" o = Gtk.Widget.WidgetAddTickCallbackMethodInfo
    ResolveDialerMethod "bindProperty" o = GObject.Object.ObjectBindPropertyMethodInfo
    ResolveDialerMethod "bindPropertyFull" o = GObject.Object.ObjectBindPropertyFullMethodInfo
    ResolveDialerMethod "canActivateAccel" o = Gtk.Widget.WidgetCanActivateAccelMethodInfo
    ResolveDialerMethod "checkResize" o = Gtk.Container.ContainerCheckResizeMethodInfo
    ResolveDialerMethod "childFocus" o = Gtk.Widget.WidgetChildFocusMethodInfo
    ResolveDialerMethod "childGetProperty" o = Gtk.Container.ContainerChildGetPropertyMethodInfo
    ResolveDialerMethod "childNotify" o = Gtk.Container.ContainerChildNotifyMethodInfo
    ResolveDialerMethod "childNotifyByPspec" o = Gtk.Container.ContainerChildNotifyByPspecMethodInfo
    ResolveDialerMethod "childSetProperty" o = Gtk.Container.ContainerChildSetPropertyMethodInfo
    ResolveDialerMethod "childType" o = Gtk.Container.ContainerChildTypeMethodInfo
    ResolveDialerMethod "classPath" o = Gtk.Widget.WidgetClassPathMethodInfo
    ResolveDialerMethod "clearNumber" o = DialerClearNumberMethodInfo
    ResolveDialerMethod "computeExpand" o = Gtk.Widget.WidgetComputeExpandMethodInfo
    ResolveDialerMethod "constructChild" o = Gtk.Buildable.BuildableConstructChildMethodInfo
    ResolveDialerMethod "createPangoContext" o = Gtk.Widget.WidgetCreatePangoContextMethodInfo
    ResolveDialerMethod "createPangoLayout" o = Gtk.Widget.WidgetCreatePangoLayoutMethodInfo
    ResolveDialerMethod "customFinished" o = Gtk.Buildable.BuildableCustomFinishedMethodInfo
    ResolveDialerMethod "customTagEnd" o = Gtk.Buildable.BuildableCustomTagEndMethodInfo
    ResolveDialerMethod "customTagStart" o = Gtk.Buildable.BuildableCustomTagStartMethodInfo
    ResolveDialerMethod "destroy" o = Gtk.Widget.WidgetDestroyMethodInfo
    ResolveDialerMethod "destroyed" o = Gtk.Widget.WidgetDestroyedMethodInfo
    ResolveDialerMethod "deviceIsShadowed" o = Gtk.Widget.WidgetDeviceIsShadowedMethodInfo
    ResolveDialerMethod "dragBegin" o = Gtk.Widget.WidgetDragBeginMethodInfo
    ResolveDialerMethod "dragBeginWithCoordinates" o = Gtk.Widget.WidgetDragBeginWithCoordinatesMethodInfo
    ResolveDialerMethod "dragCheckThreshold" o = Gtk.Widget.WidgetDragCheckThresholdMethodInfo
    ResolveDialerMethod "dragDestAddImageTargets" o = Gtk.Widget.WidgetDragDestAddImageTargetsMethodInfo
    ResolveDialerMethod "dragDestAddTextTargets" o = Gtk.Widget.WidgetDragDestAddTextTargetsMethodInfo
    ResolveDialerMethod "dragDestAddUriTargets" o = Gtk.Widget.WidgetDragDestAddUriTargetsMethodInfo
    ResolveDialerMethod "dragDestFindTarget" o = Gtk.Widget.WidgetDragDestFindTargetMethodInfo
    ResolveDialerMethod "dragDestGetTargetList" o = Gtk.Widget.WidgetDragDestGetTargetListMethodInfo
    ResolveDialerMethod "dragDestGetTrackMotion" o = Gtk.Widget.WidgetDragDestGetTrackMotionMethodInfo
    ResolveDialerMethod "dragDestSet" o = Gtk.Widget.WidgetDragDestSetMethodInfo
    ResolveDialerMethod "dragDestSetProxy" o = Gtk.Widget.WidgetDragDestSetProxyMethodInfo
    ResolveDialerMethod "dragDestSetTargetList" o = Gtk.Widget.WidgetDragDestSetTargetListMethodInfo
    ResolveDialerMethod "dragDestSetTrackMotion" o = Gtk.Widget.WidgetDragDestSetTrackMotionMethodInfo
    ResolveDialerMethod "dragDestUnset" o = Gtk.Widget.WidgetDragDestUnsetMethodInfo
    ResolveDialerMethod "dragGetData" o = Gtk.Widget.WidgetDragGetDataMethodInfo
    ResolveDialerMethod "dragHighlight" o = Gtk.Widget.WidgetDragHighlightMethodInfo
    ResolveDialerMethod "dragSourceAddImageTargets" o = Gtk.Widget.WidgetDragSourceAddImageTargetsMethodInfo
    ResolveDialerMethod "dragSourceAddTextTargets" o = Gtk.Widget.WidgetDragSourceAddTextTargetsMethodInfo
    ResolveDialerMethod "dragSourceAddUriTargets" o = Gtk.Widget.WidgetDragSourceAddUriTargetsMethodInfo
    ResolveDialerMethod "dragSourceGetTargetList" o = Gtk.Widget.WidgetDragSourceGetTargetListMethodInfo
    ResolveDialerMethod "dragSourceSet" o = Gtk.Widget.WidgetDragSourceSetMethodInfo
    ResolveDialerMethod "dragSourceSetIconGicon" o = Gtk.Widget.WidgetDragSourceSetIconGiconMethodInfo
    ResolveDialerMethod "dragSourceSetIconName" o = Gtk.Widget.WidgetDragSourceSetIconNameMethodInfo
    ResolveDialerMethod "dragSourceSetIconPixbuf" o = Gtk.Widget.WidgetDragSourceSetIconPixbufMethodInfo
    ResolveDialerMethod "dragSourceSetIconStock" o = Gtk.Widget.WidgetDragSourceSetIconStockMethodInfo
    ResolveDialerMethod "dragSourceSetTargetList" o = Gtk.Widget.WidgetDragSourceSetTargetListMethodInfo
    ResolveDialerMethod "dragSourceUnset" o = Gtk.Widget.WidgetDragSourceUnsetMethodInfo
    ResolveDialerMethod "dragUnhighlight" o = Gtk.Widget.WidgetDragUnhighlightMethodInfo
    ResolveDialerMethod "draw" o = Gtk.Widget.WidgetDrawMethodInfo
    ResolveDialerMethod "ensureStyle" o = Gtk.Widget.WidgetEnsureStyleMethodInfo
    ResolveDialerMethod "errorBell" o = Gtk.Widget.WidgetErrorBellMethodInfo
    ResolveDialerMethod "event" o = Gtk.Widget.WidgetEventMethodInfo
    ResolveDialerMethod "forall" o = Gtk.Container.ContainerForallMethodInfo
    ResolveDialerMethod "forceFloating" o = GObject.Object.ObjectForceFloatingMethodInfo
    ResolveDialerMethod "foreach" o = Gtk.Container.ContainerForeachMethodInfo
    ResolveDialerMethod "freezeChildNotify" o = Gtk.Widget.WidgetFreezeChildNotifyMethodInfo
    ResolveDialerMethod "freezeNotify" o = GObject.Object.ObjectFreezeNotifyMethodInfo
    ResolveDialerMethod "getv" o = GObject.Object.ObjectGetvMethodInfo
    ResolveDialerMethod "grabAdd" o = Gtk.Widget.WidgetGrabAddMethodInfo
    ResolveDialerMethod "grabDefault" o = Gtk.Widget.WidgetGrabDefaultMethodInfo
    ResolveDialerMethod "grabFocus" o = Gtk.Widget.WidgetGrabFocusMethodInfo
    ResolveDialerMethod "grabRemove" o = Gtk.Widget.WidgetGrabRemoveMethodInfo
    ResolveDialerMethod "hasDefault" o = Gtk.Widget.WidgetHasDefaultMethodInfo
    ResolveDialerMethod "hasFocus" o = Gtk.Widget.WidgetHasFocusMethodInfo
    ResolveDialerMethod "hasGrab" o = Gtk.Widget.WidgetHasGrabMethodInfo
    ResolveDialerMethod "hasRcStyle" o = Gtk.Widget.WidgetHasRcStyleMethodInfo
    ResolveDialerMethod "hasScreen" o = Gtk.Widget.WidgetHasScreenMethodInfo
    ResolveDialerMethod "hasVisibleFocus" o = Gtk.Widget.WidgetHasVisibleFocusMethodInfo
    ResolveDialerMethod "hide" o = Gtk.Widget.WidgetHideMethodInfo
    ResolveDialerMethod "hideOnDelete" o = Gtk.Widget.WidgetHideOnDeleteMethodInfo
    ResolveDialerMethod "inDestruction" o = Gtk.Widget.WidgetInDestructionMethodInfo
    ResolveDialerMethod "initTemplate" o = Gtk.Widget.WidgetInitTemplateMethodInfo
    ResolveDialerMethod "inputShapeCombineRegion" o = Gtk.Widget.WidgetInputShapeCombineRegionMethodInfo
    ResolveDialerMethod "insertActionGroup" o = Gtk.Widget.WidgetInsertActionGroupMethodInfo
    ResolveDialerMethod "intersect" o = Gtk.Widget.WidgetIntersectMethodInfo
    ResolveDialerMethod "isAncestor" o = Gtk.Widget.WidgetIsAncestorMethodInfo
    ResolveDialerMethod "isComposited" o = Gtk.Widget.WidgetIsCompositedMethodInfo
    ResolveDialerMethod "isDrawable" o = Gtk.Widget.WidgetIsDrawableMethodInfo
    ResolveDialerMethod "isFloating" o = GObject.Object.ObjectIsFloatingMethodInfo
    ResolveDialerMethod "isFocus" o = Gtk.Widget.WidgetIsFocusMethodInfo
    ResolveDialerMethod "isSensitive" o = Gtk.Widget.WidgetIsSensitiveMethodInfo
    ResolveDialerMethod "isToplevel" o = Gtk.Widget.WidgetIsToplevelMethodInfo
    ResolveDialerMethod "isVisible" o = Gtk.Widget.WidgetIsVisibleMethodInfo
    ResolveDialerMethod "keynavFailed" o = Gtk.Widget.WidgetKeynavFailedMethodInfo
    ResolveDialerMethod "listAccelClosures" o = Gtk.Widget.WidgetListAccelClosuresMethodInfo
    ResolveDialerMethod "listActionPrefixes" o = Gtk.Widget.WidgetListActionPrefixesMethodInfo
    ResolveDialerMethod "listMnemonicLabels" o = Gtk.Widget.WidgetListMnemonicLabelsMethodInfo
    ResolveDialerMethod "map" o = Gtk.Widget.WidgetMapMethodInfo
    ResolveDialerMethod "mnemonicActivate" o = Gtk.Widget.WidgetMnemonicActivateMethodInfo
    ResolveDialerMethod "modifyBase" o = Gtk.Widget.WidgetModifyBaseMethodInfo
    ResolveDialerMethod "modifyBg" o = Gtk.Widget.WidgetModifyBgMethodInfo
    ResolveDialerMethod "modifyCursor" o = Gtk.Widget.WidgetModifyCursorMethodInfo
    ResolveDialerMethod "modifyFg" o = Gtk.Widget.WidgetModifyFgMethodInfo
    ResolveDialerMethod "modifyFont" o = Gtk.Widget.WidgetModifyFontMethodInfo
    ResolveDialerMethod "modifyStyle" o = Gtk.Widget.WidgetModifyStyleMethodInfo
    ResolveDialerMethod "modifyText" o = Gtk.Widget.WidgetModifyTextMethodInfo
    ResolveDialerMethod "notify" o = GObject.Object.ObjectNotifyMethodInfo
    ResolveDialerMethod "notifyByPspec" o = GObject.Object.ObjectNotifyByPspecMethodInfo
    ResolveDialerMethod "overrideBackgroundColor" o = Gtk.Widget.WidgetOverrideBackgroundColorMethodInfo
    ResolveDialerMethod "overrideColor" o = Gtk.Widget.WidgetOverrideColorMethodInfo
    ResolveDialerMethod "overrideCursor" o = Gtk.Widget.WidgetOverrideCursorMethodInfo
    ResolveDialerMethod "overrideFont" o = Gtk.Widget.WidgetOverrideFontMethodInfo
    ResolveDialerMethod "overrideSymbolicColor" o = Gtk.Widget.WidgetOverrideSymbolicColorMethodInfo
    ResolveDialerMethod "parserFinished" o = Gtk.Buildable.BuildableParserFinishedMethodInfo
    ResolveDialerMethod "path" o = Gtk.Widget.WidgetPathMethodInfo
    ResolveDialerMethod "propagateDraw" o = Gtk.Container.ContainerPropagateDrawMethodInfo
    ResolveDialerMethod "queueAllocate" o = Gtk.Widget.WidgetQueueAllocateMethodInfo
    ResolveDialerMethod "queueComputeExpand" o = Gtk.Widget.WidgetQueueComputeExpandMethodInfo
    ResolveDialerMethod "queueDraw" o = Gtk.Widget.WidgetQueueDrawMethodInfo
    ResolveDialerMethod "queueDrawArea" o = Gtk.Widget.WidgetQueueDrawAreaMethodInfo
    ResolveDialerMethod "queueDrawRegion" o = Gtk.Widget.WidgetQueueDrawRegionMethodInfo
    ResolveDialerMethod "queueResize" o = Gtk.Widget.WidgetQueueResizeMethodInfo
    ResolveDialerMethod "queueResizeNoRedraw" o = Gtk.Widget.WidgetQueueResizeNoRedrawMethodInfo
    ResolveDialerMethod "realize" o = Gtk.Widget.WidgetRealizeMethodInfo
    ResolveDialerMethod "ref" o = GObject.Object.ObjectRefMethodInfo
    ResolveDialerMethod "refSink" o = GObject.Object.ObjectRefSinkMethodInfo
    ResolveDialerMethod "regionIntersect" o = Gtk.Widget.WidgetRegionIntersectMethodInfo
    ResolveDialerMethod "registerWindow" o = Gtk.Widget.WidgetRegisterWindowMethodInfo
    ResolveDialerMethod "remove" o = Gtk.Container.ContainerRemoveMethodInfo
    ResolveDialerMethod "removeAccelerator" o = Gtk.Widget.WidgetRemoveAcceleratorMethodInfo
    ResolveDialerMethod "removeMnemonicLabel" o = Gtk.Widget.WidgetRemoveMnemonicLabelMethodInfo
    ResolveDialerMethod "removeTickCallback" o = Gtk.Widget.WidgetRemoveTickCallbackMethodInfo
    ResolveDialerMethod "renderIcon" o = Gtk.Widget.WidgetRenderIconMethodInfo
    ResolveDialerMethod "renderIconPixbuf" o = Gtk.Widget.WidgetRenderIconPixbufMethodInfo
    ResolveDialerMethod "reparent" o = Gtk.Widget.WidgetReparentMethodInfo
    ResolveDialerMethod "resetRcStyles" o = Gtk.Widget.WidgetResetRcStylesMethodInfo
    ResolveDialerMethod "resetStyle" o = Gtk.Widget.WidgetResetStyleMethodInfo
    ResolveDialerMethod "resizeChildren" o = Gtk.Container.ContainerResizeChildrenMethodInfo
    ResolveDialerMethod "runDispose" o = GObject.Object.ObjectRunDisposeMethodInfo
    ResolveDialerMethod "sendExpose" o = Gtk.Widget.WidgetSendExposeMethodInfo
    ResolveDialerMethod "sendFocusChange" o = Gtk.Widget.WidgetSendFocusChangeMethodInfo
    ResolveDialerMethod "shapeCombineRegion" o = Gtk.Widget.WidgetShapeCombineRegionMethodInfo
    ResolveDialerMethod "show" o = Gtk.Widget.WidgetShowMethodInfo
    ResolveDialerMethod "showAll" o = Gtk.Widget.WidgetShowAllMethodInfo
    ResolveDialerMethod "showNow" o = Gtk.Widget.WidgetShowNowMethodInfo
    ResolveDialerMethod "sizeAllocate" o = Gtk.Widget.WidgetSizeAllocateMethodInfo
    ResolveDialerMethod "sizeAllocateWithBaseline" o = Gtk.Widget.WidgetSizeAllocateWithBaselineMethodInfo
    ResolveDialerMethod "sizeRequest" o = Gtk.Widget.WidgetSizeRequestMethodInfo
    ResolveDialerMethod "stealData" o = GObject.Object.ObjectStealDataMethodInfo
    ResolveDialerMethod "stealQdata" o = GObject.Object.ObjectStealQdataMethodInfo
    ResolveDialerMethod "styleAttach" o = Gtk.Widget.WidgetStyleAttachMethodInfo
    ResolveDialerMethod "styleGetProperty" o = Gtk.Widget.WidgetStyleGetPropertyMethodInfo
    ResolveDialerMethod "thawChildNotify" o = Gtk.Widget.WidgetThawChildNotifyMethodInfo
    ResolveDialerMethod "thawNotify" o = GObject.Object.ObjectThawNotifyMethodInfo
    ResolveDialerMethod "translateCoordinates" o = Gtk.Widget.WidgetTranslateCoordinatesMethodInfo
    ResolveDialerMethod "triggerTooltipQuery" o = Gtk.Widget.WidgetTriggerTooltipQueryMethodInfo
    ResolveDialerMethod "unmap" o = Gtk.Widget.WidgetUnmapMethodInfo
    ResolveDialerMethod "unparent" o = Gtk.Widget.WidgetUnparentMethodInfo
    ResolveDialerMethod "unrealize" o = Gtk.Widget.WidgetUnrealizeMethodInfo
    ResolveDialerMethod "unref" o = GObject.Object.ObjectUnrefMethodInfo
    ResolveDialerMethod "unregisterWindow" o = Gtk.Widget.WidgetUnregisterWindowMethodInfo
    ResolveDialerMethod "unsetFocusChain" o = Gtk.Container.ContainerUnsetFocusChainMethodInfo
    ResolveDialerMethod "unsetStateFlags" o = Gtk.Widget.WidgetUnsetStateFlagsMethodInfo
    ResolveDialerMethod "watchClosure" o = GObject.Object.ObjectWatchClosureMethodInfo
    ResolveDialerMethod "getAccessible" o = Gtk.Widget.WidgetGetAccessibleMethodInfo
    ResolveDialerMethod "getActionGroup" o = Gtk.Widget.WidgetGetActionGroupMethodInfo
    ResolveDialerMethod "getAllocatedBaseline" o = Gtk.Widget.WidgetGetAllocatedBaselineMethodInfo
    ResolveDialerMethod "getAllocatedHeight" o = Gtk.Widget.WidgetGetAllocatedHeightMethodInfo
    ResolveDialerMethod "getAllocatedSize" o = Gtk.Widget.WidgetGetAllocatedSizeMethodInfo
    ResolveDialerMethod "getAllocatedWidth" o = Gtk.Widget.WidgetGetAllocatedWidthMethodInfo
    ResolveDialerMethod "getAllocation" o = Gtk.Widget.WidgetGetAllocationMethodInfo
    ResolveDialerMethod "getAncestor" o = Gtk.Widget.WidgetGetAncestorMethodInfo
    ResolveDialerMethod "getAppPaintable" o = Gtk.Widget.WidgetGetAppPaintableMethodInfo
    ResolveDialerMethod "getBorderWidth" o = Gtk.Container.ContainerGetBorderWidthMethodInfo
    ResolveDialerMethod "getCanDefault" o = Gtk.Widget.WidgetGetCanDefaultMethodInfo
    ResolveDialerMethod "getCanFocus" o = Gtk.Widget.WidgetGetCanFocusMethodInfo
    ResolveDialerMethod "getChild" o = Gtk.Bin.BinGetChildMethodInfo
    ResolveDialerMethod "getChildRequisition" o = Gtk.Widget.WidgetGetChildRequisitionMethodInfo
    ResolveDialerMethod "getChildVisible" o = Gtk.Widget.WidgetGetChildVisibleMethodInfo
    ResolveDialerMethod "getChildren" o = Gtk.Container.ContainerGetChildrenMethodInfo
    ResolveDialerMethod "getClip" o = Gtk.Widget.WidgetGetClipMethodInfo
    ResolveDialerMethod "getClipboard" o = Gtk.Widget.WidgetGetClipboardMethodInfo
    ResolveDialerMethod "getCompositeName" o = Gtk.Widget.WidgetGetCompositeNameMethodInfo
    ResolveDialerMethod "getData" o = GObject.Object.ObjectGetDataMethodInfo
    ResolveDialerMethod "getDeviceEnabled" o = Gtk.Widget.WidgetGetDeviceEnabledMethodInfo
    ResolveDialerMethod "getDeviceEvents" o = Gtk.Widget.WidgetGetDeviceEventsMethodInfo
    ResolveDialerMethod "getDirection" o = Gtk.Widget.WidgetGetDirectionMethodInfo
    ResolveDialerMethod "getDisplay" o = Gtk.Widget.WidgetGetDisplayMethodInfo
    ResolveDialerMethod "getDoubleBuffered" o = Gtk.Widget.WidgetGetDoubleBufferedMethodInfo
    ResolveDialerMethod "getEvents" o = Gtk.Widget.WidgetGetEventsMethodInfo
    ResolveDialerMethod "getFocusChain" o = Gtk.Container.ContainerGetFocusChainMethodInfo
    ResolveDialerMethod "getFocusChild" o = Gtk.Container.ContainerGetFocusChildMethodInfo
    ResolveDialerMethod "getFocusHadjustment" o = Gtk.Container.ContainerGetFocusHadjustmentMethodInfo
    ResolveDialerMethod "getFocusOnClick" o = Gtk.Widget.WidgetGetFocusOnClickMethodInfo
    ResolveDialerMethod "getFocusVadjustment" o = Gtk.Container.ContainerGetFocusVadjustmentMethodInfo
    ResolveDialerMethod "getFontMap" o = Gtk.Widget.WidgetGetFontMapMethodInfo
    ResolveDialerMethod "getFontOptions" o = Gtk.Widget.WidgetGetFontOptionsMethodInfo
    ResolveDialerMethod "getFrameClock" o = Gtk.Widget.WidgetGetFrameClockMethodInfo
    ResolveDialerMethod "getHalign" o = Gtk.Widget.WidgetGetHalignMethodInfo
    ResolveDialerMethod "getHasTooltip" o = Gtk.Widget.WidgetGetHasTooltipMethodInfo
    ResolveDialerMethod "getHasWindow" o = Gtk.Widget.WidgetGetHasWindowMethodInfo
    ResolveDialerMethod "getHexpand" o = Gtk.Widget.WidgetGetHexpandMethodInfo
    ResolveDialerMethod "getHexpandSet" o = Gtk.Widget.WidgetGetHexpandSetMethodInfo
    ResolveDialerMethod "getInternalChild" o = Gtk.Buildable.BuildableGetInternalChildMethodInfo
    ResolveDialerMethod "getMapped" o = Gtk.Widget.WidgetGetMappedMethodInfo
    ResolveDialerMethod "getMarginBottom" o = Gtk.Widget.WidgetGetMarginBottomMethodInfo
    ResolveDialerMethod "getMarginEnd" o = Gtk.Widget.WidgetGetMarginEndMethodInfo
    ResolveDialerMethod "getMarginLeft" o = Gtk.Widget.WidgetGetMarginLeftMethodInfo
    ResolveDialerMethod "getMarginRight" o = Gtk.Widget.WidgetGetMarginRightMethodInfo
    ResolveDialerMethod "getMarginStart" o = Gtk.Widget.WidgetGetMarginStartMethodInfo
    ResolveDialerMethod "getMarginTop" o = Gtk.Widget.WidgetGetMarginTopMethodInfo
    ResolveDialerMethod "getModifierMask" o = Gtk.Widget.WidgetGetModifierMaskMethodInfo
    ResolveDialerMethod "getModifierStyle" o = Gtk.Widget.WidgetGetModifierStyleMethodInfo
    ResolveDialerMethod "getName" o = Gtk.Widget.WidgetGetNameMethodInfo
    ResolveDialerMethod "getNoShowAll" o = Gtk.Widget.WidgetGetNoShowAllMethodInfo
    ResolveDialerMethod "getNumber" o = DialerGetNumberMethodInfo
    ResolveDialerMethod "getOpacity" o = Gtk.Widget.WidgetGetOpacityMethodInfo
    ResolveDialerMethod "getPangoContext" o = Gtk.Widget.WidgetGetPangoContextMethodInfo
    ResolveDialerMethod "getParent" o = Gtk.Widget.WidgetGetParentMethodInfo
    ResolveDialerMethod "getParentWindow" o = Gtk.Widget.WidgetGetParentWindowMethodInfo
    ResolveDialerMethod "getPath" o = Gtk.Widget.WidgetGetPathMethodInfo
    ResolveDialerMethod "getPathForChild" o = Gtk.Container.ContainerGetPathForChildMethodInfo
    ResolveDialerMethod "getPointer" o = Gtk.Widget.WidgetGetPointerMethodInfo
    ResolveDialerMethod "getPreferredHeight" o = Gtk.Widget.WidgetGetPreferredHeightMethodInfo
    ResolveDialerMethod "getPreferredHeightAndBaselineForWidth" o = Gtk.Widget.WidgetGetPreferredHeightAndBaselineForWidthMethodInfo
    ResolveDialerMethod "getPreferredHeightForWidth" o = Gtk.Widget.WidgetGetPreferredHeightForWidthMethodInfo
    ResolveDialerMethod "getPreferredSize" o = Gtk.Widget.WidgetGetPreferredSizeMethodInfo
    ResolveDialerMethod "getPreferredWidth" o = Gtk.Widget.WidgetGetPreferredWidthMethodInfo
    ResolveDialerMethod "getPreferredWidthForHeight" o = Gtk.Widget.WidgetGetPreferredWidthForHeightMethodInfo
    ResolveDialerMethod "getProperty" o = GObject.Object.ObjectGetPropertyMethodInfo
    ResolveDialerMethod "getQdata" o = GObject.Object.ObjectGetQdataMethodInfo
    ResolveDialerMethod "getRealized" o = Gtk.Widget.WidgetGetRealizedMethodInfo
    ResolveDialerMethod "getReceivesDefault" o = Gtk.Widget.WidgetGetReceivesDefaultMethodInfo
    ResolveDialerMethod "getRelief" o = DialerGetReliefMethodInfo
    ResolveDialerMethod "getRequestMode" o = Gtk.Widget.WidgetGetRequestModeMethodInfo
    ResolveDialerMethod "getRequisition" o = Gtk.Widget.WidgetGetRequisitionMethodInfo
    ResolveDialerMethod "getResizeMode" o = Gtk.Container.ContainerGetResizeModeMethodInfo
    ResolveDialerMethod "getRootWindow" o = Gtk.Widget.WidgetGetRootWindowMethodInfo
    ResolveDialerMethod "getScaleFactor" o = Gtk.Widget.WidgetGetScaleFactorMethodInfo
    ResolveDialerMethod "getScreen" o = Gtk.Widget.WidgetGetScreenMethodInfo
    ResolveDialerMethod "getSensitive" o = Gtk.Widget.WidgetGetSensitiveMethodInfo
    ResolveDialerMethod "getSettings" o = Gtk.Widget.WidgetGetSettingsMethodInfo
    ResolveDialerMethod "getShowActionButtons" o = DialerGetShowActionButtonsMethodInfo
    ResolveDialerMethod "getSizeRequest" o = Gtk.Widget.WidgetGetSizeRequestMethodInfo
    ResolveDialerMethod "getState" o = Gtk.Widget.WidgetGetStateMethodInfo
    ResolveDialerMethod "getStateFlags" o = Gtk.Widget.WidgetGetStateFlagsMethodInfo
    ResolveDialerMethod "getStyle" o = Gtk.Widget.WidgetGetStyleMethodInfo
    ResolveDialerMethod "getStyleContext" o = Gtk.Widget.WidgetGetStyleContextMethodInfo
    ResolveDialerMethod "getSupportMultidevice" o = Gtk.Widget.WidgetGetSupportMultideviceMethodInfo
    ResolveDialerMethod "getTemplateChild" o = Gtk.Widget.WidgetGetTemplateChildMethodInfo
    ResolveDialerMethod "getTooltipMarkup" o = Gtk.Widget.WidgetGetTooltipMarkupMethodInfo
    ResolveDialerMethod "getTooltipText" o = Gtk.Widget.WidgetGetTooltipTextMethodInfo
    ResolveDialerMethod "getTooltipWindow" o = Gtk.Widget.WidgetGetTooltipWindowMethodInfo
    ResolveDialerMethod "getToplevel" o = Gtk.Widget.WidgetGetToplevelMethodInfo
    ResolveDialerMethod "getValign" o = Gtk.Widget.WidgetGetValignMethodInfo
    ResolveDialerMethod "getValignWithBaseline" o = Gtk.Widget.WidgetGetValignWithBaselineMethodInfo
    ResolveDialerMethod "getVexpand" o = Gtk.Widget.WidgetGetVexpandMethodInfo
    ResolveDialerMethod "getVexpandSet" o = Gtk.Widget.WidgetGetVexpandSetMethodInfo
    ResolveDialerMethod "getVisible" o = Gtk.Widget.WidgetGetVisibleMethodInfo
    ResolveDialerMethod "getVisual" o = Gtk.Widget.WidgetGetVisualMethodInfo
    ResolveDialerMethod "getWindow" o = Gtk.Widget.WidgetGetWindowMethodInfo
    ResolveDialerMethod "setAccelPath" o = Gtk.Widget.WidgetSetAccelPathMethodInfo
    ResolveDialerMethod "setAllocation" o = Gtk.Widget.WidgetSetAllocationMethodInfo
    ResolveDialerMethod "setAppPaintable" o = Gtk.Widget.WidgetSetAppPaintableMethodInfo
    ResolveDialerMethod "setBorderWidth" o = Gtk.Container.ContainerSetBorderWidthMethodInfo
    ResolveDialerMethod "setBuildableProperty" o = Gtk.Buildable.BuildableSetBuildablePropertyMethodInfo
    ResolveDialerMethod "setCanDefault" o = Gtk.Widget.WidgetSetCanDefaultMethodInfo
    ResolveDialerMethod "setCanFocus" o = Gtk.Widget.WidgetSetCanFocusMethodInfo
    ResolveDialerMethod "setChildVisible" o = Gtk.Widget.WidgetSetChildVisibleMethodInfo
    ResolveDialerMethod "setClip" o = Gtk.Widget.WidgetSetClipMethodInfo
    ResolveDialerMethod "setCompositeName" o = Gtk.Widget.WidgetSetCompositeNameMethodInfo
    ResolveDialerMethod "setData" o = GObject.Object.ObjectSetDataMethodInfo
    ResolveDialerMethod "setDeviceEnabled" o = Gtk.Widget.WidgetSetDeviceEnabledMethodInfo
    ResolveDialerMethod "setDeviceEvents" o = Gtk.Widget.WidgetSetDeviceEventsMethodInfo
    ResolveDialerMethod "setDirection" o = Gtk.Widget.WidgetSetDirectionMethodInfo
    ResolveDialerMethod "setDoubleBuffered" o = Gtk.Widget.WidgetSetDoubleBufferedMethodInfo
    ResolveDialerMethod "setEvents" o = Gtk.Widget.WidgetSetEventsMethodInfo
    ResolveDialerMethod "setFocusChain" o = Gtk.Container.ContainerSetFocusChainMethodInfo
    ResolveDialerMethod "setFocusChild" o = Gtk.Container.ContainerSetFocusChildMethodInfo
    ResolveDialerMethod "setFocusHadjustment" o = Gtk.Container.ContainerSetFocusHadjustmentMethodInfo
    ResolveDialerMethod "setFocusOnClick" o = Gtk.Widget.WidgetSetFocusOnClickMethodInfo
    ResolveDialerMethod "setFocusVadjustment" o = Gtk.Container.ContainerSetFocusVadjustmentMethodInfo
    ResolveDialerMethod "setFontMap" o = Gtk.Widget.WidgetSetFontMapMethodInfo
    ResolveDialerMethod "setFontOptions" o = Gtk.Widget.WidgetSetFontOptionsMethodInfo
    ResolveDialerMethod "setHalign" o = Gtk.Widget.WidgetSetHalignMethodInfo
    ResolveDialerMethod "setHasTooltip" o = Gtk.Widget.WidgetSetHasTooltipMethodInfo
    ResolveDialerMethod "setHasWindow" o = Gtk.Widget.WidgetSetHasWindowMethodInfo
    ResolveDialerMethod "setHexpand" o = Gtk.Widget.WidgetSetHexpandMethodInfo
    ResolveDialerMethod "setHexpandSet" o = Gtk.Widget.WidgetSetHexpandSetMethodInfo
    ResolveDialerMethod "setMapped" o = Gtk.Widget.WidgetSetMappedMethodInfo
    ResolveDialerMethod "setMarginBottom" o = Gtk.Widget.WidgetSetMarginBottomMethodInfo
    ResolveDialerMethod "setMarginEnd" o = Gtk.Widget.WidgetSetMarginEndMethodInfo
    ResolveDialerMethod "setMarginLeft" o = Gtk.Widget.WidgetSetMarginLeftMethodInfo
    ResolveDialerMethod "setMarginRight" o = Gtk.Widget.WidgetSetMarginRightMethodInfo
    ResolveDialerMethod "setMarginStart" o = Gtk.Widget.WidgetSetMarginStartMethodInfo
    ResolveDialerMethod "setMarginTop" o = Gtk.Widget.WidgetSetMarginTopMethodInfo
    ResolveDialerMethod "setName" o = Gtk.Widget.WidgetSetNameMethodInfo
    ResolveDialerMethod "setNoShowAll" o = Gtk.Widget.WidgetSetNoShowAllMethodInfo
    ResolveDialerMethod "setNumber" o = DialerSetNumberMethodInfo
    ResolveDialerMethod "setOpacity" o = Gtk.Widget.WidgetSetOpacityMethodInfo
    ResolveDialerMethod "setParent" o = Gtk.Widget.WidgetSetParentMethodInfo
    ResolveDialerMethod "setParentWindow" o = Gtk.Widget.WidgetSetParentWindowMethodInfo
    ResolveDialerMethod "setProperty" o = GObject.Object.ObjectSetPropertyMethodInfo
    ResolveDialerMethod "setRealized" o = Gtk.Widget.WidgetSetRealizedMethodInfo
    ResolveDialerMethod "setReallocateRedraws" o = Gtk.Container.ContainerSetReallocateRedrawsMethodInfo
    ResolveDialerMethod "setReceivesDefault" o = Gtk.Widget.WidgetSetReceivesDefaultMethodInfo
    ResolveDialerMethod "setRedrawOnAllocate" o = Gtk.Widget.WidgetSetRedrawOnAllocateMethodInfo
    ResolveDialerMethod "setRelief" o = DialerSetReliefMethodInfo
    ResolveDialerMethod "setResizeMode" o = Gtk.Container.ContainerSetResizeModeMethodInfo
    ResolveDialerMethod "setSensitive" o = Gtk.Widget.WidgetSetSensitiveMethodInfo
    ResolveDialerMethod "setShowActionButtons" o = DialerSetShowActionButtonsMethodInfo
    ResolveDialerMethod "setSizeRequest" o = Gtk.Widget.WidgetSetSizeRequestMethodInfo
    ResolveDialerMethod "setState" o = Gtk.Widget.WidgetSetStateMethodInfo
    ResolveDialerMethod "setStateFlags" o = Gtk.Widget.WidgetSetStateFlagsMethodInfo
    ResolveDialerMethod "setStyle" o = Gtk.Widget.WidgetSetStyleMethodInfo
    ResolveDialerMethod "setSupportMultidevice" o = Gtk.Widget.WidgetSetSupportMultideviceMethodInfo
    ResolveDialerMethod "setTooltipMarkup" o = Gtk.Widget.WidgetSetTooltipMarkupMethodInfo
    ResolveDialerMethod "setTooltipText" o = Gtk.Widget.WidgetSetTooltipTextMethodInfo
    ResolveDialerMethod "setTooltipWindow" o = Gtk.Widget.WidgetSetTooltipWindowMethodInfo
    ResolveDialerMethod "setValign" o = Gtk.Widget.WidgetSetValignMethodInfo
    ResolveDialerMethod "setVexpand" o = Gtk.Widget.WidgetSetVexpandMethodInfo
    ResolveDialerMethod "setVexpandSet" o = Gtk.Widget.WidgetSetVexpandSetMethodInfo
    ResolveDialerMethod "setVisible" o = Gtk.Widget.WidgetSetVisibleMethodInfo
    ResolveDialerMethod "setVisual" o = Gtk.Widget.WidgetSetVisualMethodInfo
    ResolveDialerMethod "setWindow" o = Gtk.Widget.WidgetSetWindowMethodInfo
    ResolveDialerMethod l o = O.MethodResolutionFailed l o

instance (info ~ ResolveDialerMethod t Dialer, O.MethodInfo info Dialer p) => OL.IsLabel t (Dialer -> p) where
#if MIN_VERSION_base(4,10,0)
    fromLabel = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#else
    fromLabel _ = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#endif

#endif

-- signal Dialer::deleted
{- |
This signal is emitted when the dialer\'s \'deleted\' button is clicked
to delete the last symbol.
-}
type DialerDeletedCallback =
    IO ()

-- | A convenience synonym for @`Nothing` :: `Maybe` `DialerDeletedCallback`@.
noDialerDeletedCallback :: Maybe DialerDeletedCallback
noDialerDeletedCallback = Nothing

-- | Type for the callback on the (unwrapped) C side.
type C_DialerDeletedCallback =
    Ptr () ->                               -- object
    Ptr () ->                               -- user_data
    IO ()

-- | Generate a function pointer callable from C code, from a `C_DialerDeletedCallback`.
foreign import ccall "wrapper"
    mk_DialerDeletedCallback :: C_DialerDeletedCallback -> IO (FunPtr C_DialerDeletedCallback)

-- | Wrap the callback into a `GClosure`.
genClosure_DialerDeleted :: MonadIO m => DialerDeletedCallback -> m (GClosure C_DialerDeletedCallback)
genClosure_DialerDeleted cb = liftIO $ do
    let cb' = wrap_DialerDeletedCallback cb
    mk_DialerDeletedCallback cb' >>= B.GClosure.newGClosure


-- | Wrap a `DialerDeletedCallback` into a `C_DialerDeletedCallback`.
wrap_DialerDeletedCallback ::
    DialerDeletedCallback ->
    C_DialerDeletedCallback
wrap_DialerDeletedCallback _cb _ _ = do
    _cb 


{- |
Connect a signal handler for the “@deleted@” signal, to be run before the default handler.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Signals.on' dialer #deleted callback
@
-}
onDialerDeleted :: (IsDialer a, MonadIO m) => a -> DialerDeletedCallback -> m SignalHandlerId
onDialerDeleted obj cb = liftIO $ do
    let cb' = wrap_DialerDeletedCallback cb
    cb'' <- mk_DialerDeletedCallback cb'
    connectSignalFunPtr obj "deleted" cb'' SignalConnectBefore

{- |
Connect a signal handler for the “@deleted@” signal, to be run after the default handler.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Signals.after' dialer #deleted callback
@
-}
afterDialerDeleted :: (IsDialer a, MonadIO m) => a -> DialerDeletedCallback -> m SignalHandlerId
afterDialerDeleted obj cb = liftIO $ do
    let cb' = wrap_DialerDeletedCallback cb
    cb'' <- mk_DialerDeletedCallback cb'
    connectSignalFunPtr obj "deleted" cb'' SignalConnectAfter


-- signal Dialer::submitted
{- |
This signal is emitted when the dialer\'s \'dial\' button is activated.
Connect to this signal to perform to get notified when the user
wants to submit the dialed number.
-}
type DialerSubmittedCallback =
    T.Text
    {- ^ /@number@/: The number at the time of activation. -}
    -> IO ()

-- | A convenience synonym for @`Nothing` :: `Maybe` `DialerSubmittedCallback`@.
noDialerSubmittedCallback :: Maybe DialerSubmittedCallback
noDialerSubmittedCallback = Nothing

-- | Type for the callback on the (unwrapped) C side.
type C_DialerSubmittedCallback =
    Ptr () ->                               -- object
    CString ->
    Ptr () ->                               -- user_data
    IO ()

-- | Generate a function pointer callable from C code, from a `C_DialerSubmittedCallback`.
foreign import ccall "wrapper"
    mk_DialerSubmittedCallback :: C_DialerSubmittedCallback -> IO (FunPtr C_DialerSubmittedCallback)

-- | Wrap the callback into a `GClosure`.
genClosure_DialerSubmitted :: MonadIO m => DialerSubmittedCallback -> m (GClosure C_DialerSubmittedCallback)
genClosure_DialerSubmitted cb = liftIO $ do
    let cb' = wrap_DialerSubmittedCallback cb
    mk_DialerSubmittedCallback cb' >>= B.GClosure.newGClosure


-- | Wrap a `DialerSubmittedCallback` into a `C_DialerSubmittedCallback`.
wrap_DialerSubmittedCallback ::
    DialerSubmittedCallback ->
    C_DialerSubmittedCallback
wrap_DialerSubmittedCallback _cb _ number _ = do
    number' <- cstringToText number
    _cb  number'


{- |
Connect a signal handler for the “@submitted@” signal, to be run before the default handler.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Signals.on' dialer #submitted callback
@
-}
onDialerSubmitted :: (IsDialer a, MonadIO m) => a -> DialerSubmittedCallback -> m SignalHandlerId
onDialerSubmitted obj cb = liftIO $ do
    let cb' = wrap_DialerSubmittedCallback cb
    cb'' <- mk_DialerSubmittedCallback cb'
    connectSignalFunPtr obj "submitted" cb'' SignalConnectBefore

{- |
Connect a signal handler for the “@submitted@” signal, to be run after the default handler.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Signals.after' dialer #submitted callback
@
-}
afterDialerSubmitted :: (IsDialer a, MonadIO m) => a -> DialerSubmittedCallback -> m SignalHandlerId
afterDialerSubmitted obj cb = liftIO $ do
    let cb' = wrap_DialerSubmittedCallback cb
    cb'' <- mk_DialerSubmittedCallback cb'
    connectSignalFunPtr obj "submitted" cb'' SignalConnectAfter


-- signal Dialer::symbol-clicked
{- |
This signal is emitted when one of the symbol buttons (0-9, # or *)
is clicked. Connect to this signal to find out which button was pressed.
This doesn\'t take any cycling modes into account. So the button with \"*\"
and \"+\" on it will always send \"*\".  Delete and Submit buttons will
not trigger this signal.
-}
type DialerSymbolClickedCallback =
    Int8
    {- ^ /@button@/: The main symbol on the button that was clicked -}
    -> IO ()

-- | A convenience synonym for @`Nothing` :: `Maybe` `DialerSymbolClickedCallback`@.
noDialerSymbolClickedCallback :: Maybe DialerSymbolClickedCallback
noDialerSymbolClickedCallback = Nothing

-- | Type for the callback on the (unwrapped) C side.
type C_DialerSymbolClickedCallback =
    Ptr () ->                               -- object
    Int8 ->
    Ptr () ->                               -- user_data
    IO ()

-- | Generate a function pointer callable from C code, from a `C_DialerSymbolClickedCallback`.
foreign import ccall "wrapper"
    mk_DialerSymbolClickedCallback :: C_DialerSymbolClickedCallback -> IO (FunPtr C_DialerSymbolClickedCallback)

-- | Wrap the callback into a `GClosure`.
genClosure_DialerSymbolClicked :: MonadIO m => DialerSymbolClickedCallback -> m (GClosure C_DialerSymbolClickedCallback)
genClosure_DialerSymbolClicked cb = liftIO $ do
    let cb' = wrap_DialerSymbolClickedCallback cb
    mk_DialerSymbolClickedCallback cb' >>= B.GClosure.newGClosure


-- | Wrap a `DialerSymbolClickedCallback` into a `C_DialerSymbolClickedCallback`.
wrap_DialerSymbolClickedCallback ::
    DialerSymbolClickedCallback ->
    C_DialerSymbolClickedCallback
wrap_DialerSymbolClickedCallback _cb _ button _ = do
    _cb  button


{- |
Connect a signal handler for the “@symbol-clicked@” signal, to be run before the default handler.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Signals.on' dialer #symbolClicked callback
@
-}
onDialerSymbolClicked :: (IsDialer a, MonadIO m) => a -> DialerSymbolClickedCallback -> m SignalHandlerId
onDialerSymbolClicked obj cb = liftIO $ do
    let cb' = wrap_DialerSymbolClickedCallback cb
    cb'' <- mk_DialerSymbolClickedCallback cb'
    connectSignalFunPtr obj "symbol-clicked" cb'' SignalConnectBefore

{- |
Connect a signal handler for the “@symbol-clicked@” signal, to be run after the default handler.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Signals.after' dialer #symbolClicked callback
@
-}
afterDialerSymbolClicked :: (IsDialer a, MonadIO m) => a -> DialerSymbolClickedCallback -> m SignalHandlerId
afterDialerSymbolClicked obj cb = liftIO $ do
    let cb' = wrap_DialerSymbolClickedCallback cb
    cb'' <- mk_DialerSymbolClickedCallback cb'
    connectSignalFunPtr obj "symbol-clicked" cb'' SignalConnectAfter


-- VVV Prop "column-spacing"
   -- Type: TBasicType TUInt
   -- Flags: [PropertyReadable,PropertyWritable]
   -- Nullable: (Nothing,Nothing)

{- |
Get the value of the “@column-spacing@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dialer #columnSpacing
@
-}
getDialerColumnSpacing :: (MonadIO m, IsDialer o) => o -> m Word32
getDialerColumnSpacing obj = liftIO $ B.Properties.getObjectPropertyUInt32 obj "column-spacing"

{- |
Set the value of the “@column-spacing@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' dialer [ #columnSpacing 'Data.GI.Base.Attributes.:=' value ]
@
-}
setDialerColumnSpacing :: (MonadIO m, IsDialer o) => o -> Word32 -> m ()
setDialerColumnSpacing obj val = liftIO $ B.Properties.setObjectPropertyUInt32 obj "column-spacing" val

{- |
Construct a `GValueConstruct` with valid value for the “@column-spacing@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructDialerColumnSpacing :: (IsDialer o) => Word32 -> IO (GValueConstruct o)
constructDialerColumnSpacing val = B.Properties.constructObjectPropertyUInt32 "column-spacing" val

#if ENABLE_OVERLOADING
data DialerColumnSpacingPropertyInfo
instance AttrInfo DialerColumnSpacingPropertyInfo where
    type AttrAllowedOps DialerColumnSpacingPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DialerColumnSpacingPropertyInfo = (~) Word32
    type AttrBaseTypeConstraint DialerColumnSpacingPropertyInfo = IsDialer
    type AttrGetType DialerColumnSpacingPropertyInfo = Word32
    type AttrLabel DialerColumnSpacingPropertyInfo = "column-spacing"
    type AttrOrigin DialerColumnSpacingPropertyInfo = Dialer
    attrGet _ = getDialerColumnSpacing
    attrSet _ = setDialerColumnSpacing
    attrConstruct _ = constructDialerColumnSpacing
    attrClear _ = undefined
#endif

-- VVV Prop "number"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]
   -- Nullable: (Just False,Just False)

{- |
Get the value of the “@number@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dialer #number
@
-}
getDialerNumber :: (MonadIO m, IsDialer o) => o -> m T.Text
getDialerNumber obj = liftIO $ checkUnexpectedNothing "getDialerNumber" $ B.Properties.getObjectPropertyString obj "number"

{- |
Set the value of the “@number@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' dialer [ #number 'Data.GI.Base.Attributes.:=' value ]
@
-}
setDialerNumber :: (MonadIO m, IsDialer o) => o -> T.Text -> m ()
setDialerNumber obj val = liftIO $ B.Properties.setObjectPropertyString obj "number" (Just val)

{- |
Construct a `GValueConstruct` with valid value for the “@number@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructDialerNumber :: (IsDialer o) => T.Text -> IO (GValueConstruct o)
constructDialerNumber val = B.Properties.constructObjectPropertyString "number" (Just val)

#if ENABLE_OVERLOADING
data DialerNumberPropertyInfo
instance AttrInfo DialerNumberPropertyInfo where
    type AttrAllowedOps DialerNumberPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DialerNumberPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DialerNumberPropertyInfo = IsDialer
    type AttrGetType DialerNumberPropertyInfo = T.Text
    type AttrLabel DialerNumberPropertyInfo = "number"
    type AttrOrigin DialerNumberPropertyInfo = Dialer
    attrGet _ = getDialerNumber
    attrSet _ = setDialerNumber
    attrConstruct _ = constructDialerNumber
    attrClear _ = undefined
#endif

-- VVV Prop "relief"
   -- Type: TInterface (Name {namespace = "Gtk", name = "ReliefStyle"})
   -- Flags: [PropertyReadable,PropertyWritable]
   -- Nullable: (Just False,Just False)

{- |
Get the value of the “@relief@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dialer #relief
@
-}
getDialerRelief :: (MonadIO m, IsDialer o) => o -> m Gtk.Enums.ReliefStyle
getDialerRelief obj = liftIO $ B.Properties.getObjectPropertyEnum obj "relief"

{- |
Set the value of the “@relief@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' dialer [ #relief 'Data.GI.Base.Attributes.:=' value ]
@
-}
setDialerRelief :: (MonadIO m, IsDialer o) => o -> Gtk.Enums.ReliefStyle -> m ()
setDialerRelief obj val = liftIO $ B.Properties.setObjectPropertyEnum obj "relief" val

{- |
Construct a `GValueConstruct` with valid value for the “@relief@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructDialerRelief :: (IsDialer o) => Gtk.Enums.ReliefStyle -> IO (GValueConstruct o)
constructDialerRelief val = B.Properties.constructObjectPropertyEnum "relief" val

#if ENABLE_OVERLOADING
data DialerReliefPropertyInfo
instance AttrInfo DialerReliefPropertyInfo where
    type AttrAllowedOps DialerReliefPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DialerReliefPropertyInfo = (~) Gtk.Enums.ReliefStyle
    type AttrBaseTypeConstraint DialerReliefPropertyInfo = IsDialer
    type AttrGetType DialerReliefPropertyInfo = Gtk.Enums.ReliefStyle
    type AttrLabel DialerReliefPropertyInfo = "relief"
    type AttrOrigin DialerReliefPropertyInfo = Dialer
    attrGet _ = getDialerRelief
    attrSet _ = setDialerRelief
    attrConstruct _ = constructDialerRelief
    attrClear _ = undefined
#endif

-- VVV Prop "row-spacing"
   -- Type: TBasicType TUInt
   -- Flags: [PropertyReadable,PropertyWritable]
   -- Nullable: (Nothing,Nothing)

{- |
Get the value of the “@row-spacing@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dialer #rowSpacing
@
-}
getDialerRowSpacing :: (MonadIO m, IsDialer o) => o -> m Word32
getDialerRowSpacing obj = liftIO $ B.Properties.getObjectPropertyUInt32 obj "row-spacing"

{- |
Set the value of the “@row-spacing@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' dialer [ #rowSpacing 'Data.GI.Base.Attributes.:=' value ]
@
-}
setDialerRowSpacing :: (MonadIO m, IsDialer o) => o -> Word32 -> m ()
setDialerRowSpacing obj val = liftIO $ B.Properties.setObjectPropertyUInt32 obj "row-spacing" val

{- |
Construct a `GValueConstruct` with valid value for the “@row-spacing@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructDialerRowSpacing :: (IsDialer o) => Word32 -> IO (GValueConstruct o)
constructDialerRowSpacing val = B.Properties.constructObjectPropertyUInt32 "row-spacing" val

#if ENABLE_OVERLOADING
data DialerRowSpacingPropertyInfo
instance AttrInfo DialerRowSpacingPropertyInfo where
    type AttrAllowedOps DialerRowSpacingPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DialerRowSpacingPropertyInfo = (~) Word32
    type AttrBaseTypeConstraint DialerRowSpacingPropertyInfo = IsDialer
    type AttrGetType DialerRowSpacingPropertyInfo = Word32
    type AttrLabel DialerRowSpacingPropertyInfo = "row-spacing"
    type AttrOrigin DialerRowSpacingPropertyInfo = Dialer
    attrGet _ = getDialerRowSpacing
    attrSet _ = setDialerRowSpacing
    attrConstruct _ = constructDialerRowSpacing
    attrClear _ = undefined
#endif

-- VVV Prop "show-action-buttons"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable]
   -- Nullable: (Just False,Just False)

{- |
Get the value of the “@show-action-buttons@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dialer #showActionButtons
@
-}
getDialerShowActionButtons :: (MonadIO m, IsDialer o) => o -> m Bool
getDialerShowActionButtons obj = liftIO $ B.Properties.getObjectPropertyBool obj "show-action-buttons"

{- |
Set the value of the “@show-action-buttons@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' dialer [ #showActionButtons 'Data.GI.Base.Attributes.:=' value ]
@
-}
setDialerShowActionButtons :: (MonadIO m, IsDialer o) => o -> Bool -> m ()
setDialerShowActionButtons obj val = liftIO $ B.Properties.setObjectPropertyBool obj "show-action-buttons" val

{- |
Construct a `GValueConstruct` with valid value for the “@show-action-buttons@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructDialerShowActionButtons :: (IsDialer o) => Bool -> IO (GValueConstruct o)
constructDialerShowActionButtons val = B.Properties.constructObjectPropertyBool "show-action-buttons" val

#if ENABLE_OVERLOADING
data DialerShowActionButtonsPropertyInfo
instance AttrInfo DialerShowActionButtonsPropertyInfo where
    type AttrAllowedOps DialerShowActionButtonsPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DialerShowActionButtonsPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint DialerShowActionButtonsPropertyInfo = IsDialer
    type AttrGetType DialerShowActionButtonsPropertyInfo = Bool
    type AttrLabel DialerShowActionButtonsPropertyInfo = "show-action-buttons"
    type AttrOrigin DialerShowActionButtonsPropertyInfo = Dialer
    attrGet _ = getDialerShowActionButtons
    attrSet _ = setDialerShowActionButtons
    attrConstruct _ = constructDialerShowActionButtons
    attrClear _ = undefined
#endif

#if ENABLE_OVERLOADING
instance O.HasAttributeList Dialer
type instance O.AttributeList Dialer = DialerAttributeList
type DialerAttributeList = ('[ '("appPaintable", Gtk.Widget.WidgetAppPaintablePropertyInfo), '("borderWidth", Gtk.Container.ContainerBorderWidthPropertyInfo), '("canDefault", Gtk.Widget.WidgetCanDefaultPropertyInfo), '("canFocus", Gtk.Widget.WidgetCanFocusPropertyInfo), '("child", Gtk.Container.ContainerChildPropertyInfo), '("columnSpacing", DialerColumnSpacingPropertyInfo), '("compositeChild", Gtk.Widget.WidgetCompositeChildPropertyInfo), '("doubleBuffered", Gtk.Widget.WidgetDoubleBufferedPropertyInfo), '("events", Gtk.Widget.WidgetEventsPropertyInfo), '("expand", Gtk.Widget.WidgetExpandPropertyInfo), '("focusOnClick", Gtk.Widget.WidgetFocusOnClickPropertyInfo), '("halign", Gtk.Widget.WidgetHalignPropertyInfo), '("hasDefault", Gtk.Widget.WidgetHasDefaultPropertyInfo), '("hasFocus", Gtk.Widget.WidgetHasFocusPropertyInfo), '("hasTooltip", Gtk.Widget.WidgetHasTooltipPropertyInfo), '("heightRequest", Gtk.Widget.WidgetHeightRequestPropertyInfo), '("hexpand", Gtk.Widget.WidgetHexpandPropertyInfo), '("hexpandSet", Gtk.Widget.WidgetHexpandSetPropertyInfo), '("isFocus", Gtk.Widget.WidgetIsFocusPropertyInfo), '("margin", Gtk.Widget.WidgetMarginPropertyInfo), '("marginBottom", Gtk.Widget.WidgetMarginBottomPropertyInfo), '("marginEnd", Gtk.Widget.WidgetMarginEndPropertyInfo), '("marginLeft", Gtk.Widget.WidgetMarginLeftPropertyInfo), '("marginRight", Gtk.Widget.WidgetMarginRightPropertyInfo), '("marginStart", Gtk.Widget.WidgetMarginStartPropertyInfo), '("marginTop", Gtk.Widget.WidgetMarginTopPropertyInfo), '("name", Gtk.Widget.WidgetNamePropertyInfo), '("noShowAll", Gtk.Widget.WidgetNoShowAllPropertyInfo), '("number", DialerNumberPropertyInfo), '("opacity", Gtk.Widget.WidgetOpacityPropertyInfo), '("parent", Gtk.Widget.WidgetParentPropertyInfo), '("receivesDefault", Gtk.Widget.WidgetReceivesDefaultPropertyInfo), '("relief", DialerReliefPropertyInfo), '("resizeMode", Gtk.Container.ContainerResizeModePropertyInfo), '("rowSpacing", DialerRowSpacingPropertyInfo), '("scaleFactor", Gtk.Widget.WidgetScaleFactorPropertyInfo), '("sensitive", Gtk.Widget.WidgetSensitivePropertyInfo), '("showActionButtons", DialerShowActionButtonsPropertyInfo), '("style", Gtk.Widget.WidgetStylePropertyInfo), '("tooltipMarkup", Gtk.Widget.WidgetTooltipMarkupPropertyInfo), '("tooltipText", Gtk.Widget.WidgetTooltipTextPropertyInfo), '("valign", Gtk.Widget.WidgetValignPropertyInfo), '("vexpand", Gtk.Widget.WidgetVexpandPropertyInfo), '("vexpandSet", Gtk.Widget.WidgetVexpandSetPropertyInfo), '("visible", Gtk.Widget.WidgetVisiblePropertyInfo), '("widthRequest", Gtk.Widget.WidgetWidthRequestPropertyInfo), '("window", Gtk.Widget.WidgetWindowPropertyInfo)] :: [(Symbol, *)])
#endif

#if ENABLE_OVERLOADING
dialerColumnSpacing :: AttrLabelProxy "columnSpacing"
dialerColumnSpacing = AttrLabelProxy

dialerNumber :: AttrLabelProxy "number"
dialerNumber = AttrLabelProxy

dialerRelief :: AttrLabelProxy "relief"
dialerRelief = AttrLabelProxy

dialerRowSpacing :: AttrLabelProxy "rowSpacing"
dialerRowSpacing = AttrLabelProxy

dialerShowActionButtons :: AttrLabelProxy "showActionButtons"
dialerShowActionButtons = AttrLabelProxy

#endif

#if ENABLE_OVERLOADING
data DialerDeletedSignalInfo
instance SignalInfo DialerDeletedSignalInfo where
    type HaskellCallbackType DialerDeletedSignalInfo = DialerDeletedCallback
    connectSignal _ obj cb connectMode = do
        let cb' = wrap_DialerDeletedCallback cb
        cb'' <- mk_DialerDeletedCallback cb'
        connectSignalFunPtr obj "deleted" cb'' connectMode

data DialerSubmittedSignalInfo
instance SignalInfo DialerSubmittedSignalInfo where
    type HaskellCallbackType DialerSubmittedSignalInfo = DialerSubmittedCallback
    connectSignal _ obj cb connectMode = do
        let cb' = wrap_DialerSubmittedCallback cb
        cb'' <- mk_DialerSubmittedCallback cb'
        connectSignalFunPtr obj "submitted" cb'' connectMode

data DialerSymbolClickedSignalInfo
instance SignalInfo DialerSymbolClickedSignalInfo where
    type HaskellCallbackType DialerSymbolClickedSignalInfo = DialerSymbolClickedCallback
    connectSignal _ obj cb connectMode = do
        let cb' = wrap_DialerSymbolClickedCallback cb
        cb'' <- mk_DialerSymbolClickedCallback cb'
        connectSignalFunPtr obj "symbol-clicked" cb'' connectMode

type instance O.SignalList Dialer = DialerSignalList
type DialerSignalList = ('[ '("accelClosuresChanged", Gtk.Widget.WidgetAccelClosuresChangedSignalInfo), '("add", Gtk.Container.ContainerAddSignalInfo), '("buttonPressEvent", Gtk.Widget.WidgetButtonPressEventSignalInfo), '("buttonReleaseEvent", Gtk.Widget.WidgetButtonReleaseEventSignalInfo), '("canActivateAccel", Gtk.Widget.WidgetCanActivateAccelSignalInfo), '("checkResize", Gtk.Container.ContainerCheckResizeSignalInfo), '("childNotify", Gtk.Widget.WidgetChildNotifySignalInfo), '("compositedChanged", Gtk.Widget.WidgetCompositedChangedSignalInfo), '("configureEvent", Gtk.Widget.WidgetConfigureEventSignalInfo), '("damageEvent", Gtk.Widget.WidgetDamageEventSignalInfo), '("deleteEvent", Gtk.Widget.WidgetDeleteEventSignalInfo), '("deleted", DialerDeletedSignalInfo), '("destroy", Gtk.Widget.WidgetDestroySignalInfo), '("destroyEvent", Gtk.Widget.WidgetDestroyEventSignalInfo), '("directionChanged", Gtk.Widget.WidgetDirectionChangedSignalInfo), '("dragBegin", Gtk.Widget.WidgetDragBeginSignalInfo), '("dragDataDelete", Gtk.Widget.WidgetDragDataDeleteSignalInfo), '("dragDataGet", Gtk.Widget.WidgetDragDataGetSignalInfo), '("dragDataReceived", Gtk.Widget.WidgetDragDataReceivedSignalInfo), '("dragDrop", Gtk.Widget.WidgetDragDropSignalInfo), '("dragEnd", Gtk.Widget.WidgetDragEndSignalInfo), '("dragFailed", Gtk.Widget.WidgetDragFailedSignalInfo), '("dragLeave", Gtk.Widget.WidgetDragLeaveSignalInfo), '("dragMotion", Gtk.Widget.WidgetDragMotionSignalInfo), '("draw", Gtk.Widget.WidgetDrawSignalInfo), '("enterNotifyEvent", Gtk.Widget.WidgetEnterNotifyEventSignalInfo), '("event", Gtk.Widget.WidgetEventSignalInfo), '("eventAfter", Gtk.Widget.WidgetEventAfterSignalInfo), '("focus", Gtk.Widget.WidgetFocusSignalInfo), '("focusInEvent", Gtk.Widget.WidgetFocusInEventSignalInfo), '("focusOutEvent", Gtk.Widget.WidgetFocusOutEventSignalInfo), '("grabBrokenEvent", Gtk.Widget.WidgetGrabBrokenEventSignalInfo), '("grabFocus", Gtk.Widget.WidgetGrabFocusSignalInfo), '("grabNotify", Gtk.Widget.WidgetGrabNotifySignalInfo), '("hide", Gtk.Widget.WidgetHideSignalInfo), '("hierarchyChanged", Gtk.Widget.WidgetHierarchyChangedSignalInfo), '("keyPressEvent", Gtk.Widget.WidgetKeyPressEventSignalInfo), '("keyReleaseEvent", Gtk.Widget.WidgetKeyReleaseEventSignalInfo), '("keynavFailed", Gtk.Widget.WidgetKeynavFailedSignalInfo), '("leaveNotifyEvent", Gtk.Widget.WidgetLeaveNotifyEventSignalInfo), '("map", Gtk.Widget.WidgetMapSignalInfo), '("mapEvent", Gtk.Widget.WidgetMapEventSignalInfo), '("mnemonicActivate", Gtk.Widget.WidgetMnemonicActivateSignalInfo), '("motionNotifyEvent", Gtk.Widget.WidgetMotionNotifyEventSignalInfo), '("moveFocus", Gtk.Widget.WidgetMoveFocusSignalInfo), '("notify", GObject.Object.ObjectNotifySignalInfo), '("parentSet", Gtk.Widget.WidgetParentSetSignalInfo), '("popupMenu", Gtk.Widget.WidgetPopupMenuSignalInfo), '("propertyNotifyEvent", Gtk.Widget.WidgetPropertyNotifyEventSignalInfo), '("proximityInEvent", Gtk.Widget.WidgetProximityInEventSignalInfo), '("proximityOutEvent", Gtk.Widget.WidgetProximityOutEventSignalInfo), '("queryTooltip", Gtk.Widget.WidgetQueryTooltipSignalInfo), '("realize", Gtk.Widget.WidgetRealizeSignalInfo), '("remove", Gtk.Container.ContainerRemoveSignalInfo), '("screenChanged", Gtk.Widget.WidgetScreenChangedSignalInfo), '("scrollEvent", Gtk.Widget.WidgetScrollEventSignalInfo), '("selectionClearEvent", Gtk.Widget.WidgetSelectionClearEventSignalInfo), '("selectionGet", Gtk.Widget.WidgetSelectionGetSignalInfo), '("selectionNotifyEvent", Gtk.Widget.WidgetSelectionNotifyEventSignalInfo), '("selectionReceived", Gtk.Widget.WidgetSelectionReceivedSignalInfo), '("selectionRequestEvent", Gtk.Widget.WidgetSelectionRequestEventSignalInfo), '("setFocusChild", Gtk.Container.ContainerSetFocusChildSignalInfo), '("show", Gtk.Widget.WidgetShowSignalInfo), '("showHelp", Gtk.Widget.WidgetShowHelpSignalInfo), '("sizeAllocate", Gtk.Widget.WidgetSizeAllocateSignalInfo), '("stateChanged", Gtk.Widget.WidgetStateChangedSignalInfo), '("stateFlagsChanged", Gtk.Widget.WidgetStateFlagsChangedSignalInfo), '("styleSet", Gtk.Widget.WidgetStyleSetSignalInfo), '("styleUpdated", Gtk.Widget.WidgetStyleUpdatedSignalInfo), '("submitted", DialerSubmittedSignalInfo), '("symbolClicked", DialerSymbolClickedSignalInfo), '("touchEvent", Gtk.Widget.WidgetTouchEventSignalInfo), '("unmap", Gtk.Widget.WidgetUnmapSignalInfo), '("unmapEvent", Gtk.Widget.WidgetUnmapEventSignalInfo), '("unrealize", Gtk.Widget.WidgetUnrealizeSignalInfo), '("visibilityNotifyEvent", Gtk.Widget.WidgetVisibilityNotifyEventSignalInfo), '("windowStateEvent", Gtk.Widget.WidgetWindowStateEventSignalInfo)] :: [(Symbol, *)])

#endif

-- method Dialer::new
-- method type : Constructor
-- Args : []
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "Handy", name = "Dialer"}))
-- throws : False
-- Skip return : False

foreign import ccall "hdy_dialer_new" hdy_dialer_new :: 
    IO (Ptr Dialer)

{- |
Create a new 'GI.Handy.Objects.Dialer.Dialer' widget.
-}
dialerNew ::
    (B.CallStack.HasCallStack, MonadIO m) =>
    m Dialer
    {- ^ __Returns:__ the newly created 'GI.Handy.Objects.Dialer.Dialer' widget -}
dialerNew  = liftIO $ do
    result <- hdy_dialer_new
    checkUnexpectedReturnNULL "dialerNew" result
    result' <- (newObject Dialer) result
    return result'

#if ENABLE_OVERLOADING
#endif

-- method Dialer::clear_number
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "Handy", name = "Dialer"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #HdyDialer", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "hdy_dialer_clear_number" hdy_dialer_clear_number :: 
    Ptr Dialer ->                           -- self : TInterface (Name {namespace = "Handy", name = "Dialer"})
    IO ()

{- |
Set the current number to the empty string. When the number is already
cleared no action is performed.
-}
dialerClearNumber ::
    (B.CallStack.HasCallStack, MonadIO m, IsDialer a) =>
    a
    {- ^ /@self@/: a 'GI.Handy.Objects.Dialer.Dialer' -}
    -> m ()
dialerClearNumber self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    hdy_dialer_clear_number self'
    touchManagedPtr self
    return ()

#if ENABLE_OVERLOADING
data DialerClearNumberMethodInfo
instance (signature ~ (m ()), MonadIO m, IsDialer a) => O.MethodInfo DialerClearNumberMethodInfo a signature where
    overloadedMethod _ = dialerClearNumber

#endif

-- method Dialer::get_number
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "Handy", name = "Dialer"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #HdyDialer", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TUTF8)
-- throws : False
-- Skip return : False

foreign import ccall "hdy_dialer_get_number" hdy_dialer_get_number :: 
    Ptr Dialer ->                           -- self : TInterface (Name {namespace = "Handy", name = "Dialer"})
    IO CString

{- |
Get the currently displayed number.
-}
dialerGetNumber ::
    (B.CallStack.HasCallStack, MonadIO m, IsDialer a) =>
    a
    {- ^ /@self@/: a 'GI.Handy.Objects.Dialer.Dialer' -}
    -> m T.Text
    {- ^ __Returns:__ the current number in the display -}
dialerGetNumber self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- hdy_dialer_get_number self'
    checkUnexpectedReturnNULL "dialerGetNumber" result
    result' <- cstringToText result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DialerGetNumberMethodInfo
instance (signature ~ (m T.Text), MonadIO m, IsDialer a) => O.MethodInfo DialerGetNumberMethodInfo a signature where
    overloadedMethod _ = dialerGetNumber

#endif

-- method Dialer::get_relief
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "Handy", name = "Dialer"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "The #HdyDialer whose main buttons you want the #GtkReliefStyle from", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "Gtk", name = "ReliefStyle"}))
-- throws : False
-- Skip return : False

foreign import ccall "hdy_dialer_get_relief" hdy_dialer_get_relief :: 
    Ptr Dialer ->                           -- self : TInterface (Name {namespace = "Handy", name = "Dialer"})
    IO CUInt

{- |
Returns the current relief style of the main buttons for the given
'GI.Handy.Objects.Dialer.Dialer'.
-}
dialerGetRelief ::
    (B.CallStack.HasCallStack, MonadIO m, IsDialer a) =>
    a
    {- ^ /@self@/: The 'GI.Handy.Objects.Dialer.Dialer' whose main buttons you want the 'GI.Gtk.Enums.ReliefStyle' from -}
    -> m Gtk.Enums.ReliefStyle
    {- ^ __Returns:__ The current 'GI.Gtk.Enums.ReliefStyle' -}
dialerGetRelief self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- hdy_dialer_get_relief self'
    let result' = (toEnum . fromIntegral) result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DialerGetReliefMethodInfo
instance (signature ~ (m Gtk.Enums.ReliefStyle), MonadIO m, IsDialer a) => O.MethodInfo DialerGetReliefMethodInfo a signature where
    overloadedMethod _ = dialerGetRelief

#endif

-- method Dialer::get_show_action_buttons
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "Handy", name = "Dialer"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #HdyDialer", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TBoolean)
-- throws : False
-- Skip return : False

foreign import ccall "hdy_dialer_get_show_action_buttons" hdy_dialer_get_show_action_buttons :: 
    Ptr Dialer ->                           -- self : TInterface (Name {namespace = "Handy", name = "Dialer"})
    IO CInt

{- |
Get whether the submit and delete buttons are to be shown.
-}
dialerGetShowActionButtons ::
    (B.CallStack.HasCallStack, MonadIO m, IsDialer a) =>
    a
    {- ^ /@self@/: a 'GI.Handy.Objects.Dialer.Dialer' -}
    -> m Bool
    {- ^ __Returns:__ whether the buttons are to be shown -}
dialerGetShowActionButtons self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- hdy_dialer_get_show_action_buttons self'
    let result' = (/= 0) result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DialerGetShowActionButtonsMethodInfo
instance (signature ~ (m Bool), MonadIO m, IsDialer a) => O.MethodInfo DialerGetShowActionButtonsMethodInfo a signature where
    overloadedMethod _ = dialerGetShowActionButtons

#endif

-- method Dialer::set_number
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "Handy", name = "Dialer"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #HdyDialer", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "number", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "the number to set", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "hdy_dialer_set_number" hdy_dialer_set_number :: 
    Ptr Dialer ->                           -- self : TInterface (Name {namespace = "Handy", name = "Dialer"})
    CString ->                              -- number : TBasicType TUTF8
    IO ()

{- |
Set the currently displayed number.
-}
dialerSetNumber ::
    (B.CallStack.HasCallStack, MonadIO m, IsDialer a) =>
    a
    {- ^ /@self@/: a 'GI.Handy.Objects.Dialer.Dialer' -}
    -> T.Text
    {- ^ /@number@/: the number to set -}
    -> m ()
dialerSetNumber self number = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    number' <- textToCString number
    hdy_dialer_set_number self' number'
    touchManagedPtr self
    freeMem number'
    return ()

#if ENABLE_OVERLOADING
data DialerSetNumberMethodInfo
instance (signature ~ (T.Text -> m ()), MonadIO m, IsDialer a) => O.MethodInfo DialerSetNumberMethodInfo a signature where
    overloadedMethod _ = dialerSetNumber

#endif

-- method Dialer::set_relief
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "Handy", name = "Dialer"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "The #HdyDialer whose main buttons you want to set relief styles of", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "relief", argType = TInterface (Name {namespace = "Gtk", name = "ReliefStyle"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "The #GtkReliefStyle as described above", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "hdy_dialer_set_relief" hdy_dialer_set_relief :: 
    Ptr Dialer ->                           -- self : TInterface (Name {namespace = "Handy", name = "Dialer"})
    CUInt ->                                -- relief : TInterface (Name {namespace = "Gtk", name = "ReliefStyle"})
    IO ()

{- |
Sets the relief style of the edges of the main buttons for the given
'GI.Handy.Objects.Dialer.Dialer' widget.
Two styles exist, 'GI.Gtk.Enums.ReliefStyleNormal' and 'GI.Gtk.Enums.ReliefStyleNone'.
The default style is, as one can guess, 'GI.Gtk.Enums.ReliefStyleNormal'.
-}
dialerSetRelief ::
    (B.CallStack.HasCallStack, MonadIO m, IsDialer a) =>
    a
    {- ^ /@self@/: The 'GI.Handy.Objects.Dialer.Dialer' whose main buttons you want to set relief styles of -}
    -> Gtk.Enums.ReliefStyle
    {- ^ /@relief@/: The 'GI.Gtk.Enums.ReliefStyle' as described above -}
    -> m ()
dialerSetRelief self relief = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    let relief' = (fromIntegral . fromEnum) relief
    hdy_dialer_set_relief self' relief'
    touchManagedPtr self
    return ()

#if ENABLE_OVERLOADING
data DialerSetReliefMethodInfo
instance (signature ~ (Gtk.Enums.ReliefStyle -> m ()), MonadIO m, IsDialer a) => O.MethodInfo DialerSetReliefMethodInfo a signature where
    overloadedMethod _ = dialerSetRelief

#endif

-- method Dialer::set_show_action_buttons
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "Handy", name = "Dialer"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #HdyDialer", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "show", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "whether to show the buttons", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "hdy_dialer_set_show_action_buttons" hdy_dialer_set_show_action_buttons :: 
    Ptr Dialer ->                           -- self : TInterface (Name {namespace = "Handy", name = "Dialer"})
    CInt ->                                 -- show : TBasicType TBoolean
    IO ()

{- |
Set whether to show the submit and delete buttons.
-}
dialerSetShowActionButtons ::
    (B.CallStack.HasCallStack, MonadIO m, IsDialer a) =>
    a
    {- ^ /@self@/: a 'GI.Handy.Objects.Dialer.Dialer' -}
    -> Bool
    {- ^ /@show@/: whether to show the buttons -}
    -> m ()
dialerSetShowActionButtons self show_ = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    let show_' = (fromIntegral . fromEnum) show_
    hdy_dialer_set_show_action_buttons self' show_'
    touchManagedPtr self
    return ()

#if ENABLE_OVERLOADING
data DialerSetShowActionButtonsMethodInfo
instance (signature ~ (Bool -> m ()), MonadIO m, IsDialer a) => O.MethodInfo DialerSetShowActionButtonsMethodInfo a signature where
    overloadedMethod _ = dialerSetShowActionButtons

#endif


