

{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (inaki@blueleaf.cc)

/No description available in the introspection data./
-}

#define ENABLE_OVERLOADING (MIN_VERSION_haskell_gi_overloading(1,0,0) \
       && !defined(__HADDOCK_VERSION__))

module GI.Handy.Objects.DialerCycleButton
    ( 

-- * Exported types
    DialerCycleButton(..)                   ,
    IsDialerCycleButton                     ,
    toDialerCycleButton                     ,
    noDialerCycleButton                     ,


 -- * Methods
-- ** getCurrentSymbol #method:getCurrentSymbol#

#if ENABLE_OVERLOADING
    DialerCycleButtonGetCurrentSymbolMethodInfo,
#endif
    dialerCycleButtonGetCurrentSymbol       ,


-- ** getCycleTimeout #method:getCycleTimeout#

#if ENABLE_OVERLOADING
    DialerCycleButtonGetCycleTimeoutMethodInfo,
#endif
    dialerCycleButtonGetCycleTimeout        ,


-- ** isCycling #method:isCycling#

#if ENABLE_OVERLOADING
    DialerCycleButtonIsCyclingMethodInfo    ,
#endif
    dialerCycleButtonIsCycling              ,


-- ** new #method:new#

    dialerCycleButtonNew                    ,


-- ** setCycleTimeout #method:setCycleTimeout#

#if ENABLE_OVERLOADING
    DialerCycleButtonSetCycleTimeoutMethodInfo,
#endif
    dialerCycleButtonSetCycleTimeout        ,


-- ** stopCycle #method:stopCycle#

#if ENABLE_OVERLOADING
    DialerCycleButtonStopCycleMethodInfo    ,
#endif
    dialerCycleButtonStopCycle              ,




 -- * Properties
-- ** cycleTimeout #attr:cycleTimeout#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    DialerCycleButtonCycleTimeoutPropertyInfo,
#endif
    constructDialerCycleButtonCycleTimeout  ,
#if ENABLE_OVERLOADING
    dialerCycleButtonCycleTimeout           ,
#endif
    getDialerCycleButtonCycleTimeout        ,
    setDialerCycleButtonCycleTimeout        ,




 -- * Signals
-- ** cycleEnd #signal:cycleEnd#

    C_DialerCycleButtonCycleEndCallback     ,
    DialerCycleButtonCycleEndCallback       ,
#if ENABLE_OVERLOADING
    DialerCycleButtonCycleEndSignalInfo     ,
#endif
    afterDialerCycleButtonCycleEnd          ,
    genClosure_DialerCycleButtonCycleEnd    ,
    mk_DialerCycleButtonCycleEndCallback    ,
    noDialerCycleButtonCycleEndCallback     ,
    onDialerCycleButtonCycleEnd             ,
    wrap_DialerCycleButtonCycleEndCallback  ,


-- ** cycleStart #signal:cycleStart#

    C_DialerCycleButtonCycleStartCallback   ,
    DialerCycleButtonCycleStartCallback     ,
#if ENABLE_OVERLOADING
    DialerCycleButtonCycleStartSignalInfo   ,
#endif
    afterDialerCycleButtonCycleStart        ,
    genClosure_DialerCycleButtonCycleStart  ,
    mk_DialerCycleButtonCycleStartCallback  ,
    noDialerCycleButtonCycleStartCallback   ,
    onDialerCycleButtonCycleStart           ,
    wrap_DialerCycleButtonCycleStartCallback,




    ) where

import Data.GI.Base.ShortPrelude
import qualified Data.GI.Base.ShortPrelude as SP
import qualified Data.GI.Base.Overloading as O
import qualified Prelude as P

import qualified Data.GI.Base.Attributes as GI.Attributes
import qualified Data.GI.Base.ManagedPtr as B.ManagedPtr
import qualified Data.GI.Base.GClosure as B.GClosure
import qualified Data.GI.Base.GError as B.GError
import qualified Data.GI.Base.GVariant as B.GVariant
import qualified Data.GI.Base.GValue as B.GValue
import qualified Data.GI.Base.GParamSpec as B.GParamSpec
import qualified Data.GI.Base.CallStack as B.CallStack
import qualified Data.GI.Base.Properties as B.Properties
import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map
import qualified Foreign.Ptr as FP
import qualified GHC.OverloadedLabels as OL

import qualified GI.Atk.Interfaces.ImplementorIface as Atk.ImplementorIface
import qualified GI.GObject.Objects.Object as GObject.Object
import qualified GI.Gtk.Interfaces.Actionable as Gtk.Actionable
import qualified GI.Gtk.Interfaces.Activatable as Gtk.Activatable
import qualified GI.Gtk.Interfaces.Buildable as Gtk.Buildable
import qualified GI.Gtk.Objects.Bin as Gtk.Bin
import qualified GI.Gtk.Objects.Button as Gtk.Button
import qualified GI.Gtk.Objects.Container as Gtk.Container
import qualified GI.Gtk.Objects.Widget as Gtk.Widget
import {-# SOURCE #-} qualified GI.Handy.Objects.DialerButton as Handy.DialerButton

-- | Memory-managed wrapper type.
newtype DialerCycleButton = DialerCycleButton (ManagedPtr DialerCycleButton)
foreign import ccall "hdy_dialer_cycle_button_get_type"
    c_hdy_dialer_cycle_button_get_type :: IO GType

instance GObject DialerCycleButton where
    gobjectType = c_hdy_dialer_cycle_button_get_type
    

-- | Type class for types which can be safely cast to `DialerCycleButton`, for instance with `toDialerCycleButton`.
class (GObject o, O.IsDescendantOf DialerCycleButton o) => IsDialerCycleButton o
instance (GObject o, O.IsDescendantOf DialerCycleButton o) => IsDialerCycleButton o

instance O.HasParentTypes DialerCycleButton
type instance O.ParentTypes DialerCycleButton = '[Handy.DialerButton.DialerButton, Gtk.Button.Button, Gtk.Bin.Bin, Gtk.Container.Container, Gtk.Widget.Widget, GObject.Object.Object, Atk.ImplementorIface.ImplementorIface, Gtk.Actionable.Actionable, Gtk.Activatable.Activatable, Gtk.Buildable.Buildable]

-- | Cast to `DialerCycleButton`, for types for which this is known to be safe. For general casts, use `Data.GI.Base.ManagedPtr.castTo`.
toDialerCycleButton :: (MonadIO m, IsDialerCycleButton o) => o -> m DialerCycleButton
toDialerCycleButton = liftIO . unsafeCastTo DialerCycleButton

-- | A convenience alias for `Nothing` :: `Maybe` `DialerCycleButton`.
noDialerCycleButton :: Maybe DialerCycleButton
noDialerCycleButton = Nothing

#if ENABLE_OVERLOADING
type family ResolveDialerCycleButtonMethod (t :: Symbol) (o :: *) :: * where
    ResolveDialerCycleButtonMethod "activate" o = Gtk.Widget.WidgetActivateMethodInfo
    ResolveDialerCycleButtonMethod "add" o = Gtk.Container.ContainerAddMethodInfo
    ResolveDialerCycleButtonMethod "addAccelerator" o = Gtk.Widget.WidgetAddAcceleratorMethodInfo
    ResolveDialerCycleButtonMethod "addChild" o = Gtk.Buildable.BuildableAddChildMethodInfo
    ResolveDialerCycleButtonMethod "addDeviceEvents" o = Gtk.Widget.WidgetAddDeviceEventsMethodInfo
    ResolveDialerCycleButtonMethod "addEvents" o = Gtk.Widget.WidgetAddEventsMethodInfo
    ResolveDialerCycleButtonMethod "addMnemonicLabel" o = Gtk.Widget.WidgetAddMnemonicLabelMethodInfo
    ResolveDialerCycleButtonMethod "addTickCallback" o = Gtk.Widget.WidgetAddTickCallbackMethodInfo
    ResolveDialerCycleButtonMethod "bindProperty" o = GObject.Object.ObjectBindPropertyMethodInfo
    ResolveDialerCycleButtonMethod "bindPropertyFull" o = GObject.Object.ObjectBindPropertyFullMethodInfo
    ResolveDialerCycleButtonMethod "canActivateAccel" o = Gtk.Widget.WidgetCanActivateAccelMethodInfo
    ResolveDialerCycleButtonMethod "checkResize" o = Gtk.Container.ContainerCheckResizeMethodInfo
    ResolveDialerCycleButtonMethod "childFocus" o = Gtk.Widget.WidgetChildFocusMethodInfo
    ResolveDialerCycleButtonMethod "childGetProperty" o = Gtk.Container.ContainerChildGetPropertyMethodInfo
    ResolveDialerCycleButtonMethod "childNotify" o = Gtk.Container.ContainerChildNotifyMethodInfo
    ResolveDialerCycleButtonMethod "childNotifyByPspec" o = Gtk.Container.ContainerChildNotifyByPspecMethodInfo
    ResolveDialerCycleButtonMethod "childSetProperty" o = Gtk.Container.ContainerChildSetPropertyMethodInfo
    ResolveDialerCycleButtonMethod "childType" o = Gtk.Container.ContainerChildTypeMethodInfo
    ResolveDialerCycleButtonMethod "classPath" o = Gtk.Widget.WidgetClassPathMethodInfo
    ResolveDialerCycleButtonMethod "clicked" o = Gtk.Button.ButtonClickedMethodInfo
    ResolveDialerCycleButtonMethod "computeExpand" o = Gtk.Widget.WidgetComputeExpandMethodInfo
    ResolveDialerCycleButtonMethod "constructChild" o = Gtk.Buildable.BuildableConstructChildMethodInfo
    ResolveDialerCycleButtonMethod "createPangoContext" o = Gtk.Widget.WidgetCreatePangoContextMethodInfo
    ResolveDialerCycleButtonMethod "createPangoLayout" o = Gtk.Widget.WidgetCreatePangoLayoutMethodInfo
    ResolveDialerCycleButtonMethod "customFinished" o = Gtk.Buildable.BuildableCustomFinishedMethodInfo
    ResolveDialerCycleButtonMethod "customTagEnd" o = Gtk.Buildable.BuildableCustomTagEndMethodInfo
    ResolveDialerCycleButtonMethod "customTagStart" o = Gtk.Buildable.BuildableCustomTagStartMethodInfo
    ResolveDialerCycleButtonMethod "destroy" o = Gtk.Widget.WidgetDestroyMethodInfo
    ResolveDialerCycleButtonMethod "destroyed" o = Gtk.Widget.WidgetDestroyedMethodInfo
    ResolveDialerCycleButtonMethod "deviceIsShadowed" o = Gtk.Widget.WidgetDeviceIsShadowedMethodInfo
    ResolveDialerCycleButtonMethod "doSetRelatedAction" o = Gtk.Activatable.ActivatableDoSetRelatedActionMethodInfo
    ResolveDialerCycleButtonMethod "dragBegin" o = Gtk.Widget.WidgetDragBeginMethodInfo
    ResolveDialerCycleButtonMethod "dragBeginWithCoordinates" o = Gtk.Widget.WidgetDragBeginWithCoordinatesMethodInfo
    ResolveDialerCycleButtonMethod "dragCheckThreshold" o = Gtk.Widget.WidgetDragCheckThresholdMethodInfo
    ResolveDialerCycleButtonMethod "dragDestAddImageTargets" o = Gtk.Widget.WidgetDragDestAddImageTargetsMethodInfo
    ResolveDialerCycleButtonMethod "dragDestAddTextTargets" o = Gtk.Widget.WidgetDragDestAddTextTargetsMethodInfo
    ResolveDialerCycleButtonMethod "dragDestAddUriTargets" o = Gtk.Widget.WidgetDragDestAddUriTargetsMethodInfo
    ResolveDialerCycleButtonMethod "dragDestFindTarget" o = Gtk.Widget.WidgetDragDestFindTargetMethodInfo
    ResolveDialerCycleButtonMethod "dragDestGetTargetList" o = Gtk.Widget.WidgetDragDestGetTargetListMethodInfo
    ResolveDialerCycleButtonMethod "dragDestGetTrackMotion" o = Gtk.Widget.WidgetDragDestGetTrackMotionMethodInfo
    ResolveDialerCycleButtonMethod "dragDestSet" o = Gtk.Widget.WidgetDragDestSetMethodInfo
    ResolveDialerCycleButtonMethod "dragDestSetProxy" o = Gtk.Widget.WidgetDragDestSetProxyMethodInfo
    ResolveDialerCycleButtonMethod "dragDestSetTargetList" o = Gtk.Widget.WidgetDragDestSetTargetListMethodInfo
    ResolveDialerCycleButtonMethod "dragDestSetTrackMotion" o = Gtk.Widget.WidgetDragDestSetTrackMotionMethodInfo
    ResolveDialerCycleButtonMethod "dragDestUnset" o = Gtk.Widget.WidgetDragDestUnsetMethodInfo
    ResolveDialerCycleButtonMethod "dragGetData" o = Gtk.Widget.WidgetDragGetDataMethodInfo
    ResolveDialerCycleButtonMethod "dragHighlight" o = Gtk.Widget.WidgetDragHighlightMethodInfo
    ResolveDialerCycleButtonMethod "dragSourceAddImageTargets" o = Gtk.Widget.WidgetDragSourceAddImageTargetsMethodInfo
    ResolveDialerCycleButtonMethod "dragSourceAddTextTargets" o = Gtk.Widget.WidgetDragSourceAddTextTargetsMethodInfo
    ResolveDialerCycleButtonMethod "dragSourceAddUriTargets" o = Gtk.Widget.WidgetDragSourceAddUriTargetsMethodInfo
    ResolveDialerCycleButtonMethod "dragSourceGetTargetList" o = Gtk.Widget.WidgetDragSourceGetTargetListMethodInfo
    ResolveDialerCycleButtonMethod "dragSourceSet" o = Gtk.Widget.WidgetDragSourceSetMethodInfo
    ResolveDialerCycleButtonMethod "dragSourceSetIconGicon" o = Gtk.Widget.WidgetDragSourceSetIconGiconMethodInfo
    ResolveDialerCycleButtonMethod "dragSourceSetIconName" o = Gtk.Widget.WidgetDragSourceSetIconNameMethodInfo
    ResolveDialerCycleButtonMethod "dragSourceSetIconPixbuf" o = Gtk.Widget.WidgetDragSourceSetIconPixbufMethodInfo
    ResolveDialerCycleButtonMethod "dragSourceSetIconStock" o = Gtk.Widget.WidgetDragSourceSetIconStockMethodInfo
    ResolveDialerCycleButtonMethod "dragSourceSetTargetList" o = Gtk.Widget.WidgetDragSourceSetTargetListMethodInfo
    ResolveDialerCycleButtonMethod "dragSourceUnset" o = Gtk.Widget.WidgetDragSourceUnsetMethodInfo
    ResolveDialerCycleButtonMethod "dragUnhighlight" o = Gtk.Widget.WidgetDragUnhighlightMethodInfo
    ResolveDialerCycleButtonMethod "draw" o = Gtk.Widget.WidgetDrawMethodInfo
    ResolveDialerCycleButtonMethod "ensureStyle" o = Gtk.Widget.WidgetEnsureStyleMethodInfo
    ResolveDialerCycleButtonMethod "enter" o = Gtk.Button.ButtonEnterMethodInfo
    ResolveDialerCycleButtonMethod "errorBell" o = Gtk.Widget.WidgetErrorBellMethodInfo
    ResolveDialerCycleButtonMethod "event" o = Gtk.Widget.WidgetEventMethodInfo
    ResolveDialerCycleButtonMethod "forall" o = Gtk.Container.ContainerForallMethodInfo
    ResolveDialerCycleButtonMethod "forceFloating" o = GObject.Object.ObjectForceFloatingMethodInfo
    ResolveDialerCycleButtonMethod "foreach" o = Gtk.Container.ContainerForeachMethodInfo
    ResolveDialerCycleButtonMethod "freezeChildNotify" o = Gtk.Widget.WidgetFreezeChildNotifyMethodInfo
    ResolveDialerCycleButtonMethod "freezeNotify" o = GObject.Object.ObjectFreezeNotifyMethodInfo
    ResolveDialerCycleButtonMethod "getv" o = GObject.Object.ObjectGetvMethodInfo
    ResolveDialerCycleButtonMethod "grabAdd" o = Gtk.Widget.WidgetGrabAddMethodInfo
    ResolveDialerCycleButtonMethod "grabDefault" o = Gtk.Widget.WidgetGrabDefaultMethodInfo
    ResolveDialerCycleButtonMethod "grabFocus" o = Gtk.Widget.WidgetGrabFocusMethodInfo
    ResolveDialerCycleButtonMethod "grabRemove" o = Gtk.Widget.WidgetGrabRemoveMethodInfo
    ResolveDialerCycleButtonMethod "hasDefault" o = Gtk.Widget.WidgetHasDefaultMethodInfo
    ResolveDialerCycleButtonMethod "hasFocus" o = Gtk.Widget.WidgetHasFocusMethodInfo
    ResolveDialerCycleButtonMethod "hasGrab" o = Gtk.Widget.WidgetHasGrabMethodInfo
    ResolveDialerCycleButtonMethod "hasRcStyle" o = Gtk.Widget.WidgetHasRcStyleMethodInfo
    ResolveDialerCycleButtonMethod "hasScreen" o = Gtk.Widget.WidgetHasScreenMethodInfo
    ResolveDialerCycleButtonMethod "hasVisibleFocus" o = Gtk.Widget.WidgetHasVisibleFocusMethodInfo
    ResolveDialerCycleButtonMethod "hide" o = Gtk.Widget.WidgetHideMethodInfo
    ResolveDialerCycleButtonMethod "hideOnDelete" o = Gtk.Widget.WidgetHideOnDeleteMethodInfo
    ResolveDialerCycleButtonMethod "inDestruction" o = Gtk.Widget.WidgetInDestructionMethodInfo
    ResolveDialerCycleButtonMethod "initTemplate" o = Gtk.Widget.WidgetInitTemplateMethodInfo
    ResolveDialerCycleButtonMethod "inputShapeCombineRegion" o = Gtk.Widget.WidgetInputShapeCombineRegionMethodInfo
    ResolveDialerCycleButtonMethod "insertActionGroup" o = Gtk.Widget.WidgetInsertActionGroupMethodInfo
    ResolveDialerCycleButtonMethod "intersect" o = Gtk.Widget.WidgetIntersectMethodInfo
    ResolveDialerCycleButtonMethod "isAncestor" o = Gtk.Widget.WidgetIsAncestorMethodInfo
    ResolveDialerCycleButtonMethod "isComposited" o = Gtk.Widget.WidgetIsCompositedMethodInfo
    ResolveDialerCycleButtonMethod "isCycling" o = DialerCycleButtonIsCyclingMethodInfo
    ResolveDialerCycleButtonMethod "isDrawable" o = Gtk.Widget.WidgetIsDrawableMethodInfo
    ResolveDialerCycleButtonMethod "isFloating" o = GObject.Object.ObjectIsFloatingMethodInfo
    ResolveDialerCycleButtonMethod "isFocus" o = Gtk.Widget.WidgetIsFocusMethodInfo
    ResolveDialerCycleButtonMethod "isSensitive" o = Gtk.Widget.WidgetIsSensitiveMethodInfo
    ResolveDialerCycleButtonMethod "isToplevel" o = Gtk.Widget.WidgetIsToplevelMethodInfo
    ResolveDialerCycleButtonMethod "isVisible" o = Gtk.Widget.WidgetIsVisibleMethodInfo
    ResolveDialerCycleButtonMethod "keynavFailed" o = Gtk.Widget.WidgetKeynavFailedMethodInfo
    ResolveDialerCycleButtonMethod "leave" o = Gtk.Button.ButtonLeaveMethodInfo
    ResolveDialerCycleButtonMethod "listAccelClosures" o = Gtk.Widget.WidgetListAccelClosuresMethodInfo
    ResolveDialerCycleButtonMethod "listActionPrefixes" o = Gtk.Widget.WidgetListActionPrefixesMethodInfo
    ResolveDialerCycleButtonMethod "listMnemonicLabels" o = Gtk.Widget.WidgetListMnemonicLabelsMethodInfo
    ResolveDialerCycleButtonMethod "map" o = Gtk.Widget.WidgetMapMethodInfo
    ResolveDialerCycleButtonMethod "mnemonicActivate" o = Gtk.Widget.WidgetMnemonicActivateMethodInfo
    ResolveDialerCycleButtonMethod "modifyBase" o = Gtk.Widget.WidgetModifyBaseMethodInfo
    ResolveDialerCycleButtonMethod "modifyBg" o = Gtk.Widget.WidgetModifyBgMethodInfo
    ResolveDialerCycleButtonMethod "modifyCursor" o = Gtk.Widget.WidgetModifyCursorMethodInfo
    ResolveDialerCycleButtonMethod "modifyFg" o = Gtk.Widget.WidgetModifyFgMethodInfo
    ResolveDialerCycleButtonMethod "modifyFont" o = Gtk.Widget.WidgetModifyFontMethodInfo
    ResolveDialerCycleButtonMethod "modifyStyle" o = Gtk.Widget.WidgetModifyStyleMethodInfo
    ResolveDialerCycleButtonMethod "modifyText" o = Gtk.Widget.WidgetModifyTextMethodInfo
    ResolveDialerCycleButtonMethod "notify" o = GObject.Object.ObjectNotifyMethodInfo
    ResolveDialerCycleButtonMethod "notifyByPspec" o = GObject.Object.ObjectNotifyByPspecMethodInfo
    ResolveDialerCycleButtonMethod "overrideBackgroundColor" o = Gtk.Widget.WidgetOverrideBackgroundColorMethodInfo
    ResolveDialerCycleButtonMethod "overrideColor" o = Gtk.Widget.WidgetOverrideColorMethodInfo
    ResolveDialerCycleButtonMethod "overrideCursor" o = Gtk.Widget.WidgetOverrideCursorMethodInfo
    ResolveDialerCycleButtonMethod "overrideFont" o = Gtk.Widget.WidgetOverrideFontMethodInfo
    ResolveDialerCycleButtonMethod "overrideSymbolicColor" o = Gtk.Widget.WidgetOverrideSymbolicColorMethodInfo
    ResolveDialerCycleButtonMethod "parserFinished" o = Gtk.Buildable.BuildableParserFinishedMethodInfo
    ResolveDialerCycleButtonMethod "path" o = Gtk.Widget.WidgetPathMethodInfo
    ResolveDialerCycleButtonMethod "pressed" o = Gtk.Button.ButtonPressedMethodInfo
    ResolveDialerCycleButtonMethod "propagateDraw" o = Gtk.Container.ContainerPropagateDrawMethodInfo
    ResolveDialerCycleButtonMethod "queueAllocate" o = Gtk.Widget.WidgetQueueAllocateMethodInfo
    ResolveDialerCycleButtonMethod "queueComputeExpand" o = Gtk.Widget.WidgetQueueComputeExpandMethodInfo
    ResolveDialerCycleButtonMethod "queueDraw" o = Gtk.Widget.WidgetQueueDrawMethodInfo
    ResolveDialerCycleButtonMethod "queueDrawArea" o = Gtk.Widget.WidgetQueueDrawAreaMethodInfo
    ResolveDialerCycleButtonMethod "queueDrawRegion" o = Gtk.Widget.WidgetQueueDrawRegionMethodInfo
    ResolveDialerCycleButtonMethod "queueResize" o = Gtk.Widget.WidgetQueueResizeMethodInfo
    ResolveDialerCycleButtonMethod "queueResizeNoRedraw" o = Gtk.Widget.WidgetQueueResizeNoRedrawMethodInfo
    ResolveDialerCycleButtonMethod "realize" o = Gtk.Widget.WidgetRealizeMethodInfo
    ResolveDialerCycleButtonMethod "ref" o = GObject.Object.ObjectRefMethodInfo
    ResolveDialerCycleButtonMethod "refSink" o = GObject.Object.ObjectRefSinkMethodInfo
    ResolveDialerCycleButtonMethod "regionIntersect" o = Gtk.Widget.WidgetRegionIntersectMethodInfo
    ResolveDialerCycleButtonMethod "registerWindow" o = Gtk.Widget.WidgetRegisterWindowMethodInfo
    ResolveDialerCycleButtonMethod "released" o = Gtk.Button.ButtonReleasedMethodInfo
    ResolveDialerCycleButtonMethod "remove" o = Gtk.Container.ContainerRemoveMethodInfo
    ResolveDialerCycleButtonMethod "removeAccelerator" o = Gtk.Widget.WidgetRemoveAcceleratorMethodInfo
    ResolveDialerCycleButtonMethod "removeMnemonicLabel" o = Gtk.Widget.WidgetRemoveMnemonicLabelMethodInfo
    ResolveDialerCycleButtonMethod "removeTickCallback" o = Gtk.Widget.WidgetRemoveTickCallbackMethodInfo
    ResolveDialerCycleButtonMethod "renderIcon" o = Gtk.Widget.WidgetRenderIconMethodInfo
    ResolveDialerCycleButtonMethod "renderIconPixbuf" o = Gtk.Widget.WidgetRenderIconPixbufMethodInfo
    ResolveDialerCycleButtonMethod "reparent" o = Gtk.Widget.WidgetReparentMethodInfo
    ResolveDialerCycleButtonMethod "resetRcStyles" o = Gtk.Widget.WidgetResetRcStylesMethodInfo
    ResolveDialerCycleButtonMethod "resetStyle" o = Gtk.Widget.WidgetResetStyleMethodInfo
    ResolveDialerCycleButtonMethod "resizeChildren" o = Gtk.Container.ContainerResizeChildrenMethodInfo
    ResolveDialerCycleButtonMethod "runDispose" o = GObject.Object.ObjectRunDisposeMethodInfo
    ResolveDialerCycleButtonMethod "sendExpose" o = Gtk.Widget.WidgetSendExposeMethodInfo
    ResolveDialerCycleButtonMethod "sendFocusChange" o = Gtk.Widget.WidgetSendFocusChangeMethodInfo
    ResolveDialerCycleButtonMethod "shapeCombineRegion" o = Gtk.Widget.WidgetShapeCombineRegionMethodInfo
    ResolveDialerCycleButtonMethod "show" o = Gtk.Widget.WidgetShowMethodInfo
    ResolveDialerCycleButtonMethod "showAll" o = Gtk.Widget.WidgetShowAllMethodInfo
    ResolveDialerCycleButtonMethod "showNow" o = Gtk.Widget.WidgetShowNowMethodInfo
    ResolveDialerCycleButtonMethod "sizeAllocate" o = Gtk.Widget.WidgetSizeAllocateMethodInfo
    ResolveDialerCycleButtonMethod "sizeAllocateWithBaseline" o = Gtk.Widget.WidgetSizeAllocateWithBaselineMethodInfo
    ResolveDialerCycleButtonMethod "sizeRequest" o = Gtk.Widget.WidgetSizeRequestMethodInfo
    ResolveDialerCycleButtonMethod "stealData" o = GObject.Object.ObjectStealDataMethodInfo
    ResolveDialerCycleButtonMethod "stealQdata" o = GObject.Object.ObjectStealQdataMethodInfo
    ResolveDialerCycleButtonMethod "stopCycle" o = DialerCycleButtonStopCycleMethodInfo
    ResolveDialerCycleButtonMethod "styleAttach" o = Gtk.Widget.WidgetStyleAttachMethodInfo
    ResolveDialerCycleButtonMethod "styleGetProperty" o = Gtk.Widget.WidgetStyleGetPropertyMethodInfo
    ResolveDialerCycleButtonMethod "syncActionProperties" o = Gtk.Activatable.ActivatableSyncActionPropertiesMethodInfo
    ResolveDialerCycleButtonMethod "thawChildNotify" o = Gtk.Widget.WidgetThawChildNotifyMethodInfo
    ResolveDialerCycleButtonMethod "thawNotify" o = GObject.Object.ObjectThawNotifyMethodInfo
    ResolveDialerCycleButtonMethod "translateCoordinates" o = Gtk.Widget.WidgetTranslateCoordinatesMethodInfo
    ResolveDialerCycleButtonMethod "triggerTooltipQuery" o = Gtk.Widget.WidgetTriggerTooltipQueryMethodInfo
    ResolveDialerCycleButtonMethod "unmap" o = Gtk.Widget.WidgetUnmapMethodInfo
    ResolveDialerCycleButtonMethod "unparent" o = Gtk.Widget.WidgetUnparentMethodInfo
    ResolveDialerCycleButtonMethod "unrealize" o = Gtk.Widget.WidgetUnrealizeMethodInfo
    ResolveDialerCycleButtonMethod "unref" o = GObject.Object.ObjectUnrefMethodInfo
    ResolveDialerCycleButtonMethod "unregisterWindow" o = Gtk.Widget.WidgetUnregisterWindowMethodInfo
    ResolveDialerCycleButtonMethod "unsetFocusChain" o = Gtk.Container.ContainerUnsetFocusChainMethodInfo
    ResolveDialerCycleButtonMethod "unsetStateFlags" o = Gtk.Widget.WidgetUnsetStateFlagsMethodInfo
    ResolveDialerCycleButtonMethod "watchClosure" o = GObject.Object.ObjectWatchClosureMethodInfo
    ResolveDialerCycleButtonMethod "getAccessible" o = Gtk.Widget.WidgetGetAccessibleMethodInfo
    ResolveDialerCycleButtonMethod "getActionGroup" o = Gtk.Widget.WidgetGetActionGroupMethodInfo
    ResolveDialerCycleButtonMethod "getActionName" o = Gtk.Actionable.ActionableGetActionNameMethodInfo
    ResolveDialerCycleButtonMethod "getActionTargetValue" o = Gtk.Actionable.ActionableGetActionTargetValueMethodInfo
    ResolveDialerCycleButtonMethod "getAlignment" o = Gtk.Button.ButtonGetAlignmentMethodInfo
    ResolveDialerCycleButtonMethod "getAllocatedBaseline" o = Gtk.Widget.WidgetGetAllocatedBaselineMethodInfo
    ResolveDialerCycleButtonMethod "getAllocatedHeight" o = Gtk.Widget.WidgetGetAllocatedHeightMethodInfo
    ResolveDialerCycleButtonMethod "getAllocatedSize" o = Gtk.Widget.WidgetGetAllocatedSizeMethodInfo
    ResolveDialerCycleButtonMethod "getAllocatedWidth" o = Gtk.Widget.WidgetGetAllocatedWidthMethodInfo
    ResolveDialerCycleButtonMethod "getAllocation" o = Gtk.Widget.WidgetGetAllocationMethodInfo
    ResolveDialerCycleButtonMethod "getAlwaysShowImage" o = Gtk.Button.ButtonGetAlwaysShowImageMethodInfo
    ResolveDialerCycleButtonMethod "getAncestor" o = Gtk.Widget.WidgetGetAncestorMethodInfo
    ResolveDialerCycleButtonMethod "getAppPaintable" o = Gtk.Widget.WidgetGetAppPaintableMethodInfo
    ResolveDialerCycleButtonMethod "getBorderWidth" o = Gtk.Container.ContainerGetBorderWidthMethodInfo
    ResolveDialerCycleButtonMethod "getCanDefault" o = Gtk.Widget.WidgetGetCanDefaultMethodInfo
    ResolveDialerCycleButtonMethod "getCanFocus" o = Gtk.Widget.WidgetGetCanFocusMethodInfo
    ResolveDialerCycleButtonMethod "getChild" o = Gtk.Bin.BinGetChildMethodInfo
    ResolveDialerCycleButtonMethod "getChildRequisition" o = Gtk.Widget.WidgetGetChildRequisitionMethodInfo
    ResolveDialerCycleButtonMethod "getChildVisible" o = Gtk.Widget.WidgetGetChildVisibleMethodInfo
    ResolveDialerCycleButtonMethod "getChildren" o = Gtk.Container.ContainerGetChildrenMethodInfo
    ResolveDialerCycleButtonMethod "getClip" o = Gtk.Widget.WidgetGetClipMethodInfo
    ResolveDialerCycleButtonMethod "getClipboard" o = Gtk.Widget.WidgetGetClipboardMethodInfo
    ResolveDialerCycleButtonMethod "getCompositeName" o = Gtk.Widget.WidgetGetCompositeNameMethodInfo
    ResolveDialerCycleButtonMethod "getCurrentSymbol" o = DialerCycleButtonGetCurrentSymbolMethodInfo
    ResolveDialerCycleButtonMethod "getCycleTimeout" o = DialerCycleButtonGetCycleTimeoutMethodInfo
    ResolveDialerCycleButtonMethod "getData" o = GObject.Object.ObjectGetDataMethodInfo
    ResolveDialerCycleButtonMethod "getDeviceEnabled" o = Gtk.Widget.WidgetGetDeviceEnabledMethodInfo
    ResolveDialerCycleButtonMethod "getDeviceEvents" o = Gtk.Widget.WidgetGetDeviceEventsMethodInfo
    ResolveDialerCycleButtonMethod "getDigit" o = Handy.DialerButton.DialerButtonGetDigitMethodInfo
    ResolveDialerCycleButtonMethod "getDirection" o = Gtk.Widget.WidgetGetDirectionMethodInfo
    ResolveDialerCycleButtonMethod "getDisplay" o = Gtk.Widget.WidgetGetDisplayMethodInfo
    ResolveDialerCycleButtonMethod "getDoubleBuffered" o = Gtk.Widget.WidgetGetDoubleBufferedMethodInfo
    ResolveDialerCycleButtonMethod "getEventWindow" o = Gtk.Button.ButtonGetEventWindowMethodInfo
    ResolveDialerCycleButtonMethod "getEvents" o = Gtk.Widget.WidgetGetEventsMethodInfo
    ResolveDialerCycleButtonMethod "getFocusChain" o = Gtk.Container.ContainerGetFocusChainMethodInfo
    ResolveDialerCycleButtonMethod "getFocusChild" o = Gtk.Container.ContainerGetFocusChildMethodInfo
    ResolveDialerCycleButtonMethod "getFocusHadjustment" o = Gtk.Container.ContainerGetFocusHadjustmentMethodInfo
    ResolveDialerCycleButtonMethod "getFocusOnClick" o = Gtk.Button.ButtonGetFocusOnClickMethodInfo
    ResolveDialerCycleButtonMethod "getFocusVadjustment" o = Gtk.Container.ContainerGetFocusVadjustmentMethodInfo
    ResolveDialerCycleButtonMethod "getFontMap" o = Gtk.Widget.WidgetGetFontMapMethodInfo
    ResolveDialerCycleButtonMethod "getFontOptions" o = Gtk.Widget.WidgetGetFontOptionsMethodInfo
    ResolveDialerCycleButtonMethod "getFrameClock" o = Gtk.Widget.WidgetGetFrameClockMethodInfo
    ResolveDialerCycleButtonMethod "getHalign" o = Gtk.Widget.WidgetGetHalignMethodInfo
    ResolveDialerCycleButtonMethod "getHasTooltip" o = Gtk.Widget.WidgetGetHasTooltipMethodInfo
    ResolveDialerCycleButtonMethod "getHasWindow" o = Gtk.Widget.WidgetGetHasWindowMethodInfo
    ResolveDialerCycleButtonMethod "getHexpand" o = Gtk.Widget.WidgetGetHexpandMethodInfo
    ResolveDialerCycleButtonMethod "getHexpandSet" o = Gtk.Widget.WidgetGetHexpandSetMethodInfo
    ResolveDialerCycleButtonMethod "getImage" o = Gtk.Button.ButtonGetImageMethodInfo
    ResolveDialerCycleButtonMethod "getImagePosition" o = Gtk.Button.ButtonGetImagePositionMethodInfo
    ResolveDialerCycleButtonMethod "getInternalChild" o = Gtk.Buildable.BuildableGetInternalChildMethodInfo
    ResolveDialerCycleButtonMethod "getLabel" o = Gtk.Button.ButtonGetLabelMethodInfo
    ResolveDialerCycleButtonMethod "getMapped" o = Gtk.Widget.WidgetGetMappedMethodInfo
    ResolveDialerCycleButtonMethod "getMarginBottom" o = Gtk.Widget.WidgetGetMarginBottomMethodInfo
    ResolveDialerCycleButtonMethod "getMarginEnd" o = Gtk.Widget.WidgetGetMarginEndMethodInfo
    ResolveDialerCycleButtonMethod "getMarginLeft" o = Gtk.Widget.WidgetGetMarginLeftMethodInfo
    ResolveDialerCycleButtonMethod "getMarginRight" o = Gtk.Widget.WidgetGetMarginRightMethodInfo
    ResolveDialerCycleButtonMethod "getMarginStart" o = Gtk.Widget.WidgetGetMarginStartMethodInfo
    ResolveDialerCycleButtonMethod "getMarginTop" o = Gtk.Widget.WidgetGetMarginTopMethodInfo
    ResolveDialerCycleButtonMethod "getModifierMask" o = Gtk.Widget.WidgetGetModifierMaskMethodInfo
    ResolveDialerCycleButtonMethod "getModifierStyle" o = Gtk.Widget.WidgetGetModifierStyleMethodInfo
    ResolveDialerCycleButtonMethod "getName" o = Gtk.Widget.WidgetGetNameMethodInfo
    ResolveDialerCycleButtonMethod "getNoShowAll" o = Gtk.Widget.WidgetGetNoShowAllMethodInfo
    ResolveDialerCycleButtonMethod "getOpacity" o = Gtk.Widget.WidgetGetOpacityMethodInfo
    ResolveDialerCycleButtonMethod "getPangoContext" o = Gtk.Widget.WidgetGetPangoContextMethodInfo
    ResolveDialerCycleButtonMethod "getParent" o = Gtk.Widget.WidgetGetParentMethodInfo
    ResolveDialerCycleButtonMethod "getParentWindow" o = Gtk.Widget.WidgetGetParentWindowMethodInfo
    ResolveDialerCycleButtonMethod "getPath" o = Gtk.Widget.WidgetGetPathMethodInfo
    ResolveDialerCycleButtonMethod "getPathForChild" o = Gtk.Container.ContainerGetPathForChildMethodInfo
    ResolveDialerCycleButtonMethod "getPointer" o = Gtk.Widget.WidgetGetPointerMethodInfo
    ResolveDialerCycleButtonMethod "getPreferredHeight" o = Gtk.Widget.WidgetGetPreferredHeightMethodInfo
    ResolveDialerCycleButtonMethod "getPreferredHeightAndBaselineForWidth" o = Gtk.Widget.WidgetGetPreferredHeightAndBaselineForWidthMethodInfo
    ResolveDialerCycleButtonMethod "getPreferredHeightForWidth" o = Gtk.Widget.WidgetGetPreferredHeightForWidthMethodInfo
    ResolveDialerCycleButtonMethod "getPreferredSize" o = Gtk.Widget.WidgetGetPreferredSizeMethodInfo
    ResolveDialerCycleButtonMethod "getPreferredWidth" o = Gtk.Widget.WidgetGetPreferredWidthMethodInfo
    ResolveDialerCycleButtonMethod "getPreferredWidthForHeight" o = Gtk.Widget.WidgetGetPreferredWidthForHeightMethodInfo
    ResolveDialerCycleButtonMethod "getProperty" o = GObject.Object.ObjectGetPropertyMethodInfo
    ResolveDialerCycleButtonMethod "getQdata" o = GObject.Object.ObjectGetQdataMethodInfo
    ResolveDialerCycleButtonMethod "getRealized" o = Gtk.Widget.WidgetGetRealizedMethodInfo
    ResolveDialerCycleButtonMethod "getReceivesDefault" o = Gtk.Widget.WidgetGetReceivesDefaultMethodInfo
    ResolveDialerCycleButtonMethod "getRelatedAction" o = Gtk.Activatable.ActivatableGetRelatedActionMethodInfo
    ResolveDialerCycleButtonMethod "getRelief" o = Gtk.Button.ButtonGetReliefMethodInfo
    ResolveDialerCycleButtonMethod "getRequestMode" o = Gtk.Widget.WidgetGetRequestModeMethodInfo
    ResolveDialerCycleButtonMethod "getRequisition" o = Gtk.Widget.WidgetGetRequisitionMethodInfo
    ResolveDialerCycleButtonMethod "getResizeMode" o = Gtk.Container.ContainerGetResizeModeMethodInfo
    ResolveDialerCycleButtonMethod "getRootWindow" o = Gtk.Widget.WidgetGetRootWindowMethodInfo
    ResolveDialerCycleButtonMethod "getScaleFactor" o = Gtk.Widget.WidgetGetScaleFactorMethodInfo
    ResolveDialerCycleButtonMethod "getScreen" o = Gtk.Widget.WidgetGetScreenMethodInfo
    ResolveDialerCycleButtonMethod "getSensitive" o = Gtk.Widget.WidgetGetSensitiveMethodInfo
    ResolveDialerCycleButtonMethod "getSettings" o = Gtk.Widget.WidgetGetSettingsMethodInfo
    ResolveDialerCycleButtonMethod "getSizeRequest" o = Gtk.Widget.WidgetGetSizeRequestMethodInfo
    ResolveDialerCycleButtonMethod "getState" o = Gtk.Widget.WidgetGetStateMethodInfo
    ResolveDialerCycleButtonMethod "getStateFlags" o = Gtk.Widget.WidgetGetStateFlagsMethodInfo
    ResolveDialerCycleButtonMethod "getStyle" o = Gtk.Widget.WidgetGetStyleMethodInfo
    ResolveDialerCycleButtonMethod "getStyleContext" o = Gtk.Widget.WidgetGetStyleContextMethodInfo
    ResolveDialerCycleButtonMethod "getSupportMultidevice" o = Gtk.Widget.WidgetGetSupportMultideviceMethodInfo
    ResolveDialerCycleButtonMethod "getSymbols" o = Handy.DialerButton.DialerButtonGetSymbolsMethodInfo
    ResolveDialerCycleButtonMethod "getTemplateChild" o = Gtk.Widget.WidgetGetTemplateChildMethodInfo
    ResolveDialerCycleButtonMethod "getTooltipMarkup" o = Gtk.Widget.WidgetGetTooltipMarkupMethodInfo
    ResolveDialerCycleButtonMethod "getTooltipText" o = Gtk.Widget.WidgetGetTooltipTextMethodInfo
    ResolveDialerCycleButtonMethod "getTooltipWindow" o = Gtk.Widget.WidgetGetTooltipWindowMethodInfo
    ResolveDialerCycleButtonMethod "getToplevel" o = Gtk.Widget.WidgetGetToplevelMethodInfo
    ResolveDialerCycleButtonMethod "getUseActionAppearance" o = Gtk.Activatable.ActivatableGetUseActionAppearanceMethodInfo
    ResolveDialerCycleButtonMethod "getUseStock" o = Gtk.Button.ButtonGetUseStockMethodInfo
    ResolveDialerCycleButtonMethod "getUseUnderline" o = Gtk.Button.ButtonGetUseUnderlineMethodInfo
    ResolveDialerCycleButtonMethod "getValign" o = Gtk.Widget.WidgetGetValignMethodInfo
    ResolveDialerCycleButtonMethod "getValignWithBaseline" o = Gtk.Widget.WidgetGetValignWithBaselineMethodInfo
    ResolveDialerCycleButtonMethod "getVexpand" o = Gtk.Widget.WidgetGetVexpandMethodInfo
    ResolveDialerCycleButtonMethod "getVexpandSet" o = Gtk.Widget.WidgetGetVexpandSetMethodInfo
    ResolveDialerCycleButtonMethod "getVisible" o = Gtk.Widget.WidgetGetVisibleMethodInfo
    ResolveDialerCycleButtonMethod "getVisual" o = Gtk.Widget.WidgetGetVisualMethodInfo
    ResolveDialerCycleButtonMethod "getWindow" o = Gtk.Widget.WidgetGetWindowMethodInfo
    ResolveDialerCycleButtonMethod "setAccelPath" o = Gtk.Widget.WidgetSetAccelPathMethodInfo
    ResolveDialerCycleButtonMethod "setActionName" o = Gtk.Actionable.ActionableSetActionNameMethodInfo
    ResolveDialerCycleButtonMethod "setActionTargetValue" o = Gtk.Actionable.ActionableSetActionTargetValueMethodInfo
    ResolveDialerCycleButtonMethod "setAlignment" o = Gtk.Button.ButtonSetAlignmentMethodInfo
    ResolveDialerCycleButtonMethod "setAllocation" o = Gtk.Widget.WidgetSetAllocationMethodInfo
    ResolveDialerCycleButtonMethod "setAlwaysShowImage" o = Gtk.Button.ButtonSetAlwaysShowImageMethodInfo
    ResolveDialerCycleButtonMethod "setAppPaintable" o = Gtk.Widget.WidgetSetAppPaintableMethodInfo
    ResolveDialerCycleButtonMethod "setBorderWidth" o = Gtk.Container.ContainerSetBorderWidthMethodInfo
    ResolveDialerCycleButtonMethod "setBuildableProperty" o = Gtk.Buildable.BuildableSetBuildablePropertyMethodInfo
    ResolveDialerCycleButtonMethod "setCanDefault" o = Gtk.Widget.WidgetSetCanDefaultMethodInfo
    ResolveDialerCycleButtonMethod "setCanFocus" o = Gtk.Widget.WidgetSetCanFocusMethodInfo
    ResolveDialerCycleButtonMethod "setChildVisible" o = Gtk.Widget.WidgetSetChildVisibleMethodInfo
    ResolveDialerCycleButtonMethod "setClip" o = Gtk.Widget.WidgetSetClipMethodInfo
    ResolveDialerCycleButtonMethod "setCompositeName" o = Gtk.Widget.WidgetSetCompositeNameMethodInfo
    ResolveDialerCycleButtonMethod "setCycleTimeout" o = DialerCycleButtonSetCycleTimeoutMethodInfo
    ResolveDialerCycleButtonMethod "setData" o = GObject.Object.ObjectSetDataMethodInfo
    ResolveDialerCycleButtonMethod "setDetailedActionName" o = Gtk.Actionable.ActionableSetDetailedActionNameMethodInfo
    ResolveDialerCycleButtonMethod "setDeviceEnabled" o = Gtk.Widget.WidgetSetDeviceEnabledMethodInfo
    ResolveDialerCycleButtonMethod "setDeviceEvents" o = Gtk.Widget.WidgetSetDeviceEventsMethodInfo
    ResolveDialerCycleButtonMethod "setDirection" o = Gtk.Widget.WidgetSetDirectionMethodInfo
    ResolveDialerCycleButtonMethod "setDoubleBuffered" o = Gtk.Widget.WidgetSetDoubleBufferedMethodInfo
    ResolveDialerCycleButtonMethod "setEvents" o = Gtk.Widget.WidgetSetEventsMethodInfo
    ResolveDialerCycleButtonMethod "setFocusChain" o = Gtk.Container.ContainerSetFocusChainMethodInfo
    ResolveDialerCycleButtonMethod "setFocusChild" o = Gtk.Container.ContainerSetFocusChildMethodInfo
    ResolveDialerCycleButtonMethod "setFocusHadjustment" o = Gtk.Container.ContainerSetFocusHadjustmentMethodInfo
    ResolveDialerCycleButtonMethod "setFocusOnClick" o = Gtk.Button.ButtonSetFocusOnClickMethodInfo
    ResolveDialerCycleButtonMethod "setFocusVadjustment" o = Gtk.Container.ContainerSetFocusVadjustmentMethodInfo
    ResolveDialerCycleButtonMethod "setFontMap" o = Gtk.Widget.WidgetSetFontMapMethodInfo
    ResolveDialerCycleButtonMethod "setFontOptions" o = Gtk.Widget.WidgetSetFontOptionsMethodInfo
    ResolveDialerCycleButtonMethod "setHalign" o = Gtk.Widget.WidgetSetHalignMethodInfo
    ResolveDialerCycleButtonMethod "setHasTooltip" o = Gtk.Widget.WidgetSetHasTooltipMethodInfo
    ResolveDialerCycleButtonMethod "setHasWindow" o = Gtk.Widget.WidgetSetHasWindowMethodInfo
    ResolveDialerCycleButtonMethod "setHexpand" o = Gtk.Widget.WidgetSetHexpandMethodInfo
    ResolveDialerCycleButtonMethod "setHexpandSet" o = Gtk.Widget.WidgetSetHexpandSetMethodInfo
    ResolveDialerCycleButtonMethod "setImage" o = Gtk.Button.ButtonSetImageMethodInfo
    ResolveDialerCycleButtonMethod "setImagePosition" o = Gtk.Button.ButtonSetImagePositionMethodInfo
    ResolveDialerCycleButtonMethod "setLabel" o = Gtk.Button.ButtonSetLabelMethodInfo
    ResolveDialerCycleButtonMethod "setMapped" o = Gtk.Widget.WidgetSetMappedMethodInfo
    ResolveDialerCycleButtonMethod "setMarginBottom" o = Gtk.Widget.WidgetSetMarginBottomMethodInfo
    ResolveDialerCycleButtonMethod "setMarginEnd" o = Gtk.Widget.WidgetSetMarginEndMethodInfo
    ResolveDialerCycleButtonMethod "setMarginLeft" o = Gtk.Widget.WidgetSetMarginLeftMethodInfo
    ResolveDialerCycleButtonMethod "setMarginRight" o = Gtk.Widget.WidgetSetMarginRightMethodInfo
    ResolveDialerCycleButtonMethod "setMarginStart" o = Gtk.Widget.WidgetSetMarginStartMethodInfo
    ResolveDialerCycleButtonMethod "setMarginTop" o = Gtk.Widget.WidgetSetMarginTopMethodInfo
    ResolveDialerCycleButtonMethod "setName" o = Gtk.Widget.WidgetSetNameMethodInfo
    ResolveDialerCycleButtonMethod "setNoShowAll" o = Gtk.Widget.WidgetSetNoShowAllMethodInfo
    ResolveDialerCycleButtonMethod "setOpacity" o = Gtk.Widget.WidgetSetOpacityMethodInfo
    ResolveDialerCycleButtonMethod "setParent" o = Gtk.Widget.WidgetSetParentMethodInfo
    ResolveDialerCycleButtonMethod "setParentWindow" o = Gtk.Widget.WidgetSetParentWindowMethodInfo
    ResolveDialerCycleButtonMethod "setProperty" o = GObject.Object.ObjectSetPropertyMethodInfo
    ResolveDialerCycleButtonMethod "setRealized" o = Gtk.Widget.WidgetSetRealizedMethodInfo
    ResolveDialerCycleButtonMethod "setReallocateRedraws" o = Gtk.Container.ContainerSetReallocateRedrawsMethodInfo
    ResolveDialerCycleButtonMethod "setReceivesDefault" o = Gtk.Widget.WidgetSetReceivesDefaultMethodInfo
    ResolveDialerCycleButtonMethod "setRedrawOnAllocate" o = Gtk.Widget.WidgetSetRedrawOnAllocateMethodInfo
    ResolveDialerCycleButtonMethod "setRelatedAction" o = Gtk.Activatable.ActivatableSetRelatedActionMethodInfo
    ResolveDialerCycleButtonMethod "setRelief" o = Gtk.Button.ButtonSetReliefMethodInfo
    ResolveDialerCycleButtonMethod "setResizeMode" o = Gtk.Container.ContainerSetResizeModeMethodInfo
    ResolveDialerCycleButtonMethod "setSensitive" o = Gtk.Widget.WidgetSetSensitiveMethodInfo
    ResolveDialerCycleButtonMethod "setSizeRequest" o = Gtk.Widget.WidgetSetSizeRequestMethodInfo
    ResolveDialerCycleButtonMethod "setState" o = Gtk.Widget.WidgetSetStateMethodInfo
    ResolveDialerCycleButtonMethod "setStateFlags" o = Gtk.Widget.WidgetSetStateFlagsMethodInfo
    ResolveDialerCycleButtonMethod "setStyle" o = Gtk.Widget.WidgetSetStyleMethodInfo
    ResolveDialerCycleButtonMethod "setSupportMultidevice" o = Gtk.Widget.WidgetSetSupportMultideviceMethodInfo
    ResolveDialerCycleButtonMethod "setTooltipMarkup" o = Gtk.Widget.WidgetSetTooltipMarkupMethodInfo
    ResolveDialerCycleButtonMethod "setTooltipText" o = Gtk.Widget.WidgetSetTooltipTextMethodInfo
    ResolveDialerCycleButtonMethod "setTooltipWindow" o = Gtk.Widget.WidgetSetTooltipWindowMethodInfo
    ResolveDialerCycleButtonMethod "setUseActionAppearance" o = Gtk.Activatable.ActivatableSetUseActionAppearanceMethodInfo
    ResolveDialerCycleButtonMethod "setUseStock" o = Gtk.Button.ButtonSetUseStockMethodInfo
    ResolveDialerCycleButtonMethod "setUseUnderline" o = Gtk.Button.ButtonSetUseUnderlineMethodInfo
    ResolveDialerCycleButtonMethod "setValign" o = Gtk.Widget.WidgetSetValignMethodInfo
    ResolveDialerCycleButtonMethod "setVexpand" o = Gtk.Widget.WidgetSetVexpandMethodInfo
    ResolveDialerCycleButtonMethod "setVexpandSet" o = Gtk.Widget.WidgetSetVexpandSetMethodInfo
    ResolveDialerCycleButtonMethod "setVisible" o = Gtk.Widget.WidgetSetVisibleMethodInfo
    ResolveDialerCycleButtonMethod "setVisual" o = Gtk.Widget.WidgetSetVisualMethodInfo
    ResolveDialerCycleButtonMethod "setWindow" o = Gtk.Widget.WidgetSetWindowMethodInfo
    ResolveDialerCycleButtonMethod l o = O.MethodResolutionFailed l o

instance (info ~ ResolveDialerCycleButtonMethod t DialerCycleButton, O.MethodInfo info DialerCycleButton p) => OL.IsLabel t (DialerCycleButton -> p) where
#if MIN_VERSION_base(4,10,0)
    fromLabel = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#else
    fromLabel _ = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#endif

#endif

-- signal DialerCycleButton::cycle-end
{- |
This signal is emitted when the cycle ends. This can either be
because of timeout or because @/hdy_dialer_cycle_stop_cycle/@ got
called.
-}
type DialerCycleButtonCycleEndCallback =
    IO ()

-- | A convenience synonym for @`Nothing` :: `Maybe` `DialerCycleButtonCycleEndCallback`@.
noDialerCycleButtonCycleEndCallback :: Maybe DialerCycleButtonCycleEndCallback
noDialerCycleButtonCycleEndCallback = Nothing

-- | Type for the callback on the (unwrapped) C side.
type C_DialerCycleButtonCycleEndCallback =
    Ptr () ->                               -- object
    Ptr () ->                               -- user_data
    IO ()

-- | Generate a function pointer callable from C code, from a `C_DialerCycleButtonCycleEndCallback`.
foreign import ccall "wrapper"
    mk_DialerCycleButtonCycleEndCallback :: C_DialerCycleButtonCycleEndCallback -> IO (FunPtr C_DialerCycleButtonCycleEndCallback)

-- | Wrap the callback into a `GClosure`.
genClosure_DialerCycleButtonCycleEnd :: MonadIO m => DialerCycleButtonCycleEndCallback -> m (GClosure C_DialerCycleButtonCycleEndCallback)
genClosure_DialerCycleButtonCycleEnd cb = liftIO $ do
    let cb' = wrap_DialerCycleButtonCycleEndCallback cb
    mk_DialerCycleButtonCycleEndCallback cb' >>= B.GClosure.newGClosure


-- | Wrap a `DialerCycleButtonCycleEndCallback` into a `C_DialerCycleButtonCycleEndCallback`.
wrap_DialerCycleButtonCycleEndCallback ::
    DialerCycleButtonCycleEndCallback ->
    C_DialerCycleButtonCycleEndCallback
wrap_DialerCycleButtonCycleEndCallback _cb _ _ = do
    _cb 


{- |
Connect a signal handler for the “@cycle-end@” signal, to be run before the default handler.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Signals.on' dialerCycleButton #cycleEnd callback
@
-}
onDialerCycleButtonCycleEnd :: (IsDialerCycleButton a, MonadIO m) => a -> DialerCycleButtonCycleEndCallback -> m SignalHandlerId
onDialerCycleButtonCycleEnd obj cb = liftIO $ do
    let cb' = wrap_DialerCycleButtonCycleEndCallback cb
    cb'' <- mk_DialerCycleButtonCycleEndCallback cb'
    connectSignalFunPtr obj "cycle-end" cb'' SignalConnectBefore

{- |
Connect a signal handler for the “@cycle-end@” signal, to be run after the default handler.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Signals.after' dialerCycleButton #cycleEnd callback
@
-}
afterDialerCycleButtonCycleEnd :: (IsDialerCycleButton a, MonadIO m) => a -> DialerCycleButtonCycleEndCallback -> m SignalHandlerId
afterDialerCycleButtonCycleEnd obj cb = liftIO $ do
    let cb' = wrap_DialerCycleButtonCycleEndCallback cb
    cb'' <- mk_DialerCycleButtonCycleEndCallback cb'
    connectSignalFunPtr obj "cycle-end" cb'' SignalConnectAfter


-- signal DialerCycleButton::cycle-start
{- |
This signal is emitted when the button starts cycling (that is on
the first button press).
-}
type DialerCycleButtonCycleStartCallback =
    IO ()

-- | A convenience synonym for @`Nothing` :: `Maybe` `DialerCycleButtonCycleStartCallback`@.
noDialerCycleButtonCycleStartCallback :: Maybe DialerCycleButtonCycleStartCallback
noDialerCycleButtonCycleStartCallback = Nothing

-- | Type for the callback on the (unwrapped) C side.
type C_DialerCycleButtonCycleStartCallback =
    Ptr () ->                               -- object
    Ptr () ->                               -- user_data
    IO ()

-- | Generate a function pointer callable from C code, from a `C_DialerCycleButtonCycleStartCallback`.
foreign import ccall "wrapper"
    mk_DialerCycleButtonCycleStartCallback :: C_DialerCycleButtonCycleStartCallback -> IO (FunPtr C_DialerCycleButtonCycleStartCallback)

-- | Wrap the callback into a `GClosure`.
genClosure_DialerCycleButtonCycleStart :: MonadIO m => DialerCycleButtonCycleStartCallback -> m (GClosure C_DialerCycleButtonCycleStartCallback)
genClosure_DialerCycleButtonCycleStart cb = liftIO $ do
    let cb' = wrap_DialerCycleButtonCycleStartCallback cb
    mk_DialerCycleButtonCycleStartCallback cb' >>= B.GClosure.newGClosure


-- | Wrap a `DialerCycleButtonCycleStartCallback` into a `C_DialerCycleButtonCycleStartCallback`.
wrap_DialerCycleButtonCycleStartCallback ::
    DialerCycleButtonCycleStartCallback ->
    C_DialerCycleButtonCycleStartCallback
wrap_DialerCycleButtonCycleStartCallback _cb _ _ = do
    _cb 


{- |
Connect a signal handler for the “@cycle-start@” signal, to be run before the default handler.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Signals.on' dialerCycleButton #cycleStart callback
@
-}
onDialerCycleButtonCycleStart :: (IsDialerCycleButton a, MonadIO m) => a -> DialerCycleButtonCycleStartCallback -> m SignalHandlerId
onDialerCycleButtonCycleStart obj cb = liftIO $ do
    let cb' = wrap_DialerCycleButtonCycleStartCallback cb
    cb'' <- mk_DialerCycleButtonCycleStartCallback cb'
    connectSignalFunPtr obj "cycle-start" cb'' SignalConnectBefore

{- |
Connect a signal handler for the “@cycle-start@” signal, to be run after the default handler.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Signals.after' dialerCycleButton #cycleStart callback
@
-}
afterDialerCycleButtonCycleStart :: (IsDialerCycleButton a, MonadIO m) => a -> DialerCycleButtonCycleStartCallback -> m SignalHandlerId
afterDialerCycleButtonCycleStart obj cb = liftIO $ do
    let cb' = wrap_DialerCycleButtonCycleStartCallback cb
    cb'' <- mk_DialerCycleButtonCycleStartCallback cb'
    connectSignalFunPtr obj "cycle-start" cb'' SignalConnectAfter


-- VVV Prop "cycle-timeout"
   -- Type: TBasicType TInt
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]
   -- Nullable: (Just False,Just False)

{- |
Get the value of the “@cycle-timeout@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' dialerCycleButton #cycleTimeout
@
-}
getDialerCycleButtonCycleTimeout :: (MonadIO m, IsDialerCycleButton o) => o -> m Int32
getDialerCycleButtonCycleTimeout obj = liftIO $ B.Properties.getObjectPropertyInt32 obj "cycle-timeout"

{- |
Set the value of the “@cycle-timeout@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' dialerCycleButton [ #cycleTimeout 'Data.GI.Base.Attributes.:=' value ]
@
-}
setDialerCycleButtonCycleTimeout :: (MonadIO m, IsDialerCycleButton o) => o -> Int32 -> m ()
setDialerCycleButtonCycleTimeout obj val = liftIO $ B.Properties.setObjectPropertyInt32 obj "cycle-timeout" val

{- |
Construct a `GValueConstruct` with valid value for the “@cycle-timeout@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructDialerCycleButtonCycleTimeout :: (IsDialerCycleButton o) => Int32 -> IO (GValueConstruct o)
constructDialerCycleButtonCycleTimeout val = B.Properties.constructObjectPropertyInt32 "cycle-timeout" val

#if ENABLE_OVERLOADING
data DialerCycleButtonCycleTimeoutPropertyInfo
instance AttrInfo DialerCycleButtonCycleTimeoutPropertyInfo where
    type AttrAllowedOps DialerCycleButtonCycleTimeoutPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DialerCycleButtonCycleTimeoutPropertyInfo = (~) Int32
    type AttrBaseTypeConstraint DialerCycleButtonCycleTimeoutPropertyInfo = IsDialerCycleButton
    type AttrGetType DialerCycleButtonCycleTimeoutPropertyInfo = Int32
    type AttrLabel DialerCycleButtonCycleTimeoutPropertyInfo = "cycle-timeout"
    type AttrOrigin DialerCycleButtonCycleTimeoutPropertyInfo = DialerCycleButton
    attrGet _ = getDialerCycleButtonCycleTimeout
    attrSet _ = setDialerCycleButtonCycleTimeout
    attrConstruct _ = constructDialerCycleButtonCycleTimeout
    attrClear _ = undefined
#endif

#if ENABLE_OVERLOADING
instance O.HasAttributeList DialerCycleButton
type instance O.AttributeList DialerCycleButton = DialerCycleButtonAttributeList
type DialerCycleButtonAttributeList = ('[ '("actionName", Gtk.Actionable.ActionableActionNamePropertyInfo), '("actionTarget", Gtk.Actionable.ActionableActionTargetPropertyInfo), '("alwaysShowImage", Gtk.Button.ButtonAlwaysShowImagePropertyInfo), '("appPaintable", Gtk.Widget.WidgetAppPaintablePropertyInfo), '("borderWidth", Gtk.Container.ContainerBorderWidthPropertyInfo), '("canDefault", Gtk.Widget.WidgetCanDefaultPropertyInfo), '("canFocus", Gtk.Widget.WidgetCanFocusPropertyInfo), '("child", Gtk.Container.ContainerChildPropertyInfo), '("compositeChild", Gtk.Widget.WidgetCompositeChildPropertyInfo), '("cycleTimeout", DialerCycleButtonCycleTimeoutPropertyInfo), '("digit", Handy.DialerButton.DialerButtonDigitPropertyInfo), '("doubleBuffered", Gtk.Widget.WidgetDoubleBufferedPropertyInfo), '("events", Gtk.Widget.WidgetEventsPropertyInfo), '("expand", Gtk.Widget.WidgetExpandPropertyInfo), '("focusOnClick", Gtk.Widget.WidgetFocusOnClickPropertyInfo), '("halign", Gtk.Widget.WidgetHalignPropertyInfo), '("hasDefault", Gtk.Widget.WidgetHasDefaultPropertyInfo), '("hasFocus", Gtk.Widget.WidgetHasFocusPropertyInfo), '("hasTooltip", Gtk.Widget.WidgetHasTooltipPropertyInfo), '("heightRequest", Gtk.Widget.WidgetHeightRequestPropertyInfo), '("hexpand", Gtk.Widget.WidgetHexpandPropertyInfo), '("hexpandSet", Gtk.Widget.WidgetHexpandSetPropertyInfo), '("image", Gtk.Button.ButtonImagePropertyInfo), '("imagePosition", Gtk.Button.ButtonImagePositionPropertyInfo), '("isFocus", Gtk.Widget.WidgetIsFocusPropertyInfo), '("label", Gtk.Button.ButtonLabelPropertyInfo), '("margin", Gtk.Widget.WidgetMarginPropertyInfo), '("marginBottom", Gtk.Widget.WidgetMarginBottomPropertyInfo), '("marginEnd", Gtk.Widget.WidgetMarginEndPropertyInfo), '("marginLeft", Gtk.Widget.WidgetMarginLeftPropertyInfo), '("marginRight", Gtk.Widget.WidgetMarginRightPropertyInfo), '("marginStart", Gtk.Widget.WidgetMarginStartPropertyInfo), '("marginTop", Gtk.Widget.WidgetMarginTopPropertyInfo), '("name", Gtk.Widget.WidgetNamePropertyInfo), '("noShowAll", Gtk.Widget.WidgetNoShowAllPropertyInfo), '("opacity", Gtk.Widget.WidgetOpacityPropertyInfo), '("parent", Gtk.Widget.WidgetParentPropertyInfo), '("receivesDefault", Gtk.Widget.WidgetReceivesDefaultPropertyInfo), '("relatedAction", Gtk.Activatable.ActivatableRelatedActionPropertyInfo), '("relief", Gtk.Button.ButtonReliefPropertyInfo), '("resizeMode", Gtk.Container.ContainerResizeModePropertyInfo), '("scaleFactor", Gtk.Widget.WidgetScaleFactorPropertyInfo), '("sensitive", Gtk.Widget.WidgetSensitivePropertyInfo), '("style", Gtk.Widget.WidgetStylePropertyInfo), '("symbols", Handy.DialerButton.DialerButtonSymbolsPropertyInfo), '("tooltipMarkup", Gtk.Widget.WidgetTooltipMarkupPropertyInfo), '("tooltipText", Gtk.Widget.WidgetTooltipTextPropertyInfo), '("useActionAppearance", Gtk.Activatable.ActivatableUseActionAppearancePropertyInfo), '("useStock", Gtk.Button.ButtonUseStockPropertyInfo), '("useUnderline", Gtk.Button.ButtonUseUnderlinePropertyInfo), '("valign", Gtk.Widget.WidgetValignPropertyInfo), '("vexpand", Gtk.Widget.WidgetVexpandPropertyInfo), '("vexpandSet", Gtk.Widget.WidgetVexpandSetPropertyInfo), '("visible", Gtk.Widget.WidgetVisiblePropertyInfo), '("widthRequest", Gtk.Widget.WidgetWidthRequestPropertyInfo), '("window", Gtk.Widget.WidgetWindowPropertyInfo), '("xalign", Gtk.Button.ButtonXalignPropertyInfo), '("yalign", Gtk.Button.ButtonYalignPropertyInfo)] :: [(Symbol, *)])
#endif

#if ENABLE_OVERLOADING
dialerCycleButtonCycleTimeout :: AttrLabelProxy "cycleTimeout"
dialerCycleButtonCycleTimeout = AttrLabelProxy

#endif

#if ENABLE_OVERLOADING
data DialerCycleButtonCycleEndSignalInfo
instance SignalInfo DialerCycleButtonCycleEndSignalInfo where
    type HaskellCallbackType DialerCycleButtonCycleEndSignalInfo = DialerCycleButtonCycleEndCallback
    connectSignal _ obj cb connectMode = do
        let cb' = wrap_DialerCycleButtonCycleEndCallback cb
        cb'' <- mk_DialerCycleButtonCycleEndCallback cb'
        connectSignalFunPtr obj "cycle-end" cb'' connectMode

data DialerCycleButtonCycleStartSignalInfo
instance SignalInfo DialerCycleButtonCycleStartSignalInfo where
    type HaskellCallbackType DialerCycleButtonCycleStartSignalInfo = DialerCycleButtonCycleStartCallback
    connectSignal _ obj cb connectMode = do
        let cb' = wrap_DialerCycleButtonCycleStartCallback cb
        cb'' <- mk_DialerCycleButtonCycleStartCallback cb'
        connectSignalFunPtr obj "cycle-start" cb'' connectMode

type instance O.SignalList DialerCycleButton = DialerCycleButtonSignalList
type DialerCycleButtonSignalList = ('[ '("accelClosuresChanged", Gtk.Widget.WidgetAccelClosuresChangedSignalInfo), '("activate", Gtk.Button.ButtonActivateSignalInfo), '("add", Gtk.Container.ContainerAddSignalInfo), '("buttonPressEvent", Gtk.Widget.WidgetButtonPressEventSignalInfo), '("buttonReleaseEvent", Gtk.Widget.WidgetButtonReleaseEventSignalInfo), '("canActivateAccel", Gtk.Widget.WidgetCanActivateAccelSignalInfo), '("checkResize", Gtk.Container.ContainerCheckResizeSignalInfo), '("childNotify", Gtk.Widget.WidgetChildNotifySignalInfo), '("clicked", Gtk.Button.ButtonClickedSignalInfo), '("compositedChanged", Gtk.Widget.WidgetCompositedChangedSignalInfo), '("configureEvent", Gtk.Widget.WidgetConfigureEventSignalInfo), '("cycleEnd", DialerCycleButtonCycleEndSignalInfo), '("cycleStart", DialerCycleButtonCycleStartSignalInfo), '("damageEvent", Gtk.Widget.WidgetDamageEventSignalInfo), '("deleteEvent", Gtk.Widget.WidgetDeleteEventSignalInfo), '("destroy", Gtk.Widget.WidgetDestroySignalInfo), '("destroyEvent", Gtk.Widget.WidgetDestroyEventSignalInfo), '("directionChanged", Gtk.Widget.WidgetDirectionChangedSignalInfo), '("dragBegin", Gtk.Widget.WidgetDragBeginSignalInfo), '("dragDataDelete", Gtk.Widget.WidgetDragDataDeleteSignalInfo), '("dragDataGet", Gtk.Widget.WidgetDragDataGetSignalInfo), '("dragDataReceived", Gtk.Widget.WidgetDragDataReceivedSignalInfo), '("dragDrop", Gtk.Widget.WidgetDragDropSignalInfo), '("dragEnd", Gtk.Widget.WidgetDragEndSignalInfo), '("dragFailed", Gtk.Widget.WidgetDragFailedSignalInfo), '("dragLeave", Gtk.Widget.WidgetDragLeaveSignalInfo), '("dragMotion", Gtk.Widget.WidgetDragMotionSignalInfo), '("draw", Gtk.Widget.WidgetDrawSignalInfo), '("enter", Gtk.Button.ButtonEnterSignalInfo), '("enterNotifyEvent", Gtk.Widget.WidgetEnterNotifyEventSignalInfo), '("event", Gtk.Widget.WidgetEventSignalInfo), '("eventAfter", Gtk.Widget.WidgetEventAfterSignalInfo), '("focus", Gtk.Widget.WidgetFocusSignalInfo), '("focusInEvent", Gtk.Widget.WidgetFocusInEventSignalInfo), '("focusOutEvent", Gtk.Widget.WidgetFocusOutEventSignalInfo), '("grabBrokenEvent", Gtk.Widget.WidgetGrabBrokenEventSignalInfo), '("grabFocus", Gtk.Widget.WidgetGrabFocusSignalInfo), '("grabNotify", Gtk.Widget.WidgetGrabNotifySignalInfo), '("hide", Gtk.Widget.WidgetHideSignalInfo), '("hierarchyChanged", Gtk.Widget.WidgetHierarchyChangedSignalInfo), '("keyPressEvent", Gtk.Widget.WidgetKeyPressEventSignalInfo), '("keyReleaseEvent", Gtk.Widget.WidgetKeyReleaseEventSignalInfo), '("keynavFailed", Gtk.Widget.WidgetKeynavFailedSignalInfo), '("leave", Gtk.Button.ButtonLeaveSignalInfo), '("leaveNotifyEvent", Gtk.Widget.WidgetLeaveNotifyEventSignalInfo), '("map", Gtk.Widget.WidgetMapSignalInfo), '("mapEvent", Gtk.Widget.WidgetMapEventSignalInfo), '("mnemonicActivate", Gtk.Widget.WidgetMnemonicActivateSignalInfo), '("motionNotifyEvent", Gtk.Widget.WidgetMotionNotifyEventSignalInfo), '("moveFocus", Gtk.Widget.WidgetMoveFocusSignalInfo), '("notify", GObject.Object.ObjectNotifySignalInfo), '("parentSet", Gtk.Widget.WidgetParentSetSignalInfo), '("popupMenu", Gtk.Widget.WidgetPopupMenuSignalInfo), '("pressed", Gtk.Button.ButtonPressedSignalInfo), '("propertyNotifyEvent", Gtk.Widget.WidgetPropertyNotifyEventSignalInfo), '("proximityInEvent", Gtk.Widget.WidgetProximityInEventSignalInfo), '("proximityOutEvent", Gtk.Widget.WidgetProximityOutEventSignalInfo), '("queryTooltip", Gtk.Widget.WidgetQueryTooltipSignalInfo), '("realize", Gtk.Widget.WidgetRealizeSignalInfo), '("released", Gtk.Button.ButtonReleasedSignalInfo), '("remove", Gtk.Container.ContainerRemoveSignalInfo), '("screenChanged", Gtk.Widget.WidgetScreenChangedSignalInfo), '("scrollEvent", Gtk.Widget.WidgetScrollEventSignalInfo), '("selectionClearEvent", Gtk.Widget.WidgetSelectionClearEventSignalInfo), '("selectionGet", Gtk.Widget.WidgetSelectionGetSignalInfo), '("selectionNotifyEvent", Gtk.Widget.WidgetSelectionNotifyEventSignalInfo), '("selectionReceived", Gtk.Widget.WidgetSelectionReceivedSignalInfo), '("selectionRequestEvent", Gtk.Widget.WidgetSelectionRequestEventSignalInfo), '("setFocusChild", Gtk.Container.ContainerSetFocusChildSignalInfo), '("show", Gtk.Widget.WidgetShowSignalInfo), '("showHelp", Gtk.Widget.WidgetShowHelpSignalInfo), '("sizeAllocate", Gtk.Widget.WidgetSizeAllocateSignalInfo), '("stateChanged", Gtk.Widget.WidgetStateChangedSignalInfo), '("stateFlagsChanged", Gtk.Widget.WidgetStateFlagsChangedSignalInfo), '("styleSet", Gtk.Widget.WidgetStyleSetSignalInfo), '("styleUpdated", Gtk.Widget.WidgetStyleUpdatedSignalInfo), '("touchEvent", Gtk.Widget.WidgetTouchEventSignalInfo), '("unmap", Gtk.Widget.WidgetUnmapSignalInfo), '("unmapEvent", Gtk.Widget.WidgetUnmapEventSignalInfo), '("unrealize", Gtk.Widget.WidgetUnrealizeSignalInfo), '("visibilityNotifyEvent", Gtk.Widget.WidgetVisibilityNotifyEventSignalInfo), '("windowStateEvent", Gtk.Widget.WidgetWindowStateEventSignalInfo)] :: [(Symbol, *)])

#endif

-- method DialerCycleButton::new
-- method type : Constructor
-- Args : [Arg {argCName = "symbols", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "the symbols displayed on the #HdyDialerCycleButton", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "Handy", name = "DialerCycleButton"}))
-- throws : False
-- Skip return : False

foreign import ccall "hdy_dialer_cycle_button_new" hdy_dialer_cycle_button_new :: 
    CString ->                              -- symbols : TBasicType TUTF8
    IO (Ptr DialerCycleButton)

{- |
Create a new 'GI.Handy.Objects.DialerCycleButton.DialerCycleButton' which displays /@symbols@/. The
symbols can by cycled through by pressing the button multiple
times.
-}
dialerCycleButtonNew ::
    (B.CallStack.HasCallStack, MonadIO m) =>
    T.Text
    {- ^ /@symbols@/: the symbols displayed on the 'GI.Handy.Objects.DialerCycleButton.DialerCycleButton' -}
    -> m DialerCycleButton
    {- ^ __Returns:__ the newly created 'GI.Handy.Objects.DialerCycleButton.DialerCycleButton' widget -}
dialerCycleButtonNew symbols = liftIO $ do
    symbols' <- textToCString symbols
    result <- hdy_dialer_cycle_button_new symbols'
    checkUnexpectedReturnNULL "dialerCycleButtonNew" result
    result' <- (newObject DialerCycleButton) result
    freeMem symbols'
    return result'

#if ENABLE_OVERLOADING
#endif

-- method DialerCycleButton::get_current_symbol
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "Handy", name = "DialerCycleButton"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #HdyDialerCycleButton", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TUniChar)
-- throws : False
-- Skip return : False

foreign import ccall "hdy_dialer_cycle_button_get_current_symbol" hdy_dialer_cycle_button_get_current_symbol :: 
    Ptr DialerCycleButton ->                -- self : TInterface (Name {namespace = "Handy", name = "DialerCycleButton"})
    IO CInt

{- |
Get the symbol the dialer should display
-}
dialerCycleButtonGetCurrentSymbol ::
    (B.CallStack.HasCallStack, MonadIO m, IsDialerCycleButton a) =>
    a
    {- ^ /@self@/: a 'GI.Handy.Objects.DialerCycleButton.DialerCycleButton' -}
    -> m Char
    {- ^ __Returns:__ a pointer to the symbol -}
dialerCycleButtonGetCurrentSymbol self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- hdy_dialer_cycle_button_get_current_symbol self'
    let result' = (chr . fromIntegral) result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DialerCycleButtonGetCurrentSymbolMethodInfo
instance (signature ~ (m Char), MonadIO m, IsDialerCycleButton a) => O.MethodInfo DialerCycleButtonGetCurrentSymbolMethodInfo a signature where
    overloadedMethod _ = dialerCycleButtonGetCurrentSymbol

#endif

-- method DialerCycleButton::get_cycle_timeout
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "Handy", name = "DialerCycleButton"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #HdyDialerCycleButton", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TInt)
-- throws : False
-- Skip return : False

foreign import ccall "hdy_dialer_cycle_button_get_cycle_timeout" hdy_dialer_cycle_button_get_cycle_timeout :: 
    Ptr DialerCycleButton ->                -- self : TInterface (Name {namespace = "Handy", name = "DialerCycleButton"})
    IO Int32

{- |
Get the cycle timeout in milliseconds.
-}
dialerCycleButtonGetCycleTimeout ::
    (B.CallStack.HasCallStack, MonadIO m, IsDialerCycleButton a) =>
    a
    {- ^ /@self@/: a 'GI.Handy.Objects.DialerCycleButton.DialerCycleButton' -}
    -> m Int32
dialerCycleButtonGetCycleTimeout self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- hdy_dialer_cycle_button_get_cycle_timeout self'
    touchManagedPtr self
    return result

#if ENABLE_OVERLOADING
data DialerCycleButtonGetCycleTimeoutMethodInfo
instance (signature ~ (m Int32), MonadIO m, IsDialerCycleButton a) => O.MethodInfo DialerCycleButtonGetCycleTimeoutMethodInfo a signature where
    overloadedMethod _ = dialerCycleButtonGetCycleTimeout

#endif

-- method DialerCycleButton::is_cycling
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "Handy", name = "DialerCycleButton"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #HdyDialerCycleButton", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TBoolean)
-- throws : False
-- Skip return : False

foreign import ccall "hdy_dialer_cycle_button_is_cycling" hdy_dialer_cycle_button_is_cycling :: 
    Ptr DialerCycleButton ->                -- self : TInterface (Name {namespace = "Handy", name = "DialerCycleButton"})
    IO CInt

{- |
Check whether the button is in cycling mode.
-}
dialerCycleButtonIsCycling ::
    (B.CallStack.HasCallStack, MonadIO m, IsDialerCycleButton a) =>
    a
    {- ^ /@self@/: a 'GI.Handy.Objects.DialerCycleButton.DialerCycleButton' -}
    -> m Bool
    {- ^ __Returns:__ @/TRUE/@ if the in cycling mode otherwise @/FALSE/@ -}
dialerCycleButtonIsCycling self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- hdy_dialer_cycle_button_is_cycling self'
    let result' = (/= 0) result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data DialerCycleButtonIsCyclingMethodInfo
instance (signature ~ (m Bool), MonadIO m, IsDialerCycleButton a) => O.MethodInfo DialerCycleButtonIsCyclingMethodInfo a signature where
    overloadedMethod _ = dialerCycleButtonIsCycling

#endif

-- method DialerCycleButton::set_cycle_timeout
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "Handy", name = "DialerCycleButton"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #HdyDialerCycleButton", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "timeout", argType = TBasicType TInt, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "the timeout in milliseconds", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "hdy_dialer_cycle_button_set_cycle_timeout" hdy_dialer_cycle_button_set_cycle_timeout :: 
    Ptr DialerCycleButton ->                -- self : TInterface (Name {namespace = "Handy", name = "DialerCycleButton"})
    Int32 ->                                -- timeout : TBasicType TInt
    IO ()

{- |
Set the cycle timeout in milliseconds.
-}
dialerCycleButtonSetCycleTimeout ::
    (B.CallStack.HasCallStack, MonadIO m, IsDialerCycleButton a) =>
    a
    {- ^ /@self@/: a 'GI.Handy.Objects.DialerCycleButton.DialerCycleButton' -}
    -> Int32
    {- ^ /@timeout@/: the timeout in milliseconds -}
    -> m ()
dialerCycleButtonSetCycleTimeout self timeout = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    hdy_dialer_cycle_button_set_cycle_timeout self' timeout
    touchManagedPtr self
    return ()

#if ENABLE_OVERLOADING
data DialerCycleButtonSetCycleTimeoutMethodInfo
instance (signature ~ (Int32 -> m ()), MonadIO m, IsDialerCycleButton a) => O.MethodInfo DialerCycleButtonSetCycleTimeoutMethodInfo a signature where
    overloadedMethod _ = dialerCycleButtonSetCycleTimeout

#endif

-- method DialerCycleButton::stop_cycle
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "Handy", name = "DialerCycleButton"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #HdyDialerCycleButton", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "hdy_dialer_cycle_button_stop_cycle" hdy_dialer_cycle_button_stop_cycle :: 
    Ptr DialerCycleButton ->                -- self : TInterface (Name {namespace = "Handy", name = "DialerCycleButton"})
    IO ()

{- |
Stop the cycling mode.
-}
dialerCycleButtonStopCycle ::
    (B.CallStack.HasCallStack, MonadIO m, IsDialerCycleButton a) =>
    a
    {- ^ /@self@/: a 'GI.Handy.Objects.DialerCycleButton.DialerCycleButton' -}
    -> m ()
dialerCycleButtonStopCycle self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    hdy_dialer_cycle_button_stop_cycle self'
    touchManagedPtr self
    return ()

#if ENABLE_OVERLOADING
data DialerCycleButtonStopCycleMethodInfo
instance (signature ~ (m ()), MonadIO m, IsDialerCycleButton a) => O.MethodInfo DialerCycleButtonStopCycleMethodInfo a signature where
    overloadedMethod _ = dialerCycleButtonStopCycle

#endif


