

{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (inaki@blueleaf.cc)

/No description available in the introspection data./
-}

#define ENABLE_OVERLOADING (MIN_VERSION_haskell_gi_overloading(1,0,0) \
       && !defined(__HADDOCK_VERSION__))

module GI.Handy.Objects.ExpanderRow
    ( 

-- * Exported types
    ExpanderRow(..)                         ,
    IsExpanderRow                           ,
    toExpanderRow                           ,
    noExpanderRow                           ,


 -- * Methods
-- ** getEnableExpansion #method:getEnableExpansion#

#if ENABLE_OVERLOADING
    ExpanderRowGetEnableExpansionMethodInfo ,
#endif
    expanderRowGetEnableExpansion           ,


-- ** getExpanded #method:getExpanded#

#if ENABLE_OVERLOADING
    ExpanderRowGetExpandedMethodInfo        ,
#endif
    expanderRowGetExpanded                  ,


-- ** getShowEnableSwitch #method:getShowEnableSwitch#

#if ENABLE_OVERLOADING
    ExpanderRowGetShowEnableSwitchMethodInfo,
#endif
    expanderRowGetShowEnableSwitch          ,


-- ** new #method:new#

    expanderRowNew                          ,


-- ** setEnableExpansion #method:setEnableExpansion#

#if ENABLE_OVERLOADING
    ExpanderRowSetEnableExpansionMethodInfo ,
#endif
    expanderRowSetEnableExpansion           ,


-- ** setExpanded #method:setExpanded#

#if ENABLE_OVERLOADING
    ExpanderRowSetExpandedMethodInfo        ,
#endif
    expanderRowSetExpanded                  ,


-- ** setShowEnableSwitch #method:setShowEnableSwitch#

#if ENABLE_OVERLOADING
    ExpanderRowSetShowEnableSwitchMethodInfo,
#endif
    expanderRowSetShowEnableSwitch          ,




 -- * Properties
-- ** enableExpansion #attr:enableExpansion#
{- | 'True' if the expansion is enabled.
-}
#if ENABLE_OVERLOADING
    ExpanderRowEnableExpansionPropertyInfo  ,
#endif
    constructExpanderRowEnableExpansion     ,
#if ENABLE_OVERLOADING
    expanderRowEnableExpansion              ,
#endif
    getExpanderRowEnableExpansion           ,
    setExpanderRowEnableExpansion           ,


-- ** expanded #attr:expanded#
{- | 'True' if the row is expanded.
-}
#if ENABLE_OVERLOADING
    ExpanderRowExpandedPropertyInfo         ,
#endif
    constructExpanderRowExpanded            ,
#if ENABLE_OVERLOADING
    expanderRowExpanded                     ,
#endif
    getExpanderRowExpanded                  ,
    setExpanderRowExpanded                  ,


-- ** showEnableSwitch #attr:showEnableSwitch#
{- | 'True' if the switch enabling the expansion is visible.
-}
#if ENABLE_OVERLOADING
    ExpanderRowShowEnableSwitchPropertyInfo ,
#endif
    constructExpanderRowShowEnableSwitch    ,
#if ENABLE_OVERLOADING
    expanderRowShowEnableSwitch             ,
#endif
    getExpanderRowShowEnableSwitch          ,
    setExpanderRowShowEnableSwitch          ,




    ) where

import Data.GI.Base.ShortPrelude
import qualified Data.GI.Base.ShortPrelude as SP
import qualified Data.GI.Base.Overloading as O
import qualified Prelude as P

import qualified Data.GI.Base.Attributes as GI.Attributes
import qualified Data.GI.Base.ManagedPtr as B.ManagedPtr
import qualified Data.GI.Base.GClosure as B.GClosure
import qualified Data.GI.Base.GError as B.GError
import qualified Data.GI.Base.GVariant as B.GVariant
import qualified Data.GI.Base.GValue as B.GValue
import qualified Data.GI.Base.GParamSpec as B.GParamSpec
import qualified Data.GI.Base.CallStack as B.CallStack
import qualified Data.GI.Base.Properties as B.Properties
import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map
import qualified Foreign.Ptr as FP
import qualified GHC.OverloadedLabels as OL

import qualified GI.Atk.Interfaces.ImplementorIface as Atk.ImplementorIface
import qualified GI.GObject.Objects.Object as GObject.Object
import qualified GI.Gtk.Interfaces.Actionable as Gtk.Actionable
import qualified GI.Gtk.Interfaces.Buildable as Gtk.Buildable
import qualified GI.Gtk.Objects.Bin as Gtk.Bin
import qualified GI.Gtk.Objects.Container as Gtk.Container
import qualified GI.Gtk.Objects.ListBoxRow as Gtk.ListBoxRow
import qualified GI.Gtk.Objects.Widget as Gtk.Widget
import {-# SOURCE #-} qualified GI.Handy.Objects.ActionRow as Handy.ActionRow

-- | Memory-managed wrapper type.
newtype ExpanderRow = ExpanderRow (ManagedPtr ExpanderRow)
foreign import ccall "hdy_expander_row_get_type"
    c_hdy_expander_row_get_type :: IO GType

instance GObject ExpanderRow where
    gobjectType = c_hdy_expander_row_get_type
    

-- | Type class for types which can be safely cast to `ExpanderRow`, for instance with `toExpanderRow`.
class (GObject o, O.IsDescendantOf ExpanderRow o) => IsExpanderRow o
instance (GObject o, O.IsDescendantOf ExpanderRow o) => IsExpanderRow o

instance O.HasParentTypes ExpanderRow
type instance O.ParentTypes ExpanderRow = '[Handy.ActionRow.ActionRow, Gtk.ListBoxRow.ListBoxRow, Gtk.Bin.Bin, Gtk.Container.Container, Gtk.Widget.Widget, GObject.Object.Object, Atk.ImplementorIface.ImplementorIface, Gtk.Actionable.Actionable, Gtk.Buildable.Buildable]

-- | Cast to `ExpanderRow`, for types for which this is known to be safe. For general casts, use `Data.GI.Base.ManagedPtr.castTo`.
toExpanderRow :: (MonadIO m, IsExpanderRow o) => o -> m ExpanderRow
toExpanderRow = liftIO . unsafeCastTo ExpanderRow

-- | A convenience alias for `Nothing` :: `Maybe` `ExpanderRow`.
noExpanderRow :: Maybe ExpanderRow
noExpanderRow = Nothing

#if ENABLE_OVERLOADING
type family ResolveExpanderRowMethod (t :: Symbol) (o :: *) :: * where
    ResolveExpanderRowMethod "activate" o = Handy.ActionRow.ActionRowActivateMethodInfo
    ResolveExpanderRowMethod "add" o = Gtk.Container.ContainerAddMethodInfo
    ResolveExpanderRowMethod "addAccelerator" o = Gtk.Widget.WidgetAddAcceleratorMethodInfo
    ResolveExpanderRowMethod "addAction" o = Handy.ActionRow.ActionRowAddActionMethodInfo
    ResolveExpanderRowMethod "addChild" o = Gtk.Buildable.BuildableAddChildMethodInfo
    ResolveExpanderRowMethod "addDeviceEvents" o = Gtk.Widget.WidgetAddDeviceEventsMethodInfo
    ResolveExpanderRowMethod "addEvents" o = Gtk.Widget.WidgetAddEventsMethodInfo
    ResolveExpanderRowMethod "addMnemonicLabel" o = Gtk.Widget.WidgetAddMnemonicLabelMethodInfo
    ResolveExpanderRowMethod "addPrefix" o = Handy.ActionRow.ActionRowAddPrefixMethodInfo
    ResolveExpanderRowMethod "addTickCallback" o = Gtk.Widget.WidgetAddTickCallbackMethodInfo
    ResolveExpanderRowMethod "bindProperty" o = GObject.Object.ObjectBindPropertyMethodInfo
    ResolveExpanderRowMethod "bindPropertyFull" o = GObject.Object.ObjectBindPropertyFullMethodInfo
    ResolveExpanderRowMethod "canActivateAccel" o = Gtk.Widget.WidgetCanActivateAccelMethodInfo
    ResolveExpanderRowMethod "changed" o = Gtk.ListBoxRow.ListBoxRowChangedMethodInfo
    ResolveExpanderRowMethod "checkResize" o = Gtk.Container.ContainerCheckResizeMethodInfo
    ResolveExpanderRowMethod "childFocus" o = Gtk.Widget.WidgetChildFocusMethodInfo
    ResolveExpanderRowMethod "childGetProperty" o = Gtk.Container.ContainerChildGetPropertyMethodInfo
    ResolveExpanderRowMethod "childNotify" o = Gtk.Container.ContainerChildNotifyMethodInfo
    ResolveExpanderRowMethod "childNotifyByPspec" o = Gtk.Container.ContainerChildNotifyByPspecMethodInfo
    ResolveExpanderRowMethod "childSetProperty" o = Gtk.Container.ContainerChildSetPropertyMethodInfo
    ResolveExpanderRowMethod "childType" o = Gtk.Container.ContainerChildTypeMethodInfo
    ResolveExpanderRowMethod "classPath" o = Gtk.Widget.WidgetClassPathMethodInfo
    ResolveExpanderRowMethod "computeExpand" o = Gtk.Widget.WidgetComputeExpandMethodInfo
    ResolveExpanderRowMethod "constructChild" o = Gtk.Buildable.BuildableConstructChildMethodInfo
    ResolveExpanderRowMethod "createPangoContext" o = Gtk.Widget.WidgetCreatePangoContextMethodInfo
    ResolveExpanderRowMethod "createPangoLayout" o = Gtk.Widget.WidgetCreatePangoLayoutMethodInfo
    ResolveExpanderRowMethod "customFinished" o = Gtk.Buildable.BuildableCustomFinishedMethodInfo
    ResolveExpanderRowMethod "customTagEnd" o = Gtk.Buildable.BuildableCustomTagEndMethodInfo
    ResolveExpanderRowMethod "customTagStart" o = Gtk.Buildable.BuildableCustomTagStartMethodInfo
    ResolveExpanderRowMethod "destroy" o = Gtk.Widget.WidgetDestroyMethodInfo
    ResolveExpanderRowMethod "destroyed" o = Gtk.Widget.WidgetDestroyedMethodInfo
    ResolveExpanderRowMethod "deviceIsShadowed" o = Gtk.Widget.WidgetDeviceIsShadowedMethodInfo
    ResolveExpanderRowMethod "dragBegin" o = Gtk.Widget.WidgetDragBeginMethodInfo
    ResolveExpanderRowMethod "dragBeginWithCoordinates" o = Gtk.Widget.WidgetDragBeginWithCoordinatesMethodInfo
    ResolveExpanderRowMethod "dragCheckThreshold" o = Gtk.Widget.WidgetDragCheckThresholdMethodInfo
    ResolveExpanderRowMethod "dragDestAddImageTargets" o = Gtk.Widget.WidgetDragDestAddImageTargetsMethodInfo
    ResolveExpanderRowMethod "dragDestAddTextTargets" o = Gtk.Widget.WidgetDragDestAddTextTargetsMethodInfo
    ResolveExpanderRowMethod "dragDestAddUriTargets" o = Gtk.Widget.WidgetDragDestAddUriTargetsMethodInfo
    ResolveExpanderRowMethod "dragDestFindTarget" o = Gtk.Widget.WidgetDragDestFindTargetMethodInfo
    ResolveExpanderRowMethod "dragDestGetTargetList" o = Gtk.Widget.WidgetDragDestGetTargetListMethodInfo
    ResolveExpanderRowMethod "dragDestGetTrackMotion" o = Gtk.Widget.WidgetDragDestGetTrackMotionMethodInfo
    ResolveExpanderRowMethod "dragDestSet" o = Gtk.Widget.WidgetDragDestSetMethodInfo
    ResolveExpanderRowMethod "dragDestSetProxy" o = Gtk.Widget.WidgetDragDestSetProxyMethodInfo
    ResolveExpanderRowMethod "dragDestSetTargetList" o = Gtk.Widget.WidgetDragDestSetTargetListMethodInfo
    ResolveExpanderRowMethod "dragDestSetTrackMotion" o = Gtk.Widget.WidgetDragDestSetTrackMotionMethodInfo
    ResolveExpanderRowMethod "dragDestUnset" o = Gtk.Widget.WidgetDragDestUnsetMethodInfo
    ResolveExpanderRowMethod "dragGetData" o = Gtk.Widget.WidgetDragGetDataMethodInfo
    ResolveExpanderRowMethod "dragHighlight" o = Gtk.Widget.WidgetDragHighlightMethodInfo
    ResolveExpanderRowMethod "dragSourceAddImageTargets" o = Gtk.Widget.WidgetDragSourceAddImageTargetsMethodInfo
    ResolveExpanderRowMethod "dragSourceAddTextTargets" o = Gtk.Widget.WidgetDragSourceAddTextTargetsMethodInfo
    ResolveExpanderRowMethod "dragSourceAddUriTargets" o = Gtk.Widget.WidgetDragSourceAddUriTargetsMethodInfo
    ResolveExpanderRowMethod "dragSourceGetTargetList" o = Gtk.Widget.WidgetDragSourceGetTargetListMethodInfo
    ResolveExpanderRowMethod "dragSourceSet" o = Gtk.Widget.WidgetDragSourceSetMethodInfo
    ResolveExpanderRowMethod "dragSourceSetIconGicon" o = Gtk.Widget.WidgetDragSourceSetIconGiconMethodInfo
    ResolveExpanderRowMethod "dragSourceSetIconName" o = Gtk.Widget.WidgetDragSourceSetIconNameMethodInfo
    ResolveExpanderRowMethod "dragSourceSetIconPixbuf" o = Gtk.Widget.WidgetDragSourceSetIconPixbufMethodInfo
    ResolveExpanderRowMethod "dragSourceSetIconStock" o = Gtk.Widget.WidgetDragSourceSetIconStockMethodInfo
    ResolveExpanderRowMethod "dragSourceSetTargetList" o = Gtk.Widget.WidgetDragSourceSetTargetListMethodInfo
    ResolveExpanderRowMethod "dragSourceUnset" o = Gtk.Widget.WidgetDragSourceUnsetMethodInfo
    ResolveExpanderRowMethod "dragUnhighlight" o = Gtk.Widget.WidgetDragUnhighlightMethodInfo
    ResolveExpanderRowMethod "draw" o = Gtk.Widget.WidgetDrawMethodInfo
    ResolveExpanderRowMethod "ensureStyle" o = Gtk.Widget.WidgetEnsureStyleMethodInfo
    ResolveExpanderRowMethod "errorBell" o = Gtk.Widget.WidgetErrorBellMethodInfo
    ResolveExpanderRowMethod "event" o = Gtk.Widget.WidgetEventMethodInfo
    ResolveExpanderRowMethod "forall" o = Gtk.Container.ContainerForallMethodInfo
    ResolveExpanderRowMethod "forceFloating" o = GObject.Object.ObjectForceFloatingMethodInfo
    ResolveExpanderRowMethod "foreach" o = Gtk.Container.ContainerForeachMethodInfo
    ResolveExpanderRowMethod "freezeChildNotify" o = Gtk.Widget.WidgetFreezeChildNotifyMethodInfo
    ResolveExpanderRowMethod "freezeNotify" o = GObject.Object.ObjectFreezeNotifyMethodInfo
    ResolveExpanderRowMethod "getv" o = GObject.Object.ObjectGetvMethodInfo
    ResolveExpanderRowMethod "grabAdd" o = Gtk.Widget.WidgetGrabAddMethodInfo
    ResolveExpanderRowMethod "grabDefault" o = Gtk.Widget.WidgetGrabDefaultMethodInfo
    ResolveExpanderRowMethod "grabFocus" o = Gtk.Widget.WidgetGrabFocusMethodInfo
    ResolveExpanderRowMethod "grabRemove" o = Gtk.Widget.WidgetGrabRemoveMethodInfo
    ResolveExpanderRowMethod "hasDefault" o = Gtk.Widget.WidgetHasDefaultMethodInfo
    ResolveExpanderRowMethod "hasFocus" o = Gtk.Widget.WidgetHasFocusMethodInfo
    ResolveExpanderRowMethod "hasGrab" o = Gtk.Widget.WidgetHasGrabMethodInfo
    ResolveExpanderRowMethod "hasRcStyle" o = Gtk.Widget.WidgetHasRcStyleMethodInfo
    ResolveExpanderRowMethod "hasScreen" o = Gtk.Widget.WidgetHasScreenMethodInfo
    ResolveExpanderRowMethod "hasVisibleFocus" o = Gtk.Widget.WidgetHasVisibleFocusMethodInfo
    ResolveExpanderRowMethod "hide" o = Gtk.Widget.WidgetHideMethodInfo
    ResolveExpanderRowMethod "hideOnDelete" o = Gtk.Widget.WidgetHideOnDeleteMethodInfo
    ResolveExpanderRowMethod "inDestruction" o = Gtk.Widget.WidgetInDestructionMethodInfo
    ResolveExpanderRowMethod "initTemplate" o = Gtk.Widget.WidgetInitTemplateMethodInfo
    ResolveExpanderRowMethod "inputShapeCombineRegion" o = Gtk.Widget.WidgetInputShapeCombineRegionMethodInfo
    ResolveExpanderRowMethod "insertActionGroup" o = Gtk.Widget.WidgetInsertActionGroupMethodInfo
    ResolveExpanderRowMethod "intersect" o = Gtk.Widget.WidgetIntersectMethodInfo
    ResolveExpanderRowMethod "isAncestor" o = Gtk.Widget.WidgetIsAncestorMethodInfo
    ResolveExpanderRowMethod "isComposited" o = Gtk.Widget.WidgetIsCompositedMethodInfo
    ResolveExpanderRowMethod "isDrawable" o = Gtk.Widget.WidgetIsDrawableMethodInfo
    ResolveExpanderRowMethod "isFloating" o = GObject.Object.ObjectIsFloatingMethodInfo
    ResolveExpanderRowMethod "isFocus" o = Gtk.Widget.WidgetIsFocusMethodInfo
    ResolveExpanderRowMethod "isSelected" o = Gtk.ListBoxRow.ListBoxRowIsSelectedMethodInfo
    ResolveExpanderRowMethod "isSensitive" o = Gtk.Widget.WidgetIsSensitiveMethodInfo
    ResolveExpanderRowMethod "isToplevel" o = Gtk.Widget.WidgetIsToplevelMethodInfo
    ResolveExpanderRowMethod "isVisible" o = Gtk.Widget.WidgetIsVisibleMethodInfo
    ResolveExpanderRowMethod "keynavFailed" o = Gtk.Widget.WidgetKeynavFailedMethodInfo
    ResolveExpanderRowMethod "listAccelClosures" o = Gtk.Widget.WidgetListAccelClosuresMethodInfo
    ResolveExpanderRowMethod "listActionPrefixes" o = Gtk.Widget.WidgetListActionPrefixesMethodInfo
    ResolveExpanderRowMethod "listMnemonicLabels" o = Gtk.Widget.WidgetListMnemonicLabelsMethodInfo
    ResolveExpanderRowMethod "map" o = Gtk.Widget.WidgetMapMethodInfo
    ResolveExpanderRowMethod "mnemonicActivate" o = Gtk.Widget.WidgetMnemonicActivateMethodInfo
    ResolveExpanderRowMethod "modifyBase" o = Gtk.Widget.WidgetModifyBaseMethodInfo
    ResolveExpanderRowMethod "modifyBg" o = Gtk.Widget.WidgetModifyBgMethodInfo
    ResolveExpanderRowMethod "modifyCursor" o = Gtk.Widget.WidgetModifyCursorMethodInfo
    ResolveExpanderRowMethod "modifyFg" o = Gtk.Widget.WidgetModifyFgMethodInfo
    ResolveExpanderRowMethod "modifyFont" o = Gtk.Widget.WidgetModifyFontMethodInfo
    ResolveExpanderRowMethod "modifyStyle" o = Gtk.Widget.WidgetModifyStyleMethodInfo
    ResolveExpanderRowMethod "modifyText" o = Gtk.Widget.WidgetModifyTextMethodInfo
    ResolveExpanderRowMethod "notify" o = GObject.Object.ObjectNotifyMethodInfo
    ResolveExpanderRowMethod "notifyByPspec" o = GObject.Object.ObjectNotifyByPspecMethodInfo
    ResolveExpanderRowMethod "overrideBackgroundColor" o = Gtk.Widget.WidgetOverrideBackgroundColorMethodInfo
    ResolveExpanderRowMethod "overrideColor" o = Gtk.Widget.WidgetOverrideColorMethodInfo
    ResolveExpanderRowMethod "overrideCursor" o = Gtk.Widget.WidgetOverrideCursorMethodInfo
    ResolveExpanderRowMethod "overrideFont" o = Gtk.Widget.WidgetOverrideFontMethodInfo
    ResolveExpanderRowMethod "overrideSymbolicColor" o = Gtk.Widget.WidgetOverrideSymbolicColorMethodInfo
    ResolveExpanderRowMethod "parserFinished" o = Gtk.Buildable.BuildableParserFinishedMethodInfo
    ResolveExpanderRowMethod "path" o = Gtk.Widget.WidgetPathMethodInfo
    ResolveExpanderRowMethod "propagateDraw" o = Gtk.Container.ContainerPropagateDrawMethodInfo
    ResolveExpanderRowMethod "queueAllocate" o = Gtk.Widget.WidgetQueueAllocateMethodInfo
    ResolveExpanderRowMethod "queueComputeExpand" o = Gtk.Widget.WidgetQueueComputeExpandMethodInfo
    ResolveExpanderRowMethod "queueDraw" o = Gtk.Widget.WidgetQueueDrawMethodInfo
    ResolveExpanderRowMethod "queueDrawArea" o = Gtk.Widget.WidgetQueueDrawAreaMethodInfo
    ResolveExpanderRowMethod "queueDrawRegion" o = Gtk.Widget.WidgetQueueDrawRegionMethodInfo
    ResolveExpanderRowMethod "queueResize" o = Gtk.Widget.WidgetQueueResizeMethodInfo
    ResolveExpanderRowMethod "queueResizeNoRedraw" o = Gtk.Widget.WidgetQueueResizeNoRedrawMethodInfo
    ResolveExpanderRowMethod "realize" o = Gtk.Widget.WidgetRealizeMethodInfo
    ResolveExpanderRowMethod "ref" o = GObject.Object.ObjectRefMethodInfo
    ResolveExpanderRowMethod "refSink" o = GObject.Object.ObjectRefSinkMethodInfo
    ResolveExpanderRowMethod "regionIntersect" o = Gtk.Widget.WidgetRegionIntersectMethodInfo
    ResolveExpanderRowMethod "registerWindow" o = Gtk.Widget.WidgetRegisterWindowMethodInfo
    ResolveExpanderRowMethod "remove" o = Gtk.Container.ContainerRemoveMethodInfo
    ResolveExpanderRowMethod "removeAccelerator" o = Gtk.Widget.WidgetRemoveAcceleratorMethodInfo
    ResolveExpanderRowMethod "removeMnemonicLabel" o = Gtk.Widget.WidgetRemoveMnemonicLabelMethodInfo
    ResolveExpanderRowMethod "removeTickCallback" o = Gtk.Widget.WidgetRemoveTickCallbackMethodInfo
    ResolveExpanderRowMethod "renderIcon" o = Gtk.Widget.WidgetRenderIconMethodInfo
    ResolveExpanderRowMethod "renderIconPixbuf" o = Gtk.Widget.WidgetRenderIconPixbufMethodInfo
    ResolveExpanderRowMethod "reparent" o = Gtk.Widget.WidgetReparentMethodInfo
    ResolveExpanderRowMethod "resetRcStyles" o = Gtk.Widget.WidgetResetRcStylesMethodInfo
    ResolveExpanderRowMethod "resetStyle" o = Gtk.Widget.WidgetResetStyleMethodInfo
    ResolveExpanderRowMethod "resizeChildren" o = Gtk.Container.ContainerResizeChildrenMethodInfo
    ResolveExpanderRowMethod "runDispose" o = GObject.Object.ObjectRunDisposeMethodInfo
    ResolveExpanderRowMethod "sendExpose" o = Gtk.Widget.WidgetSendExposeMethodInfo
    ResolveExpanderRowMethod "sendFocusChange" o = Gtk.Widget.WidgetSendFocusChangeMethodInfo
    ResolveExpanderRowMethod "shapeCombineRegion" o = Gtk.Widget.WidgetShapeCombineRegionMethodInfo
    ResolveExpanderRowMethod "show" o = Gtk.Widget.WidgetShowMethodInfo
    ResolveExpanderRowMethod "showAll" o = Gtk.Widget.WidgetShowAllMethodInfo
    ResolveExpanderRowMethod "showNow" o = Gtk.Widget.WidgetShowNowMethodInfo
    ResolveExpanderRowMethod "sizeAllocate" o = Gtk.Widget.WidgetSizeAllocateMethodInfo
    ResolveExpanderRowMethod "sizeAllocateWithBaseline" o = Gtk.Widget.WidgetSizeAllocateWithBaselineMethodInfo
    ResolveExpanderRowMethod "sizeRequest" o = Gtk.Widget.WidgetSizeRequestMethodInfo
    ResolveExpanderRowMethod "stealData" o = GObject.Object.ObjectStealDataMethodInfo
    ResolveExpanderRowMethod "stealQdata" o = GObject.Object.ObjectStealQdataMethodInfo
    ResolveExpanderRowMethod "styleAttach" o = Gtk.Widget.WidgetStyleAttachMethodInfo
    ResolveExpanderRowMethod "styleGetProperty" o = Gtk.Widget.WidgetStyleGetPropertyMethodInfo
    ResolveExpanderRowMethod "thawChildNotify" o = Gtk.Widget.WidgetThawChildNotifyMethodInfo
    ResolveExpanderRowMethod "thawNotify" o = GObject.Object.ObjectThawNotifyMethodInfo
    ResolveExpanderRowMethod "translateCoordinates" o = Gtk.Widget.WidgetTranslateCoordinatesMethodInfo
    ResolveExpanderRowMethod "triggerTooltipQuery" o = Gtk.Widget.WidgetTriggerTooltipQueryMethodInfo
    ResolveExpanderRowMethod "unmap" o = Gtk.Widget.WidgetUnmapMethodInfo
    ResolveExpanderRowMethod "unparent" o = Gtk.Widget.WidgetUnparentMethodInfo
    ResolveExpanderRowMethod "unrealize" o = Gtk.Widget.WidgetUnrealizeMethodInfo
    ResolveExpanderRowMethod "unref" o = GObject.Object.ObjectUnrefMethodInfo
    ResolveExpanderRowMethod "unregisterWindow" o = Gtk.Widget.WidgetUnregisterWindowMethodInfo
    ResolveExpanderRowMethod "unsetFocusChain" o = Gtk.Container.ContainerUnsetFocusChainMethodInfo
    ResolveExpanderRowMethod "unsetStateFlags" o = Gtk.Widget.WidgetUnsetStateFlagsMethodInfo
    ResolveExpanderRowMethod "watchClosure" o = GObject.Object.ObjectWatchClosureMethodInfo
    ResolveExpanderRowMethod "getAccessible" o = Gtk.Widget.WidgetGetAccessibleMethodInfo
    ResolveExpanderRowMethod "getActionGroup" o = Gtk.Widget.WidgetGetActionGroupMethodInfo
    ResolveExpanderRowMethod "getActionName" o = Gtk.Actionable.ActionableGetActionNameMethodInfo
    ResolveExpanderRowMethod "getActionTargetValue" o = Gtk.Actionable.ActionableGetActionTargetValueMethodInfo
    ResolveExpanderRowMethod "getActivatable" o = Gtk.ListBoxRow.ListBoxRowGetActivatableMethodInfo
    ResolveExpanderRowMethod "getActivatableWidget" o = Handy.ActionRow.ActionRowGetActivatableWidgetMethodInfo
    ResolveExpanderRowMethod "getAllocatedBaseline" o = Gtk.Widget.WidgetGetAllocatedBaselineMethodInfo
    ResolveExpanderRowMethod "getAllocatedHeight" o = Gtk.Widget.WidgetGetAllocatedHeightMethodInfo
    ResolveExpanderRowMethod "getAllocatedSize" o = Gtk.Widget.WidgetGetAllocatedSizeMethodInfo
    ResolveExpanderRowMethod "getAllocatedWidth" o = Gtk.Widget.WidgetGetAllocatedWidthMethodInfo
    ResolveExpanderRowMethod "getAllocation" o = Gtk.Widget.WidgetGetAllocationMethodInfo
    ResolveExpanderRowMethod "getAncestor" o = Gtk.Widget.WidgetGetAncestorMethodInfo
    ResolveExpanderRowMethod "getAppPaintable" o = Gtk.Widget.WidgetGetAppPaintableMethodInfo
    ResolveExpanderRowMethod "getBorderWidth" o = Gtk.Container.ContainerGetBorderWidthMethodInfo
    ResolveExpanderRowMethod "getCanDefault" o = Gtk.Widget.WidgetGetCanDefaultMethodInfo
    ResolveExpanderRowMethod "getCanFocus" o = Gtk.Widget.WidgetGetCanFocusMethodInfo
    ResolveExpanderRowMethod "getChild" o = Gtk.Bin.BinGetChildMethodInfo
    ResolveExpanderRowMethod "getChildRequisition" o = Gtk.Widget.WidgetGetChildRequisitionMethodInfo
    ResolveExpanderRowMethod "getChildVisible" o = Gtk.Widget.WidgetGetChildVisibleMethodInfo
    ResolveExpanderRowMethod "getChildren" o = Gtk.Container.ContainerGetChildrenMethodInfo
    ResolveExpanderRowMethod "getClip" o = Gtk.Widget.WidgetGetClipMethodInfo
    ResolveExpanderRowMethod "getClipboard" o = Gtk.Widget.WidgetGetClipboardMethodInfo
    ResolveExpanderRowMethod "getCompositeName" o = Gtk.Widget.WidgetGetCompositeNameMethodInfo
    ResolveExpanderRowMethod "getData" o = GObject.Object.ObjectGetDataMethodInfo
    ResolveExpanderRowMethod "getDeviceEnabled" o = Gtk.Widget.WidgetGetDeviceEnabledMethodInfo
    ResolveExpanderRowMethod "getDeviceEvents" o = Gtk.Widget.WidgetGetDeviceEventsMethodInfo
    ResolveExpanderRowMethod "getDirection" o = Gtk.Widget.WidgetGetDirectionMethodInfo
    ResolveExpanderRowMethod "getDisplay" o = Gtk.Widget.WidgetGetDisplayMethodInfo
    ResolveExpanderRowMethod "getDoubleBuffered" o = Gtk.Widget.WidgetGetDoubleBufferedMethodInfo
    ResolveExpanderRowMethod "getEnableExpansion" o = ExpanderRowGetEnableExpansionMethodInfo
    ResolveExpanderRowMethod "getEvents" o = Gtk.Widget.WidgetGetEventsMethodInfo
    ResolveExpanderRowMethod "getExpanded" o = ExpanderRowGetExpandedMethodInfo
    ResolveExpanderRowMethod "getFocusChain" o = Gtk.Container.ContainerGetFocusChainMethodInfo
    ResolveExpanderRowMethod "getFocusChild" o = Gtk.Container.ContainerGetFocusChildMethodInfo
    ResolveExpanderRowMethod "getFocusHadjustment" o = Gtk.Container.ContainerGetFocusHadjustmentMethodInfo
    ResolveExpanderRowMethod "getFocusOnClick" o = Gtk.Widget.WidgetGetFocusOnClickMethodInfo
    ResolveExpanderRowMethod "getFocusVadjustment" o = Gtk.Container.ContainerGetFocusVadjustmentMethodInfo
    ResolveExpanderRowMethod "getFontMap" o = Gtk.Widget.WidgetGetFontMapMethodInfo
    ResolveExpanderRowMethod "getFontOptions" o = Gtk.Widget.WidgetGetFontOptionsMethodInfo
    ResolveExpanderRowMethod "getFrameClock" o = Gtk.Widget.WidgetGetFrameClockMethodInfo
    ResolveExpanderRowMethod "getHalign" o = Gtk.Widget.WidgetGetHalignMethodInfo
    ResolveExpanderRowMethod "getHasTooltip" o = Gtk.Widget.WidgetGetHasTooltipMethodInfo
    ResolveExpanderRowMethod "getHasWindow" o = Gtk.Widget.WidgetGetHasWindowMethodInfo
    ResolveExpanderRowMethod "getHeader" o = Gtk.ListBoxRow.ListBoxRowGetHeaderMethodInfo
    ResolveExpanderRowMethod "getHexpand" o = Gtk.Widget.WidgetGetHexpandMethodInfo
    ResolveExpanderRowMethod "getHexpandSet" o = Gtk.Widget.WidgetGetHexpandSetMethodInfo
    ResolveExpanderRowMethod "getIconName" o = Handy.ActionRow.ActionRowGetIconNameMethodInfo
    ResolveExpanderRowMethod "getIndex" o = Gtk.ListBoxRow.ListBoxRowGetIndexMethodInfo
    ResolveExpanderRowMethod "getInternalChild" o = Gtk.Buildable.BuildableGetInternalChildMethodInfo
    ResolveExpanderRowMethod "getMapped" o = Gtk.Widget.WidgetGetMappedMethodInfo
    ResolveExpanderRowMethod "getMarginBottom" o = Gtk.Widget.WidgetGetMarginBottomMethodInfo
    ResolveExpanderRowMethod "getMarginEnd" o = Gtk.Widget.WidgetGetMarginEndMethodInfo
    ResolveExpanderRowMethod "getMarginLeft" o = Gtk.Widget.WidgetGetMarginLeftMethodInfo
    ResolveExpanderRowMethod "getMarginRight" o = Gtk.Widget.WidgetGetMarginRightMethodInfo
    ResolveExpanderRowMethod "getMarginStart" o = Gtk.Widget.WidgetGetMarginStartMethodInfo
    ResolveExpanderRowMethod "getMarginTop" o = Gtk.Widget.WidgetGetMarginTopMethodInfo
    ResolveExpanderRowMethod "getModifierMask" o = Gtk.Widget.WidgetGetModifierMaskMethodInfo
    ResolveExpanderRowMethod "getModifierStyle" o = Gtk.Widget.WidgetGetModifierStyleMethodInfo
    ResolveExpanderRowMethod "getName" o = Gtk.Widget.WidgetGetNameMethodInfo
    ResolveExpanderRowMethod "getNoShowAll" o = Gtk.Widget.WidgetGetNoShowAllMethodInfo
    ResolveExpanderRowMethod "getOpacity" o = Gtk.Widget.WidgetGetOpacityMethodInfo
    ResolveExpanderRowMethod "getPangoContext" o = Gtk.Widget.WidgetGetPangoContextMethodInfo
    ResolveExpanderRowMethod "getParent" o = Gtk.Widget.WidgetGetParentMethodInfo
    ResolveExpanderRowMethod "getParentWindow" o = Gtk.Widget.WidgetGetParentWindowMethodInfo
    ResolveExpanderRowMethod "getPath" o = Gtk.Widget.WidgetGetPathMethodInfo
    ResolveExpanderRowMethod "getPathForChild" o = Gtk.Container.ContainerGetPathForChildMethodInfo
    ResolveExpanderRowMethod "getPointer" o = Gtk.Widget.WidgetGetPointerMethodInfo
    ResolveExpanderRowMethod "getPreferredHeight" o = Gtk.Widget.WidgetGetPreferredHeightMethodInfo
    ResolveExpanderRowMethod "getPreferredHeightAndBaselineForWidth" o = Gtk.Widget.WidgetGetPreferredHeightAndBaselineForWidthMethodInfo
    ResolveExpanderRowMethod "getPreferredHeightForWidth" o = Gtk.Widget.WidgetGetPreferredHeightForWidthMethodInfo
    ResolveExpanderRowMethod "getPreferredSize" o = Gtk.Widget.WidgetGetPreferredSizeMethodInfo
    ResolveExpanderRowMethod "getPreferredWidth" o = Gtk.Widget.WidgetGetPreferredWidthMethodInfo
    ResolveExpanderRowMethod "getPreferredWidthForHeight" o = Gtk.Widget.WidgetGetPreferredWidthForHeightMethodInfo
    ResolveExpanderRowMethod "getProperty" o = GObject.Object.ObjectGetPropertyMethodInfo
    ResolveExpanderRowMethod "getQdata" o = GObject.Object.ObjectGetQdataMethodInfo
    ResolveExpanderRowMethod "getRealized" o = Gtk.Widget.WidgetGetRealizedMethodInfo
    ResolveExpanderRowMethod "getReceivesDefault" o = Gtk.Widget.WidgetGetReceivesDefaultMethodInfo
    ResolveExpanderRowMethod "getRequestMode" o = Gtk.Widget.WidgetGetRequestModeMethodInfo
    ResolveExpanderRowMethod "getRequisition" o = Gtk.Widget.WidgetGetRequisitionMethodInfo
    ResolveExpanderRowMethod "getResizeMode" o = Gtk.Container.ContainerGetResizeModeMethodInfo
    ResolveExpanderRowMethod "getRootWindow" o = Gtk.Widget.WidgetGetRootWindowMethodInfo
    ResolveExpanderRowMethod "getScaleFactor" o = Gtk.Widget.WidgetGetScaleFactorMethodInfo
    ResolveExpanderRowMethod "getScreen" o = Gtk.Widget.WidgetGetScreenMethodInfo
    ResolveExpanderRowMethod "getSelectable" o = Gtk.ListBoxRow.ListBoxRowGetSelectableMethodInfo
    ResolveExpanderRowMethod "getSensitive" o = Gtk.Widget.WidgetGetSensitiveMethodInfo
    ResolveExpanderRowMethod "getSettings" o = Gtk.Widget.WidgetGetSettingsMethodInfo
    ResolveExpanderRowMethod "getShowEnableSwitch" o = ExpanderRowGetShowEnableSwitchMethodInfo
    ResolveExpanderRowMethod "getSizeRequest" o = Gtk.Widget.WidgetGetSizeRequestMethodInfo
    ResolveExpanderRowMethod "getState" o = Gtk.Widget.WidgetGetStateMethodInfo
    ResolveExpanderRowMethod "getStateFlags" o = Gtk.Widget.WidgetGetStateFlagsMethodInfo
    ResolveExpanderRowMethod "getStyle" o = Gtk.Widget.WidgetGetStyleMethodInfo
    ResolveExpanderRowMethod "getStyleContext" o = Gtk.Widget.WidgetGetStyleContextMethodInfo
    ResolveExpanderRowMethod "getSubtitle" o = Handy.ActionRow.ActionRowGetSubtitleMethodInfo
    ResolveExpanderRowMethod "getSupportMultidevice" o = Gtk.Widget.WidgetGetSupportMultideviceMethodInfo
    ResolveExpanderRowMethod "getTemplateChild" o = Gtk.Widget.WidgetGetTemplateChildMethodInfo
    ResolveExpanderRowMethod "getTitle" o = Handy.ActionRow.ActionRowGetTitleMethodInfo
    ResolveExpanderRowMethod "getTooltipMarkup" o = Gtk.Widget.WidgetGetTooltipMarkupMethodInfo
    ResolveExpanderRowMethod "getTooltipText" o = Gtk.Widget.WidgetGetTooltipTextMethodInfo
    ResolveExpanderRowMethod "getTooltipWindow" o = Gtk.Widget.WidgetGetTooltipWindowMethodInfo
    ResolveExpanderRowMethod "getToplevel" o = Gtk.Widget.WidgetGetToplevelMethodInfo
    ResolveExpanderRowMethod "getUseUnderline" o = Handy.ActionRow.ActionRowGetUseUnderlineMethodInfo
    ResolveExpanderRowMethod "getValign" o = Gtk.Widget.WidgetGetValignMethodInfo
    ResolveExpanderRowMethod "getValignWithBaseline" o = Gtk.Widget.WidgetGetValignWithBaselineMethodInfo
    ResolveExpanderRowMethod "getVexpand" o = Gtk.Widget.WidgetGetVexpandMethodInfo
    ResolveExpanderRowMethod "getVexpandSet" o = Gtk.Widget.WidgetGetVexpandSetMethodInfo
    ResolveExpanderRowMethod "getVisible" o = Gtk.Widget.WidgetGetVisibleMethodInfo
    ResolveExpanderRowMethod "getVisual" o = Gtk.Widget.WidgetGetVisualMethodInfo
    ResolveExpanderRowMethod "getWindow" o = Gtk.Widget.WidgetGetWindowMethodInfo
    ResolveExpanderRowMethod "setAccelPath" o = Gtk.Widget.WidgetSetAccelPathMethodInfo
    ResolveExpanderRowMethod "setActionName" o = Gtk.Actionable.ActionableSetActionNameMethodInfo
    ResolveExpanderRowMethod "setActionTargetValue" o = Gtk.Actionable.ActionableSetActionTargetValueMethodInfo
    ResolveExpanderRowMethod "setActivatable" o = Gtk.ListBoxRow.ListBoxRowSetActivatableMethodInfo
    ResolveExpanderRowMethod "setActivatableWidget" o = Handy.ActionRow.ActionRowSetActivatableWidgetMethodInfo
    ResolveExpanderRowMethod "setAllocation" o = Gtk.Widget.WidgetSetAllocationMethodInfo
    ResolveExpanderRowMethod "setAppPaintable" o = Gtk.Widget.WidgetSetAppPaintableMethodInfo
    ResolveExpanderRowMethod "setBorderWidth" o = Gtk.Container.ContainerSetBorderWidthMethodInfo
    ResolveExpanderRowMethod "setBuildableProperty" o = Gtk.Buildable.BuildableSetBuildablePropertyMethodInfo
    ResolveExpanderRowMethod "setCanDefault" o = Gtk.Widget.WidgetSetCanDefaultMethodInfo
    ResolveExpanderRowMethod "setCanFocus" o = Gtk.Widget.WidgetSetCanFocusMethodInfo
    ResolveExpanderRowMethod "setChildVisible" o = Gtk.Widget.WidgetSetChildVisibleMethodInfo
    ResolveExpanderRowMethod "setClip" o = Gtk.Widget.WidgetSetClipMethodInfo
    ResolveExpanderRowMethod "setCompositeName" o = Gtk.Widget.WidgetSetCompositeNameMethodInfo
    ResolveExpanderRowMethod "setData" o = GObject.Object.ObjectSetDataMethodInfo
    ResolveExpanderRowMethod "setDetailedActionName" o = Gtk.Actionable.ActionableSetDetailedActionNameMethodInfo
    ResolveExpanderRowMethod "setDeviceEnabled" o = Gtk.Widget.WidgetSetDeviceEnabledMethodInfo
    ResolveExpanderRowMethod "setDeviceEvents" o = Gtk.Widget.WidgetSetDeviceEventsMethodInfo
    ResolveExpanderRowMethod "setDirection" o = Gtk.Widget.WidgetSetDirectionMethodInfo
    ResolveExpanderRowMethod "setDoubleBuffered" o = Gtk.Widget.WidgetSetDoubleBufferedMethodInfo
    ResolveExpanderRowMethod "setEnableExpansion" o = ExpanderRowSetEnableExpansionMethodInfo
    ResolveExpanderRowMethod "setEvents" o = Gtk.Widget.WidgetSetEventsMethodInfo
    ResolveExpanderRowMethod "setExpanded" o = ExpanderRowSetExpandedMethodInfo
    ResolveExpanderRowMethod "setFocusChain" o = Gtk.Container.ContainerSetFocusChainMethodInfo
    ResolveExpanderRowMethod "setFocusChild" o = Gtk.Container.ContainerSetFocusChildMethodInfo
    ResolveExpanderRowMethod "setFocusHadjustment" o = Gtk.Container.ContainerSetFocusHadjustmentMethodInfo
    ResolveExpanderRowMethod "setFocusOnClick" o = Gtk.Widget.WidgetSetFocusOnClickMethodInfo
    ResolveExpanderRowMethod "setFocusVadjustment" o = Gtk.Container.ContainerSetFocusVadjustmentMethodInfo
    ResolveExpanderRowMethod "setFontMap" o = Gtk.Widget.WidgetSetFontMapMethodInfo
    ResolveExpanderRowMethod "setFontOptions" o = Gtk.Widget.WidgetSetFontOptionsMethodInfo
    ResolveExpanderRowMethod "setHalign" o = Gtk.Widget.WidgetSetHalignMethodInfo
    ResolveExpanderRowMethod "setHasTooltip" o = Gtk.Widget.WidgetSetHasTooltipMethodInfo
    ResolveExpanderRowMethod "setHasWindow" o = Gtk.Widget.WidgetSetHasWindowMethodInfo
    ResolveExpanderRowMethod "setHeader" o = Gtk.ListBoxRow.ListBoxRowSetHeaderMethodInfo
    ResolveExpanderRowMethod "setHexpand" o = Gtk.Widget.WidgetSetHexpandMethodInfo
    ResolveExpanderRowMethod "setHexpandSet" o = Gtk.Widget.WidgetSetHexpandSetMethodInfo
    ResolveExpanderRowMethod "setIconName" o = Handy.ActionRow.ActionRowSetIconNameMethodInfo
    ResolveExpanderRowMethod "setMapped" o = Gtk.Widget.WidgetSetMappedMethodInfo
    ResolveExpanderRowMethod "setMarginBottom" o = Gtk.Widget.WidgetSetMarginBottomMethodInfo
    ResolveExpanderRowMethod "setMarginEnd" o = Gtk.Widget.WidgetSetMarginEndMethodInfo
    ResolveExpanderRowMethod "setMarginLeft" o = Gtk.Widget.WidgetSetMarginLeftMethodInfo
    ResolveExpanderRowMethod "setMarginRight" o = Gtk.Widget.WidgetSetMarginRightMethodInfo
    ResolveExpanderRowMethod "setMarginStart" o = Gtk.Widget.WidgetSetMarginStartMethodInfo
    ResolveExpanderRowMethod "setMarginTop" o = Gtk.Widget.WidgetSetMarginTopMethodInfo
    ResolveExpanderRowMethod "setName" o = Gtk.Widget.WidgetSetNameMethodInfo
    ResolveExpanderRowMethod "setNoShowAll" o = Gtk.Widget.WidgetSetNoShowAllMethodInfo
    ResolveExpanderRowMethod "setOpacity" o = Gtk.Widget.WidgetSetOpacityMethodInfo
    ResolveExpanderRowMethod "setParent" o = Gtk.Widget.WidgetSetParentMethodInfo
    ResolveExpanderRowMethod "setParentWindow" o = Gtk.Widget.WidgetSetParentWindowMethodInfo
    ResolveExpanderRowMethod "setProperty" o = GObject.Object.ObjectSetPropertyMethodInfo
    ResolveExpanderRowMethod "setRealized" o = Gtk.Widget.WidgetSetRealizedMethodInfo
    ResolveExpanderRowMethod "setReallocateRedraws" o = Gtk.Container.ContainerSetReallocateRedrawsMethodInfo
    ResolveExpanderRowMethod "setReceivesDefault" o = Gtk.Widget.WidgetSetReceivesDefaultMethodInfo
    ResolveExpanderRowMethod "setRedrawOnAllocate" o = Gtk.Widget.WidgetSetRedrawOnAllocateMethodInfo
    ResolveExpanderRowMethod "setResizeMode" o = Gtk.Container.ContainerSetResizeModeMethodInfo
    ResolveExpanderRowMethod "setSelectable" o = Gtk.ListBoxRow.ListBoxRowSetSelectableMethodInfo
    ResolveExpanderRowMethod "setSensitive" o = Gtk.Widget.WidgetSetSensitiveMethodInfo
    ResolveExpanderRowMethod "setShowEnableSwitch" o = ExpanderRowSetShowEnableSwitchMethodInfo
    ResolveExpanderRowMethod "setSizeRequest" o = Gtk.Widget.WidgetSetSizeRequestMethodInfo
    ResolveExpanderRowMethod "setState" o = Gtk.Widget.WidgetSetStateMethodInfo
    ResolveExpanderRowMethod "setStateFlags" o = Gtk.Widget.WidgetSetStateFlagsMethodInfo
    ResolveExpanderRowMethod "setStyle" o = Gtk.Widget.WidgetSetStyleMethodInfo
    ResolveExpanderRowMethod "setSubtitle" o = Handy.ActionRow.ActionRowSetSubtitleMethodInfo
    ResolveExpanderRowMethod "setSupportMultidevice" o = Gtk.Widget.WidgetSetSupportMultideviceMethodInfo
    ResolveExpanderRowMethod "setTitle" o = Handy.ActionRow.ActionRowSetTitleMethodInfo
    ResolveExpanderRowMethod "setTooltipMarkup" o = Gtk.Widget.WidgetSetTooltipMarkupMethodInfo
    ResolveExpanderRowMethod "setTooltipText" o = Gtk.Widget.WidgetSetTooltipTextMethodInfo
    ResolveExpanderRowMethod "setTooltipWindow" o = Gtk.Widget.WidgetSetTooltipWindowMethodInfo
    ResolveExpanderRowMethod "setUseUnderline" o = Handy.ActionRow.ActionRowSetUseUnderlineMethodInfo
    ResolveExpanderRowMethod "setValign" o = Gtk.Widget.WidgetSetValignMethodInfo
    ResolveExpanderRowMethod "setVexpand" o = Gtk.Widget.WidgetSetVexpandMethodInfo
    ResolveExpanderRowMethod "setVexpandSet" o = Gtk.Widget.WidgetSetVexpandSetMethodInfo
    ResolveExpanderRowMethod "setVisible" o = Gtk.Widget.WidgetSetVisibleMethodInfo
    ResolveExpanderRowMethod "setVisual" o = Gtk.Widget.WidgetSetVisualMethodInfo
    ResolveExpanderRowMethod "setWindow" o = Gtk.Widget.WidgetSetWindowMethodInfo
    ResolveExpanderRowMethod l o = O.MethodResolutionFailed l o

instance (info ~ ResolveExpanderRowMethod t ExpanderRow, O.MethodInfo info ExpanderRow p) => OL.IsLabel t (ExpanderRow -> p) where
#if MIN_VERSION_base(4,10,0)
    fromLabel = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#else
    fromLabel _ = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#endif

#endif

-- VVV Prop "enable-expansion"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable]
   -- Nullable: (Just False,Just False)

{- |
Get the value of the “@enable-expansion@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' expanderRow #enableExpansion
@
-}
getExpanderRowEnableExpansion :: (MonadIO m, IsExpanderRow o) => o -> m Bool
getExpanderRowEnableExpansion obj = liftIO $ B.Properties.getObjectPropertyBool obj "enable-expansion"

{- |
Set the value of the “@enable-expansion@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' expanderRow [ #enableExpansion 'Data.GI.Base.Attributes.:=' value ]
@
-}
setExpanderRowEnableExpansion :: (MonadIO m, IsExpanderRow o) => o -> Bool -> m ()
setExpanderRowEnableExpansion obj val = liftIO $ B.Properties.setObjectPropertyBool obj "enable-expansion" val

{- |
Construct a `GValueConstruct` with valid value for the “@enable-expansion@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructExpanderRowEnableExpansion :: (IsExpanderRow o) => Bool -> IO (GValueConstruct o)
constructExpanderRowEnableExpansion val = B.Properties.constructObjectPropertyBool "enable-expansion" val

#if ENABLE_OVERLOADING
data ExpanderRowEnableExpansionPropertyInfo
instance AttrInfo ExpanderRowEnableExpansionPropertyInfo where
    type AttrAllowedOps ExpanderRowEnableExpansionPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint ExpanderRowEnableExpansionPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint ExpanderRowEnableExpansionPropertyInfo = IsExpanderRow
    type AttrGetType ExpanderRowEnableExpansionPropertyInfo = Bool
    type AttrLabel ExpanderRowEnableExpansionPropertyInfo = "enable-expansion"
    type AttrOrigin ExpanderRowEnableExpansionPropertyInfo = ExpanderRow
    attrGet _ = getExpanderRowEnableExpansion
    attrSet _ = setExpanderRowEnableExpansion
    attrConstruct _ = constructExpanderRowEnableExpansion
    attrClear _ = undefined
#endif

-- VVV Prop "expanded"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable]
   -- Nullable: (Just False,Just False)

{- |
Get the value of the “@expanded@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' expanderRow #expanded
@
-}
getExpanderRowExpanded :: (MonadIO m, IsExpanderRow o) => o -> m Bool
getExpanderRowExpanded obj = liftIO $ B.Properties.getObjectPropertyBool obj "expanded"

{- |
Set the value of the “@expanded@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' expanderRow [ #expanded 'Data.GI.Base.Attributes.:=' value ]
@
-}
setExpanderRowExpanded :: (MonadIO m, IsExpanderRow o) => o -> Bool -> m ()
setExpanderRowExpanded obj val = liftIO $ B.Properties.setObjectPropertyBool obj "expanded" val

{- |
Construct a `GValueConstruct` with valid value for the “@expanded@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructExpanderRowExpanded :: (IsExpanderRow o) => Bool -> IO (GValueConstruct o)
constructExpanderRowExpanded val = B.Properties.constructObjectPropertyBool "expanded" val

#if ENABLE_OVERLOADING
data ExpanderRowExpandedPropertyInfo
instance AttrInfo ExpanderRowExpandedPropertyInfo where
    type AttrAllowedOps ExpanderRowExpandedPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint ExpanderRowExpandedPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint ExpanderRowExpandedPropertyInfo = IsExpanderRow
    type AttrGetType ExpanderRowExpandedPropertyInfo = Bool
    type AttrLabel ExpanderRowExpandedPropertyInfo = "expanded"
    type AttrOrigin ExpanderRowExpandedPropertyInfo = ExpanderRow
    attrGet _ = getExpanderRowExpanded
    attrSet _ = setExpanderRowExpanded
    attrConstruct _ = constructExpanderRowExpanded
    attrClear _ = undefined
#endif

-- VVV Prop "show-enable-switch"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable]
   -- Nullable: (Just False,Just False)

{- |
Get the value of the “@show-enable-switch@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' expanderRow #showEnableSwitch
@
-}
getExpanderRowShowEnableSwitch :: (MonadIO m, IsExpanderRow o) => o -> m Bool
getExpanderRowShowEnableSwitch obj = liftIO $ B.Properties.getObjectPropertyBool obj "show-enable-switch"

{- |
Set the value of the “@show-enable-switch@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' expanderRow [ #showEnableSwitch 'Data.GI.Base.Attributes.:=' value ]
@
-}
setExpanderRowShowEnableSwitch :: (MonadIO m, IsExpanderRow o) => o -> Bool -> m ()
setExpanderRowShowEnableSwitch obj val = liftIO $ B.Properties.setObjectPropertyBool obj "show-enable-switch" val

{- |
Construct a `GValueConstruct` with valid value for the “@show-enable-switch@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructExpanderRowShowEnableSwitch :: (IsExpanderRow o) => Bool -> IO (GValueConstruct o)
constructExpanderRowShowEnableSwitch val = B.Properties.constructObjectPropertyBool "show-enable-switch" val

#if ENABLE_OVERLOADING
data ExpanderRowShowEnableSwitchPropertyInfo
instance AttrInfo ExpanderRowShowEnableSwitchPropertyInfo where
    type AttrAllowedOps ExpanderRowShowEnableSwitchPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint ExpanderRowShowEnableSwitchPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint ExpanderRowShowEnableSwitchPropertyInfo = IsExpanderRow
    type AttrGetType ExpanderRowShowEnableSwitchPropertyInfo = Bool
    type AttrLabel ExpanderRowShowEnableSwitchPropertyInfo = "show-enable-switch"
    type AttrOrigin ExpanderRowShowEnableSwitchPropertyInfo = ExpanderRow
    attrGet _ = getExpanderRowShowEnableSwitch
    attrSet _ = setExpanderRowShowEnableSwitch
    attrConstruct _ = constructExpanderRowShowEnableSwitch
    attrClear _ = undefined
#endif

#if ENABLE_OVERLOADING
instance O.HasAttributeList ExpanderRow
type instance O.AttributeList ExpanderRow = ExpanderRowAttributeList
type ExpanderRowAttributeList = ('[ '("actionName", Gtk.Actionable.ActionableActionNamePropertyInfo), '("actionTarget", Gtk.Actionable.ActionableActionTargetPropertyInfo), '("activatable", Gtk.ListBoxRow.ListBoxRowActivatablePropertyInfo), '("activatableWidget", Handy.ActionRow.ActionRowActivatableWidgetPropertyInfo), '("appPaintable", Gtk.Widget.WidgetAppPaintablePropertyInfo), '("borderWidth", Gtk.Container.ContainerBorderWidthPropertyInfo), '("canDefault", Gtk.Widget.WidgetCanDefaultPropertyInfo), '("canFocus", Gtk.Widget.WidgetCanFocusPropertyInfo), '("child", Gtk.Container.ContainerChildPropertyInfo), '("compositeChild", Gtk.Widget.WidgetCompositeChildPropertyInfo), '("doubleBuffered", Gtk.Widget.WidgetDoubleBufferedPropertyInfo), '("enableExpansion", ExpanderRowEnableExpansionPropertyInfo), '("events", Gtk.Widget.WidgetEventsPropertyInfo), '("expand", Gtk.Widget.WidgetExpandPropertyInfo), '("expanded", ExpanderRowExpandedPropertyInfo), '("focusOnClick", Gtk.Widget.WidgetFocusOnClickPropertyInfo), '("halign", Gtk.Widget.WidgetHalignPropertyInfo), '("hasDefault", Gtk.Widget.WidgetHasDefaultPropertyInfo), '("hasFocus", Gtk.Widget.WidgetHasFocusPropertyInfo), '("hasTooltip", Gtk.Widget.WidgetHasTooltipPropertyInfo), '("heightRequest", Gtk.Widget.WidgetHeightRequestPropertyInfo), '("hexpand", Gtk.Widget.WidgetHexpandPropertyInfo), '("hexpandSet", Gtk.Widget.WidgetHexpandSetPropertyInfo), '("iconName", Handy.ActionRow.ActionRowIconNamePropertyInfo), '("isFocus", Gtk.Widget.WidgetIsFocusPropertyInfo), '("margin", Gtk.Widget.WidgetMarginPropertyInfo), '("marginBottom", Gtk.Widget.WidgetMarginBottomPropertyInfo), '("marginEnd", Gtk.Widget.WidgetMarginEndPropertyInfo), '("marginLeft", Gtk.Widget.WidgetMarginLeftPropertyInfo), '("marginRight", Gtk.Widget.WidgetMarginRightPropertyInfo), '("marginStart", Gtk.Widget.WidgetMarginStartPropertyInfo), '("marginTop", Gtk.Widget.WidgetMarginTopPropertyInfo), '("name", Gtk.Widget.WidgetNamePropertyInfo), '("noShowAll", Gtk.Widget.WidgetNoShowAllPropertyInfo), '("opacity", Gtk.Widget.WidgetOpacityPropertyInfo), '("parent", Gtk.Widget.WidgetParentPropertyInfo), '("receivesDefault", Gtk.Widget.WidgetReceivesDefaultPropertyInfo), '("resizeMode", Gtk.Container.ContainerResizeModePropertyInfo), '("scaleFactor", Gtk.Widget.WidgetScaleFactorPropertyInfo), '("selectable", Gtk.ListBoxRow.ListBoxRowSelectablePropertyInfo), '("sensitive", Gtk.Widget.WidgetSensitivePropertyInfo), '("showEnableSwitch", ExpanderRowShowEnableSwitchPropertyInfo), '("style", Gtk.Widget.WidgetStylePropertyInfo), '("subtitle", Handy.ActionRow.ActionRowSubtitlePropertyInfo), '("title", Handy.ActionRow.ActionRowTitlePropertyInfo), '("tooltipMarkup", Gtk.Widget.WidgetTooltipMarkupPropertyInfo), '("tooltipText", Gtk.Widget.WidgetTooltipTextPropertyInfo), '("useUnderline", Handy.ActionRow.ActionRowUseUnderlinePropertyInfo), '("valign", Gtk.Widget.WidgetValignPropertyInfo), '("vexpand", Gtk.Widget.WidgetVexpandPropertyInfo), '("vexpandSet", Gtk.Widget.WidgetVexpandSetPropertyInfo), '("visible", Gtk.Widget.WidgetVisiblePropertyInfo), '("widthRequest", Gtk.Widget.WidgetWidthRequestPropertyInfo), '("window", Gtk.Widget.WidgetWindowPropertyInfo)] :: [(Symbol, *)])
#endif

#if ENABLE_OVERLOADING
expanderRowEnableExpansion :: AttrLabelProxy "enableExpansion"
expanderRowEnableExpansion = AttrLabelProxy

expanderRowExpanded :: AttrLabelProxy "expanded"
expanderRowExpanded = AttrLabelProxy

expanderRowShowEnableSwitch :: AttrLabelProxy "showEnableSwitch"
expanderRowShowEnableSwitch = AttrLabelProxy

#endif

#if ENABLE_OVERLOADING
type instance O.SignalList ExpanderRow = ExpanderRowSignalList
type ExpanderRowSignalList = ('[ '("accelClosuresChanged", Gtk.Widget.WidgetAccelClosuresChangedSignalInfo), '("activate", Gtk.ListBoxRow.ListBoxRowActivateSignalInfo), '("add", Gtk.Container.ContainerAddSignalInfo), '("buttonPressEvent", Gtk.Widget.WidgetButtonPressEventSignalInfo), '("buttonReleaseEvent", Gtk.Widget.WidgetButtonReleaseEventSignalInfo), '("canActivateAccel", Gtk.Widget.WidgetCanActivateAccelSignalInfo), '("checkResize", Gtk.Container.ContainerCheckResizeSignalInfo), '("childNotify", Gtk.Widget.WidgetChildNotifySignalInfo), '("compositedChanged", Gtk.Widget.WidgetCompositedChangedSignalInfo), '("configureEvent", Gtk.Widget.WidgetConfigureEventSignalInfo), '("damageEvent", Gtk.Widget.WidgetDamageEventSignalInfo), '("deleteEvent", Gtk.Widget.WidgetDeleteEventSignalInfo), '("destroy", Gtk.Widget.WidgetDestroySignalInfo), '("destroyEvent", Gtk.Widget.WidgetDestroyEventSignalInfo), '("directionChanged", Gtk.Widget.WidgetDirectionChangedSignalInfo), '("dragBegin", Gtk.Widget.WidgetDragBeginSignalInfo), '("dragDataDelete", Gtk.Widget.WidgetDragDataDeleteSignalInfo), '("dragDataGet", Gtk.Widget.WidgetDragDataGetSignalInfo), '("dragDataReceived", Gtk.Widget.WidgetDragDataReceivedSignalInfo), '("dragDrop", Gtk.Widget.WidgetDragDropSignalInfo), '("dragEnd", Gtk.Widget.WidgetDragEndSignalInfo), '("dragFailed", Gtk.Widget.WidgetDragFailedSignalInfo), '("dragLeave", Gtk.Widget.WidgetDragLeaveSignalInfo), '("dragMotion", Gtk.Widget.WidgetDragMotionSignalInfo), '("draw", Gtk.Widget.WidgetDrawSignalInfo), '("enterNotifyEvent", Gtk.Widget.WidgetEnterNotifyEventSignalInfo), '("event", Gtk.Widget.WidgetEventSignalInfo), '("eventAfter", Gtk.Widget.WidgetEventAfterSignalInfo), '("focus", Gtk.Widget.WidgetFocusSignalInfo), '("focusInEvent", Gtk.Widget.WidgetFocusInEventSignalInfo), '("focusOutEvent", Gtk.Widget.WidgetFocusOutEventSignalInfo), '("grabBrokenEvent", Gtk.Widget.WidgetGrabBrokenEventSignalInfo), '("grabFocus", Gtk.Widget.WidgetGrabFocusSignalInfo), '("grabNotify", Gtk.Widget.WidgetGrabNotifySignalInfo), '("hide", Gtk.Widget.WidgetHideSignalInfo), '("hierarchyChanged", Gtk.Widget.WidgetHierarchyChangedSignalInfo), '("keyPressEvent", Gtk.Widget.WidgetKeyPressEventSignalInfo), '("keyReleaseEvent", Gtk.Widget.WidgetKeyReleaseEventSignalInfo), '("keynavFailed", Gtk.Widget.WidgetKeynavFailedSignalInfo), '("leaveNotifyEvent", Gtk.Widget.WidgetLeaveNotifyEventSignalInfo), '("map", Gtk.Widget.WidgetMapSignalInfo), '("mapEvent", Gtk.Widget.WidgetMapEventSignalInfo), '("mnemonicActivate", Gtk.Widget.WidgetMnemonicActivateSignalInfo), '("motionNotifyEvent", Gtk.Widget.WidgetMotionNotifyEventSignalInfo), '("moveFocus", Gtk.Widget.WidgetMoveFocusSignalInfo), '("notify", GObject.Object.ObjectNotifySignalInfo), '("parentSet", Gtk.Widget.WidgetParentSetSignalInfo), '("popupMenu", Gtk.Widget.WidgetPopupMenuSignalInfo), '("propertyNotifyEvent", Gtk.Widget.WidgetPropertyNotifyEventSignalInfo), '("proximityInEvent", Gtk.Widget.WidgetProximityInEventSignalInfo), '("proximityOutEvent", Gtk.Widget.WidgetProximityOutEventSignalInfo), '("queryTooltip", Gtk.Widget.WidgetQueryTooltipSignalInfo), '("realize", Gtk.Widget.WidgetRealizeSignalInfo), '("remove", Gtk.Container.ContainerRemoveSignalInfo), '("screenChanged", Gtk.Widget.WidgetScreenChangedSignalInfo), '("scrollEvent", Gtk.Widget.WidgetScrollEventSignalInfo), '("selectionClearEvent", Gtk.Widget.WidgetSelectionClearEventSignalInfo), '("selectionGet", Gtk.Widget.WidgetSelectionGetSignalInfo), '("selectionNotifyEvent", Gtk.Widget.WidgetSelectionNotifyEventSignalInfo), '("selectionReceived", Gtk.Widget.WidgetSelectionReceivedSignalInfo), '("selectionRequestEvent", Gtk.Widget.WidgetSelectionRequestEventSignalInfo), '("setFocusChild", Gtk.Container.ContainerSetFocusChildSignalInfo), '("show", Gtk.Widget.WidgetShowSignalInfo), '("showHelp", Gtk.Widget.WidgetShowHelpSignalInfo), '("sizeAllocate", Gtk.Widget.WidgetSizeAllocateSignalInfo), '("stateChanged", Gtk.Widget.WidgetStateChangedSignalInfo), '("stateFlagsChanged", Gtk.Widget.WidgetStateFlagsChangedSignalInfo), '("styleSet", Gtk.Widget.WidgetStyleSetSignalInfo), '("styleUpdated", Gtk.Widget.WidgetStyleUpdatedSignalInfo), '("touchEvent", Gtk.Widget.WidgetTouchEventSignalInfo), '("unmap", Gtk.Widget.WidgetUnmapSignalInfo), '("unmapEvent", Gtk.Widget.WidgetUnmapEventSignalInfo), '("unrealize", Gtk.Widget.WidgetUnrealizeSignalInfo), '("visibilityNotifyEvent", Gtk.Widget.WidgetVisibilityNotifyEventSignalInfo), '("windowStateEvent", Gtk.Widget.WidgetWindowStateEventSignalInfo)] :: [(Symbol, *)])

#endif

-- method ExpanderRow::new
-- method type : Constructor
-- Args : []
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "Handy", name = "ExpanderRow"}))
-- throws : False
-- Skip return : False

foreign import ccall "hdy_expander_row_new" hdy_expander_row_new :: 
    IO (Ptr ExpanderRow)

{- |
Creates a new 'GI.Handy.Objects.ExpanderRow.ExpanderRow'.

/Since: 0.0.6/
-}
expanderRowNew ::
    (B.CallStack.HasCallStack, MonadIO m) =>
    m ExpanderRow
    {- ^ __Returns:__ a new 'GI.Handy.Objects.ExpanderRow.ExpanderRow' -}
expanderRowNew  = liftIO $ do
    result <- hdy_expander_row_new
    checkUnexpectedReturnNULL "expanderRowNew" result
    result' <- (newObject ExpanderRow) result
    return result'

#if ENABLE_OVERLOADING
#endif

-- method ExpanderRow::get_enable_expansion
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "Handy", name = "ExpanderRow"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #HdyExpanderRow", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TBoolean)
-- throws : False
-- Skip return : False

foreign import ccall "hdy_expander_row_get_enable_expansion" hdy_expander_row_get_enable_expansion :: 
    Ptr ExpanderRow ->                      -- self : TInterface (Name {namespace = "Handy", name = "ExpanderRow"})
    IO CInt

{- |
Gets whether the expansion of /@self@/ is enabled.

/Since: 0.0.6/
-}
expanderRowGetEnableExpansion ::
    (B.CallStack.HasCallStack, MonadIO m, IsExpanderRow a) =>
    a
    {- ^ /@self@/: a 'GI.Handy.Objects.ExpanderRow.ExpanderRow' -}
    -> m Bool
    {- ^ __Returns:__ whether the expansion of /@self@/ is enabled. -}
expanderRowGetEnableExpansion self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- hdy_expander_row_get_enable_expansion self'
    let result' = (/= 0) result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data ExpanderRowGetEnableExpansionMethodInfo
instance (signature ~ (m Bool), MonadIO m, IsExpanderRow a) => O.MethodInfo ExpanderRowGetEnableExpansionMethodInfo a signature where
    overloadedMethod _ = expanderRowGetEnableExpansion

#endif

-- method ExpanderRow::get_expanded
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "Handy", name = "ExpanderRow"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Nothing, sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TBoolean)
-- throws : False
-- Skip return : False

foreign import ccall "hdy_expander_row_get_expanded" hdy_expander_row_get_expanded :: 
    Ptr ExpanderRow ->                      -- self : TInterface (Name {namespace = "Handy", name = "ExpanderRow"})
    IO CInt

{- |
/No description available in the introspection data./
-}
expanderRowGetExpanded ::
    (B.CallStack.HasCallStack, MonadIO m, IsExpanderRow a) =>
    a
    -> m Bool
expanderRowGetExpanded self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- hdy_expander_row_get_expanded self'
    let result' = (/= 0) result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data ExpanderRowGetExpandedMethodInfo
instance (signature ~ (m Bool), MonadIO m, IsExpanderRow a) => O.MethodInfo ExpanderRowGetExpandedMethodInfo a signature where
    overloadedMethod _ = expanderRowGetExpanded

#endif

-- method ExpanderRow::get_show_enable_switch
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "Handy", name = "ExpanderRow"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #HdyExpanderRow", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TBoolean)
-- throws : False
-- Skip return : False

foreign import ccall "hdy_expander_row_get_show_enable_switch" hdy_expander_row_get_show_enable_switch :: 
    Ptr ExpanderRow ->                      -- self : TInterface (Name {namespace = "Handy", name = "ExpanderRow"})
    IO CInt

{- |
Gets whether the switch enabling the expansion of /@self@/ is visible.

/Since: 0.0.6/
-}
expanderRowGetShowEnableSwitch ::
    (B.CallStack.HasCallStack, MonadIO m, IsExpanderRow a) =>
    a
    {- ^ /@self@/: a 'GI.Handy.Objects.ExpanderRow.ExpanderRow' -}
    -> m Bool
    {- ^ __Returns:__ whether the switch enabling the expansion of /@self@/ is visible. -}
expanderRowGetShowEnableSwitch self = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    result <- hdy_expander_row_get_show_enable_switch self'
    let result' = (/= 0) result
    touchManagedPtr self
    return result'

#if ENABLE_OVERLOADING
data ExpanderRowGetShowEnableSwitchMethodInfo
instance (signature ~ (m Bool), MonadIO m, IsExpanderRow a) => O.MethodInfo ExpanderRowGetShowEnableSwitchMethodInfo a signature where
    overloadedMethod _ = expanderRowGetShowEnableSwitch

#endif

-- method ExpanderRow::set_enable_expansion
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "Handy", name = "ExpanderRow"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #HdyExpanderRow", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "enable_expansion", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "%TRUE to enable the expansion", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "hdy_expander_row_set_enable_expansion" hdy_expander_row_set_enable_expansion :: 
    Ptr ExpanderRow ->                      -- self : TInterface (Name {namespace = "Handy", name = "ExpanderRow"})
    CInt ->                                 -- enable_expansion : TBasicType TBoolean
    IO ()

{- |
Sets whether the expansion of /@self@/ is enabled.

/Since: 0.0.6/
-}
expanderRowSetEnableExpansion ::
    (B.CallStack.HasCallStack, MonadIO m, IsExpanderRow a) =>
    a
    {- ^ /@self@/: a 'GI.Handy.Objects.ExpanderRow.ExpanderRow' -}
    -> Bool
    {- ^ /@enableExpansion@/: 'True' to enable the expansion -}
    -> m ()
expanderRowSetEnableExpansion self enableExpansion = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    let enableExpansion' = (fromIntegral . fromEnum) enableExpansion
    hdy_expander_row_set_enable_expansion self' enableExpansion'
    touchManagedPtr self
    return ()

#if ENABLE_OVERLOADING
data ExpanderRowSetEnableExpansionMethodInfo
instance (signature ~ (Bool -> m ()), MonadIO m, IsExpanderRow a) => O.MethodInfo ExpanderRowSetEnableExpansionMethodInfo a signature where
    overloadedMethod _ = expanderRowSetEnableExpansion

#endif

-- method ExpanderRow::set_expanded
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "Handy", name = "ExpanderRow"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Nothing, sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "expanded", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Nothing, sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "hdy_expander_row_set_expanded" hdy_expander_row_set_expanded :: 
    Ptr ExpanderRow ->                      -- self : TInterface (Name {namespace = "Handy", name = "ExpanderRow"})
    CInt ->                                 -- expanded : TBasicType TBoolean
    IO ()

{- |
/No description available in the introspection data./
-}
expanderRowSetExpanded ::
    (B.CallStack.HasCallStack, MonadIO m, IsExpanderRow a) =>
    a
    -> Bool
    -> m ()
expanderRowSetExpanded self expanded = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    let expanded' = (fromIntegral . fromEnum) expanded
    hdy_expander_row_set_expanded self' expanded'
    touchManagedPtr self
    return ()

#if ENABLE_OVERLOADING
data ExpanderRowSetExpandedMethodInfo
instance (signature ~ (Bool -> m ()), MonadIO m, IsExpanderRow a) => O.MethodInfo ExpanderRowSetExpandedMethodInfo a signature where
    overloadedMethod _ = expanderRowSetExpanded

#endif

-- method ExpanderRow::set_show_enable_switch
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "self", argType = TInterface (Name {namespace = "Handy", name = "ExpanderRow"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #HdyExpanderRow", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "show_enable_switch", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "%TRUE to show the switch enabling the expansion", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "hdy_expander_row_set_show_enable_switch" hdy_expander_row_set_show_enable_switch :: 
    Ptr ExpanderRow ->                      -- self : TInterface (Name {namespace = "Handy", name = "ExpanderRow"})
    CInt ->                                 -- show_enable_switch : TBasicType TBoolean
    IO ()

{- |
Sets whether the switch enabling the expansion of /@self@/ is visible.

/Since: 0.0.6/
-}
expanderRowSetShowEnableSwitch ::
    (B.CallStack.HasCallStack, MonadIO m, IsExpanderRow a) =>
    a
    {- ^ /@self@/: a 'GI.Handy.Objects.ExpanderRow.ExpanderRow' -}
    -> Bool
    {- ^ /@showEnableSwitch@/: 'True' to show the switch enabling the expansion -}
    -> m ()
expanderRowSetShowEnableSwitch self showEnableSwitch = liftIO $ do
    self' <- unsafeManagedPtrCastPtr self
    let showEnableSwitch' = (fromIntegral . fromEnum) showEnableSwitch
    hdy_expander_row_set_show_enable_switch self' showEnableSwitch'
    touchManagedPtr self
    return ()

#if ENABLE_OVERLOADING
data ExpanderRowSetShowEnableSwitchMethodInfo
instance (signature ~ (Bool -> m ()), MonadIO m, IsExpanderRow a) => O.MethodInfo ExpanderRowSetShowEnableSwitchMethodInfo a signature where
    overloadedMethod _ = expanderRowSetShowEnableSwitch

#endif


